<?php 

defined('_JEXEC') or die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

/**
 *  Virtuemart PayPal Checkout SSC
 *  Online Store Copyright 2022
 *  This code is copyright of online-store.co.uk
 *  You are not allowed to distribute or sell this code.
 *  https://plugins.online-store.co.uk/
*/


if (!class_exists('VmConfig'))
	require(JPATH_ADMINISTRATOR . '/' . 'components' . '/' . 'com_virtuemart' . '/' . 'helpers' . '/' . 'config.php');
 
if (!class_exists('vmPSPlugin'))
    require(JPATH_VM_PLUGINS . '/' . 'vmpsplugin.php');
    
//ini_set('display_errors', 1);
//error_reporting(E_ALL);

use PayPal\Api\Payment;
use PayPal\Api\VerifyWebhookSignature;
use PayPal\Api\WebhookEvent;
    

class plgVmPaymentPaypalcheckoutssc extends vmPSPlugin
	{
    // instance of class
    public static $_this = false;
    private $_rest = false;
	 private $_ap = true;
	 private $_ssc_payment_option='';
	 private $_ssc_pui = false;
	 
    function __construct(& $subject, $config) {
	//if (self::$_this)
	//   return self::$_this;
	parent::__construct($subject, $config);
	
	$this->_loggable = false;
	$this->tableFields = array_keys($this->getTableSQLFields());
	$this->_tablepkey = 'id';
	$this->_tableId = 'id';

	
	$varsToPush = array(
		"ssc_merchant_id" => array('', 'char'),
		"ssc_api_username" => array('', 'char'),
		"ssc_api_password" => array('', 'char'),
		"ssc_api_signature" => array('', 'char'),
		"ssc_environment" => array('', 'char'),
		"ssc_sb_merchant_id" => array('', 'char'),	
		"ssc_api_sb_username" => array('', 'char'),
		"ssc_api_sb_password" => array('', 'char'),
		"ssc_api_sb_signature" => array('', 'char'),
		"ssc_payment_intent" => array('CAPTURE', 'char'),
		"ssc_user_action" => array('', 'char'),
		"ssc_multi_currency" => array(0, 'int'),
		"ssc_one_page" => array(1, 'int'),
		"ssc_third_party_payments" => array(1, 'int'),
     
	 "payment_currency" => array('', 'int'),
	 // "email_currency" => array('', 'int'),
	 "sandbox" => array(0, 'int'),
	 
	 "ssc_address_required" => array(2, 'int'),
	 "ssc_address_override" => array(1, 'int'),
	  
	 "payment_logos" => array('', 'char'),
	 "debug" => array(0, 'int'),
	 "status_pending" => array('', 'char'),
	 "status_success" => array('C', 'char'),
	"status_authorize" => array('C', 'char'),
	 "status_canceled" => array('', 'char'),
	"status_confirmed_by_shopper" => array('U', 'char'), 
	"status_partial_refunded" => array('R', 'char'),
	"status_refunded" => array('R', 'char'),
	"status_denied" => array('D', 'char'),

	 "countries" => array('', 'char'),
	 "min_amount" => array('', 'int'),
	 "max_amount" => array('', 'int'),
		
	"categories" => array('', 'char'),
	"blocking_categories" => array('', 'char'),

	// "cost_per_transaction" => array('', 'int'),
	"cost_per_transaction" => array(0, 'float'),
	// "cost_percent_total" => array('', 'int'),
	 "cost_percent_total" => array(0, 'float'),
	 "countries" => array('', 'char'),
	 "tax_id" => array(-1, 'int'),
	 "ssc_landing_page" => array('', 'char'),
	 "ssc_solution_type" => array('', 'char'),
	 "ssc_ssc1" => array('', 'char'),
	 "ssc_ssc2" => array('', 'char'),
		 
	"ssc_whc" => array('', 'char'),	 
		 
	 "ssc_ssc1_sb" => array('', 'char'),
	 "ssc_ssc2_sb" => array('', 'char'),
		
	"ssc_whc_sb" => array('', 'char'),
		 

//	"ssc_localecode" => array('', 'char'),
//	"ssc_api_PAGESTYLE" => array('', 'char'),
	"ssc_HDRIMG" => array('', 'char'),
//	"ssc_api_HDRBORDERCOLOR" => array('', 'char'),
//	"ssc_api_HDRBACKCOLOR" => array('', 'char'),
	"ssc_PAYFLOWCOLOR" => array('', 'char'),
	"ssc_BRANDNAME" => array('', 'char'),
	"ssc_show_thank_you" => array(1, 'int'),
	"ssc_show_receipt_address" => array(1, 'int'),
	"ssc_show_order_address" => array(1, 'int'),
	"ssc_show_order_details" => array(1, 'int'),
	"ssc_payment_header" => array('', 'char'),
	"ssc_payment_footer" => array('', 'char'),
	"ssc_receipt_header" => array('', 'char'),
	"ssc_receipt_footer" => array('', 'char'),
	"ssc_raw" => array('', 'char'),
	"ssc_short_cut_cart" => array('', 'char'),
	"ssc_ipn_updates" => array(0, 'int'),
	"ssc_ajax" => array(0, 'int'),
	"ssc_template_fix" => array(1, 'int'),
	"ssc_use_patch" => array(1, 'int'),
	"ssc_ppp_lib" => array(0, 'int'),
	"ssc_enable_funding" => array('', 'char'),
	"ssc_buyer_country" => array('', 'char'),
	"ssc_order_button_background" => array('#0000FF', 'char'),
	"ssc_order_button_foreground" => array('#FFFFFF', 'char'),
		 
	"ssc_BILLINGPERIOD" => array('None', 'char'),
	"ssc_BILLINGFREQUENCY" =>array(0, 'int'),
	"ssc_TOTALBILLINGCYCLES" => array(0, 'int'),
	"ssc_INITAMT" => array(0, 'int'),

	"ssc_TRIALBILLINGPERIOD" => array('None', 'char'),
	"ssc_TRIALBILLINGFREQUENCY" =>array(0, 'int'),
	"ssc_TRIALAMT" => array(0, 'int'),
	"ssc_TRIALTOTALBILLINGCYCLES" =>array(0, 'int'),
	
	"ssc_pplan_BILLINGPERIOD" => array('None', 'char'),
	"ssc_pplan_BILLINGFREQUENCY" =>array(0, 'int'),
	"ssc_pplan_TOTALBILLINGCYCLES" => array(0, 'int'),
	"ssc_pplan_INITAMT" => array(0, 'int'),
	
	"ssc_pplan_AUTOBILLOUTAMT" => array('NoAutoBill', 'char'),
	
	"ssc_pplan_defer" => array(0, 'int'),
	"ssc_pplan_defer_date" => array(0, 'int'),
	
	"ssc_pplan_admin_fee" => array(0, 'int'),

	'ssc_pplan_defer_strtotime' => array('', 'char'),
							
	'ssc_pplan_auto_billing_type' => array('', 'char'),
   'ssc_pplan_auto_billing_max_amount' => array('', 'int'),
		 
	'ssc_show_paypal' => array(1, 'int'),
	'ssc_show_hosted' => array(1, 'int'),
	'ssc_button_position' => array(1, 'int'),
  	'ssc_use_pplan_id' => array(0, 'int'),
  	'show_cc_fields' => array(0, 'int'),
   'ssc_pplan_id' => array('PPlan', 'char'),
		 
	'ssc_show_pp' => array('paypal', 'char'),
	'ssc_show_card' => array('card', 'char'),
	'ssc_show_credit' => array('credit', 'char'),
	'ssc_show_paylater' => array('paylater', 'char'),
	'ssc_show_venmo' => array('venmo', 'char'),
	'ssc_show_sepa' => array('sepa', 'char'),
	'ssc_show_bankcontact' => array('bankcontact', 'char'),
	'ssc_show_eps' => array('eps', 'char'),
	'ssc_show_giropay' => array('giropay', 'char'),
	'ssc_show_ideal' => array('ideal', 'char'),
	'ssc_show_mybank' => array('mybank', 'char'),
	'ssc_show_p24' => array('p24', 'char'),
	'ssc_show_sofort' => array('sofort', 'char'),
	'ssc_show_pay_upon_invoice' => array('No', 'char'),
	'ssc_logo_height' => array('32', 'int'),
	'ssc_one_payment' => array('none', 'char'),
	'ssc_paypal_modal' => array('0', 'int')
		 
	);



	$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);

	//self::$_this = $this;
    }

    public function getVmPluginCreateTableSQL() {

	return $this->createTableSQL('PayPal Payments Pro Table');
    }

    function getTableSQLFields() {


$SQLfields = array(
	    "id" => 'int(1) unsigned NOT NULL AUTO_INCREMENT',
	    "virtuemart_order_id" => 'int(1) UNSIGNED',
	    "order_number" => 'char(32)',
	    "virtuemart_paymentmethod_id" => 'mediumint(1) UNSIGNED',
	    "payment_name" => 'char(255) NOT NULL DEFAULT \'\'',
	    "payment_order_total" => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\'',
	    "payment_currency" => 'char(3)',
	    "currency_code" => 'varchar(3)',
	    //  "prices_currency" => 'smallint(1)',
	  //  "prices_currency_code" => 'varchar(3)',
     //  "email_currency" => 'char(7)',
	    "cost_per_transaction" => 'decimal(10,2)',
	    "cost_percent_total" => 'decimal(10,2)',
	    "tax_id" => 'smallint(1)',
	    "paypal_custom" => 'varchar(255)',

       "paypal_response_payment_status" => 'char(50)',
	    "paypalresponse_raw" => 'varchar(512)',
	    "alt_currency" => 'char(3)',
	    "paypal_fullresponse" => "text",
		"paymentId" => 'char(64)',
		"token" => 'char(64)'
	);


$db = JFactory::getDBO();

if($this->table_exist('virtuemart_payment_plg_paypalcheckoutssc',0))

{

try
	{
	$columns = $db->getTableColumns('#__virtuemart_payment_plg_paypalcheckoutssc');

		
	if(!isset($columns['paymentId']))
		{
		$q = 'ALTER TABLE `#__virtuemart_payment_plg_paypalcheckoutssc` ADD COLUMN `paymentId` char(64) AFTER `paypalresponse_raw`';
		$db->setQuery($q);
		//$db->query($q);
		$db->execute();
		//echo '+++++++++ Not Set True +++++++++++++++++++++++';
		}
		
	if(!isset($columns['token']))
		{
		$q = 'ALTER TABLE `#__virtuemart_payment_plg_paypalcheckoutssc` ADD COLUMN `token` char(64) AFTER `paypalresponse_raw`';
		$db->setQuery($q);
		//$db->query($q);
		$db->execute();
		//echo '+++++++++ Not Set True +++++++++++++++++++++++';
		}
	
		
	}
catch (Exception $e)
	{
	echo $e->getMessage();
	}
}

$ssc = $this->ssc_check();

//load scripts after jQuery or perhaps VP core.js?


//$jinput = JFactory::getApplication()->input;
//$option = $jinput->get('option');
//$view = $jinput->get('view');
	

//$payment_params = $this->get_payment_params();

//$ppp_lib = 0;

//if(isset($payment_params['ssc_ppp_lib']))
//	{
//	$ppp_lib = $payment_params['ssc_ppp_lib'];
//	}

//if($ppp_lib == 0 || ($option == 'com_virtuemart' && ($view == 'cart' || $view == 'pluginresponse')))
//	{
//	JHtml::_('jquery.framework');
//	$document = JFactory::getDocument();
//	$document->addScript('https://www.paypalobjects.com/webstatic/ppplus/ppplus.min.js');
//	}




	return $SQLfields;
    }




function plgVmConfirmedOrder($cart, $order)
{

//error_reporting(-1);
	
	#print_r($_POST);
	#print_r($_GET);

$db = JFactory::getDbo();

//$param_get = J Request::get('get');


$jinput =JFactory::getApplication()->input;
	 
$param_get['ecocheckout'] = $jinput->get->get('ecocheckout', null, 'CMD');


$eco=0;

if (isset($param_get['ecocheckout']))
	{
	$eco=1;
	$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "paypalcheckoutssc" AND `published` = 1';
	$db->setQuery($q);
	$virtuemart_paymentmethod_id = $db->loadResult();
	$method = $this->getVmPluginMethod($virtuemart_paymentmethod_id);
	}
else
	{
	if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id)))
		{
		return null; // Another method was selected, do nothing
		}
	}	
	
if (!$this->selectedThisElement($method->payment_element))
	{
	return false;
	}
	
	
	$html='';
	$state='';
	$country='';
	$session = JFactory::getSession();
	$return_context = $session->getId();
	$this->_debug = $method->debug;
	
	if (!class_exists('VirtueMartModelOrders'))
	    require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );
	if (!class_exists('VirtueMartModelCurrency'))
	    require(JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'currency.php');

	$new_status = '';

	$address = $order['details']['BT'];
	$del_address = null;
	
	if(isset($order['details']['ST']))
	   {
	   $del_address = $order['details']['ST'];
	   }
	else
	   {
	   $del_address = $order['details']['BT'];
	   }


if($eco == 0)
	{
	if(method_exists($this,'setInConfirmOrder'))
		{
		//$this->setInConfirmOrder($cart); //xxx    //??? double order check $_cart->_inConfirm ???
		}
	//$html .= ' Set Inconfirmed<br>';	//$html .= ' Set Inconfirmed<br>';
	//echo ' Set Inconfirmed<br>';
	
   if (!class_exists('TableVendors'))
	    require(JPATH_VM_ADMINISTRATOR . '/' . 'table' . '/' . 'vendors.php');
	$vendorModel = new VirtueMartModelVendor();
	$vendorModel->setId(1);
	$vendor = $vendorModel->getVendor();
	$vendorModel->addImages($vendor, 1);
	
	
	$extension_id='17';	
	
	try
	{	 
	$db = JFactory::getDBO();
	$query =
	"SELECT " . $db->quoteName('virtuemart_userfield_id') .
	" FROM " . $db->quoteName('#__virtuemart_userfields') .
	" WHERE " . $db->quoteName('name') ." = " . $db->quote('virtuemart_state_id').";";
	$db->setQuery($query);
	$extension_id = $db->loadResult();
	}
	catch (Exception $e)
		{
		//if($debug)
		//	{
		//	echo $e->getMessage();
    	//	}
		}

	try
	{
	$db = JFactory::getDBO();
	$query = $db->getQuery(true);
	$fields = array($db->quoteName('required') . '=1');
	//$conditions = array($db->quoteName('name') . '=' . 'virtuemart_state_id');
	$conditions = array($db->quoteName('virtuemart_userfield_id') . '=' . $extension_id);  //set user fields back to required
	$query->update($db->quoteName('#__virtuemart_userfields'))->set($fields)->where($conditions);
	$db->setQuery($query);
	//$result = $db->query();
	$result = $db->execute();
	}
	catch (Exception $e)
		{
		//if($debug)
		//	{
		//	echo $e->getMessage();
    	//	}
		}
	
	
	}


	$this->getPaymentCurrency($method); //?????

	
	$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
	$db = JFactory::getDBO();
	$db->setQuery($q);
	$currency_code_3 = $db->loadResult();


   $q = 'SELECT `currency_symbol` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
	
	$db->setQuery($q);
	$currency_symbol = $db->loadResult();
	
	
	$processor_currency_code_3 = $currency_code_3;
	
	//$method->ssc_multi_currency=0;
	
	if($method->ssc_multi_currency)
		{
		$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $cart->pricesCurrency . '" ';
		
		$db->setQuery($q);
		$processor_currency_code_3 = $db->loadResult();
		}

	$dp=2;
	
	if($processor_currency_code_3 == 'JPY')
		{
		$dp=0;
		}
//echo '------------';
//echo $processor_currency_code_3;
//echo '+++++++++++++';

	if (!class_exists('CurrencyDisplay'))
   require(JPATH_VM_ADMINISTRATOR . '/' . 'helpers' . '/' . 'currencydisplay.php');


	$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
	$cd = CurrencyDisplay::getInstance($cart->pricesCurrency);
	
	if($eco == 0)
	{
	$totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total,false), $dp);
	// Prepare data that should be stored in the database
	$dbValues["order_number"] = $order["details"]["BT"]->order_number;
	$dbValues["payment_name"] = $this->renderPluginName($method, $order);
	$dbValues["virtuemart_paymentmethod_id"] = $cart->virtuemart_paymentmethod_id;
	$dbValues["paypal_custom"] = $return_context;
	$dbValues["cost_per_transaction"] = $method->cost_per_transaction;
	$dbValues["cost_percent_total"] = $method->cost_percent_total;
	
	$dbValues["payment_currency"] = $method->payment_currency;
	
//	$dbValues["payment_currency"] = $method->prices_currency;
		
	$dbValues["currency_code"] = $currency_code_3;
	
	//$method->ssc_multi_currency=0;
	
	if($method->ssc_multi_currency)
		{
		$dbValues["alt_currency"] = $cart->pricesCurrency;
		}
	else
		{
		$dbValues["alt_currency"] = $method->payment_currency;
		}
	
	$dbValues["payment_order_total"] = $totalInPaymentCurrency;
	$dbValues['tax_id'] = $method->tax_id;
	$this->storePSPluginInternalData($dbValues);
	}

$invoice_num='';

if($eco == 0)
	{
	if(isset($order["details"]["BT"]->order_number))
		{
		$invoice_num = $order["details"]["BT"]->order_number;
		}
	
	$session = JFactory::getSession();
	//$session->set('session_token', $token);

	$session_token = $session->get('session_token');
	$session_PayerID = $session->get('session_PayerID');

	if(is_null($session->get('session_token')))
		{
		//echo 'Session Token is null<br/>';
		}
	else
		{
		//echo 'Session Token ' . $session_token . '<br/>';
	
		$ret = $this->doexpress($session_token,$session_PayerID,$invoice_num);
	
		$session->set('session_token', null);
		$session->set('session_PayerID', null);
		$session->set('session_ssc_total', null);

		return $ret;	
		}

	}

$description 	= "";
$label 			= "Submit Payment"; // The is the label on the "submit" button


$loginID = "";

$product_des = "";
$short_product_des = "";

$order_form_line_item='';
$br = "\n";	

$currency_type = '0';

//if($method->ssc_multi_currency)
//	{
	$currency_type = $cart->pricesCurrency;
//	}
//else
//	{
//	$currency_type = $method->payment_currency;
//	}

$pppitems = array();

if($order)
	{
	list($table,$order_total,$line_order_total,$total_discount,$total_tax,$shipping,$line_order_details,$pppitems) = $this->order_form($order,$method,$currency_type);
	}
else
	{
	list($table,$order_total,$line_order_total,$total_discount,$total_tax,$shipping,$line_order_details,$pppitems) = $this->order_form_cart($order,$method,$currency_type);
	}

$country = '';
$cc_state = '';
$del_country = '';
$del_state = '';
$del_state_name = '';
$cc_country='';

if($eco == 0)
{
	
$country = ShopFunctions::getCountryByID($address->virtuemart_country_id, "country_2_code");
$cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id) : "";


if($country === 'US' || $del_country === 'CA')
  {
  $cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id,"state_2_code") : "";
  }


$del_country = ShopFunctions::getCountryByID($del_address->virtuemart_country_id, "country_2_code");
$del_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($del_address->virtuemart_state_id) : "";
$del_state_name = $del_state;
// possible bug
if($del_country === 'US' || $del_country === 'CA')
  {
  $del_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($del_address->virtuemart_state_id,"state_2_code") : "";
  }

//list($order_form,$order_form_html_billing) = $this->billing_shipping_address($address,$del_address,$country,$del_country,$cc_state,$del_state);


//// new custom field 23-11-11
$pro_shipping = urlencode("Overland");
////#"&SHIPPINGOPTIONNAME=" . $ _POST["pro_shipping"];

$cc_country = ShopFunctions::getCountryByID($address->virtuemart_country_id, "country_2_code");


#if(isset($method->ssc_localecode) &&  $method->ssc_localecode != '-')
#	{
	//$cc_country = $method->ssc_localecode;
#	}

$del_country = ShopFunctions::getCountryByID($del_address->virtuemart_country_id, "country_2_code");
}



if($eco == 0)
	{
	$ReturnURL = $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&e=0');
	$CancelURL = $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginUserPaymentCancel&on=' . urlencode($order['details']['BT']->order_number) . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id);
	}
else
	{
	$ReturnURL = $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&e=1');
	$CancelURL = $this->https_check(JURI::root() . 'index.php');
	}

$IPN =  $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginnotification&tmpl=component');


$landingpage = '';
$solutiontype = '';

if($method->ssc_landing_page === 'Billing')
	{
	$landingpage = '&LANDINGPAGE=Billing';
	}

if($method->ssc_landing_page === 'Login')
	{
	$landingpage = '&LANDINGPAGE=Login';
	}


if($method->ssc_solution_type === 'Sole' || $method->ssc_solution_type === '')
	{
	$solutiontype = '&SOLUTIONTYPE=Sole';
	}
	
if($method->ssc_solution_type === 'Mark')
	{
	$solutiontype = '&SOLUTIONTYPE=Mark';
	}

//ssc_api_PAGESTYLE
//ssc_api_HDRIMG
//ssc_api_HDRBORDERCOLOR
//ssc_api_HDRBACKCOLOR
//ssc_api_PAYFLOWCOLOR
//ssc_api_BRANDNAME

$ssc_HDRIMG = trim($method->ssc_HDRIMG);
if(!($ssc_HDRIMG === ''))
	{
	if (preg_match("/^https:\/\//i", $ssc_HDRIMG))
		{
		$ssc_HDRIMG = '&HDRIMG=' . urlencode($ssc_HDRIMG);
		}
	else
		{
		$ssc_HDRIMG = '';
		}
	
	}

//$ssc_api_HDRBORDERCOLOR = trim($method->ssc_api_HDRBORDERCOLOR);
//if(!($ssc_api_HDRBORDERCOLOR === ''))
//	{
//	$ssc_api_HDRBORDERCOLOR = '&HDRBORDERCOLOR=' . urlencode($ssc_api_HDRBORDERCOLOR);
//	}

//$ssc_api_HDRBACKCOLOR = trim($method->ssc_api_HDRBACKCOLOR);
//if(!($ssc_api_HDRBACKCOLOR === ''))
//	{
//	$ssc_api_HDRBACKCOLOR = '&HDRBACKCOLOR=' . urlencode($ssc_api_HDRBACKCOLOR);
//	}

$ssc_PAYFLOWCOLOR = trim($method->ssc_PAYFLOWCOLOR);
//if(!($ssc_PAYFLOWCOLOR === ''))
//	{
//	$ssc_PAYFLOWCOLOR = '&PAYFLOWCOLOR=' . urlencode($ssc_PAYFLOWCOLOR) . '&CARTBORDERCOLOR=0000FF' . '&HDRBACKCOLOR=0000FF';
//	}

if(!($ssc_PAYFLOWCOLOR === ''))
	{
	$ssc_PAYFLOWCOLOR = preg_replace("/[^A-Za-z0-9]/", "", $ssc_PAYFLOWCOLOR);
	
	$ssc_PAYFLOWCOLOR = '&CARTBORDERCOLOR=' . urlencode($ssc_PAYFLOWCOLOR);
	}
	

$ssc_BRANDNAME = trim($method->ssc_BRANDNAME);
if(!($ssc_BRANDNAME === ''))
	{
	$ssc_BRANDNAME = '&BRANDNAME=' . urlencode($ssc_BRANDNAME);
	}

//"&PAYMENTREQUEST_0_NOTETEXT =" . urlencode(art->customer_comment)






############# Begin Rest V2 ######################

$v2 = 1;

	if($v2 == 1)
	
	{
		
	$virtuemart_order_id = $order['details']['BT']->virtuemart_order_id;


	date_default_timezone_set('UTC');
	$zulu = date("Y-m-d\TH:i:s\Z");

	#echo '<div style="font-size: x-large;text-align: center" id="log_ssc">' . vmText::_('COM_VIRTUEMART_CART_SELECTPAYMENT') . '</div><br>';
	
	$payment = $this->getDataByOrderId($virtuemart_order_id);

	$pm = $payment->virtuemart_paymentmethod_id;
	
	$this->create_webhook($method,$pm);
	
	$this->show_order_buttons($method,$order,$currency_code_3,$virtuemart_order_id,$zulu);
		
	echo $this->hidessc();
	
	return;


	}







$APIrequest =
"&PAYMENTREQUEST_0_PAYMENTACTION=" . $method->ssc_payment_action .
//"&IPADDRESS=" . $ipaddress .

"&RETURNURL=". urlencode($ReturnURL) . urlencode('&pectransid=' . $invoice_num) .
//encode twice

"&CANCELURL=". urlencode($CancelURL);

//"&PAYMENTREQUEST_0_INVNUM=" . urlencode($cart->virtuemart_order_id) .

if($eco == 0)
	{
	$APIrequest .=
	"&PAYMENTREQUEST_0_INVNUM=" . urlencode($invoice_num);
	}
	
# new custom field 23-11-11
#"&PAYMENTREQUEST_0_CUSTOM=" . 
#"&SHIPPINGOPTIONNAME=" . $ _POST["pro_shipping"] .
$APIrequest .=
"&LOCALECODE=" . $cc_country .

"&PAYMENTREQUEST_0_CURRENCYCODE=" . $processor_currency_code_3 .
"&PAYMENTREQUEST_0_ITEMAMT=" . $line_order_total .
"&PAYMENTREQUEST_0_SHIPPINGAMT=" . $shipping .
"&PAYMENTREQUEST_0_TAXAMT=" . $total_tax .
"&PAYMENTREQUEST_0_AMT=" . $order_total;

if($eco == 0)
	{
	$APIrequest .=
	"&PAYMENTREQUEST_0_SHIPTONAME=" . urlencode($del_address->first_name . ' ' . $del_address->last_name) .
	"&PAYMENTREQUEST_0_SHIPTOSTREET=" . urlencode($del_address->address_1) .
	"&PAYMENTREQUEST_0_SHIPTOSTREET2=" . urlencode($del_address->address_2) .
	"&PAYMENTREQUEST_0_SHIPTOSTATE=" . urlencode($del_state) . 
	"&PAYMENTREQUEST_0_SHIPTOCITY=" . urlencode($del_address->city) . 
	"&PAYMENTREQUEST_0_SHIPTOZIP=" . urlencode($del_address->zip) .
	"&PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE=" . urlencode($del_country) .
	"&PAYMENTREQUEST_0_SHIPTOPHONENUM=" . urlencode($address->phone_1) .
	"&ADDROVERRIDE=" . '1' .
	//"&ADDROVERRIDE=" . $method->ssc_address_override .
	"&EMAIL=" . urlencode($address->email);
	}



$bt=0;
$st=0;

if($eco == 1)
	{

	//$test = array_filter($cart->BT);
	
	//if (!empty($test)) xx
//	if ($cart->BT <> 0)
	if(isset($cart->BT['last_name']))
		{
		$bt=1;
		
//		if($cart->ST <> 0)		
		if(isset($cart->STsameAsBT) && $cart->STsameAsBT == 0)
			{
			$st=1;
			}	
			
		}
		//print_r($cart);
		
	$cart_address = null;
	
	if($bt==1 && $st==0)
	   {
	   $cart_address = $cart->BT;
	   }
	   
	if($bt==1 && $st==1)
		{
	   //$cart_address = $cart->ST;
		$cart_address = $cart->getST();
	   }

	//echo print_r($cart->BT);

	//echo "BT is $bt<br>";

	//echo "ST is $st<br>";
	$cart_state = '';

	if(!is_null($cart_address))
		{
  		$cart_country = '';
		$cart_state = '';

		$cart_country = ShopFunctions::getCountryByID($cart_address['virtuemart_country_id'], "country_2_code");
		$cart_state = isset($cart_address['virtuemart_state_id']) ? ShopFunctions::getStateByID($cart_address['virtuemart_state_id']) : "";

		if($cart_country === 'US' || $cart_country === 'CA')
		  {
		  $cart_state = isset($cart_address['virtuemart_state_id']) ? ShopFunctions::getStateByID($cart_address['virtuemart_state_id'],"state_2_code") : "";
		  }

		$output =
		"&PAYMENTREQUEST_0_SHIPTONAME=" . urlencode($cart_address['first_name'] . ' ' . $cart_address['last_name']) .
		"&PAYMENTREQUEST_0_SHIPTOSTREET=" . urlencode($cart_address['address_1']) .
		"&PAYMENTREQUEST_0_SHIPTOSTREET2=" . urlencode($cart_address['address_2']) .
		"&PAYMENTREQUEST_0_SHIPTOSTATE=" . urlencode($cart_state) . 
		"&PAYMENTREQUEST_0_SHIPTOCITY=" . urlencode($cart_address['city']) . 
		"&PAYMENTREQUEST_0_SHIPTOZIP=" . urlencode($cart_address['zip']) .
		"&PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE=" . urlencode($cart_country) .
		"&PAYMENTREQUEST_0_SHIPTOPHONENUM=" . urlencode($cart->BT['phone_1']) .
		"&ADDROVERRIDE=" . '1' .
		//"&ADDROVERRIDE=" . $method->ssc_address_override .
		"&EMAIL=" . urlencode($cart->BT['email']);
		
		//echo '-------------' . $output . '+++++++++++++++++++++++++';
		
		$APIrequest .= $output;
		
		}
	}

	

$APIrequest .=
$landingpage .

$solutiontype .

"&NOSHIPPING=" . $method->ssc_address_required .

$line_order_details .


//'&REQCONFIRMSHIPPING=1' .
"&PAYMENTREQUEST_0_NOTIFYURL=" . urlencode($IPN) .

//"&PAGESTYLE=" . 

//$ssc_api_PAGESTYLE .
$ssc_HDRIMG .
//$ssc_HDRBORDERCOLOR .
//$ssc_HDRBACKCOLOR .
$ssc_PAYFLOWCOLOR .
$ssc_BRANDNAME;

if($method->debug)
	{
	$html .= 'contacting paypal server<br>';
	$html .= $APIrequest;
	
//	print_r($cart);
	
	}




$httpResponse = $this->PPHttpPost($method,"SetExpressCheckout", $APIrequest);

if($method->debug)
	{
	$html .= '<br>contact complete<br>';
	}


//print("Http Response: " . print_r($httpResponse, true));

if("SUCCESS" == strtoupper($httpResponse["ACK"]) || "SUCCESSWITHWARNING" == strtoupper($httpResponse["ACK"]))
   {

   
   $html .= "<p style='font-size: x-large'>" . JText::_('VMPAYMENT_PPC_SSC_CONNECTING_TO_PAYPAL') . "</p>";
   
   $token = urldecode($httpResponse["TOKEN"]);
   


$paypal_url ="";

if($method->ssc_environment === "sandbox")
   {
   $paypal_url = "sandbox.paypal.com";
   }
else
   {
   $paypal_url = "paypal.com";
   }

//commit = paypal
//nocommit = website



if($method->ssc_user_action === "commit" && $eco == 0)
	{
	$paypal_url = "https://www.$paypal_url/cgi-bin/webscr?cmd=_express-checkout&useraction=commit&token=$token";
	}
else
	{
	$paypal_url =   "https://www.$paypal_url/cgi-bin/webscr?cmd=_express-checkout&token=$token";
	}

$html .= "<form name='postform' action='" . $paypal_url . "' method ='post'>";                                         
$html .= '<input type="hidden" name="b1" value="a">';
$html .= '<input type="submit" name="submit_button" value="' . JText::_('VMPAYMENT_PPC_SSC_CLICK') . '"><br><br>';
$html .= '</form>';
   
//if(!$method->debug && $d==0)
//	{
//	print $APIrequest;
//	print $line_order_details;
//	}

if(!$method->debug)
   {
   $html .= '<script type="text/javascript">';
//   $html .= 'document.postform.submit();';
   $html .= '</script>';
   }



if($eco == 1)
	{
	echo $html;
	//echo 'eco is one';
	$html = '';
	}

/*		
print "<style>
br#hidessc + h3
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
}
</style>
<br id='hidessc'/>
";
*/

print "<style>
img#hidessc + h1
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>";

print "<style>
img#hidessc + h3
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>

<style>
img#hidessc + div > h3:first-child
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>

<img id='hidessc'/>
";

		
	return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $new_status);

   }
else
   {
   $order_form_city = JText::_('VMPAYMENT_PPC_SSC_CITY');
	$order_form_state = JText::_('VMPAYMENT_PPC_SSC_STATE');
	$order_form_country = JText::_('VMPAYMENT_PPC_SSC_COUNTRY');
	$order_form_zip = JText::_('VMPAYMENT_PPC_SSC_ZIP');


   $return_button = "<script language='JavaScript'><!--\r\n" .
   "document.write('<br><br><input type=\"button\" value=\"Return\" name=\"b1\" onClick=\"history.go(-1)\">&nbsp;&nbsp;')" .           
   "\r\n--></script>";   
   
   $s=0;
   $error ="No";
         $html .= "<span style='font-family: Arial, Helvetica, sans-serif; font-size: large; color: #FF0000'>";
   while(isset($httpResponse["L_LONGMESSAGE" . $s]))
   {

   
   if($httpResponse["L_ERRORCODE" . $s] == "500")
      {
	  $html .= JText::_('VMPAYMENT_PPC_SSC_UNKNOWN_ERROR');   
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "81234")
      {
      $html .= "";        
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "10002" && $httpResponse["L_LONGMESSAGE" . $s] == 'Security%20header%20is%20not%20valid')
      {
      $html .= "Please check your API Username, Password and Signature for your Live or Sandbox account.";	         
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "10002" && $httpResponse["L_LONGMESSAGE" . $s] == 'You%20do%20not%20have%20permissions%20to%20make%20this%20API%20call')
      {
      $html .= "Do you have a valid PayPal Live or Sandbox account with the correct API Username, Password and Signature";	         
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "10736")
      {
      $html .= JText::_('VMPAYMENT_PPC_SSC_SHIPPING_ADDRESS_ERROR') . "<br><br>";
      
    if($eco == 1)    
      {  
		$cart_state = isset($cart_address['virtuemart_state_id']) ? ShopFunctions::getStateByID($cart_address['virtuemart_state_id']) : "";      
      $html .= $order_form_city .': ' . $cart_address['city'] . "<br>";
      $html .= $order_form_zip . ': ' . $cart_address['zip'] . "<br>";
      $html .= $order_form_state . ': ' . $cart_state . "<br><br>"; 
		}
	else
		{
		$cart_state = isset($cart_address['virtuemart_state_id']) ? ShopFunctions::getStateByID($del_address['virtuemart_state_id']) : "";      
	    $html .= $order_form_city .': ' . $del_address->city . "<br>";
      $html .= $order_form_zip . ': ' . $del_address->zip . "<br>";
      $html .= $order_form_state . ': ' . $del_state_name. "<br><br>";  
		} 

      $html .= JText::_('VMPAYMENT_PPC_SSC_CHECK_MISSPELLINGS') . "<br><br>";
      
    if(($bt==1 && $st==1) || isset($order['details']['ST']))
	   {
	   $html .= '<a href="' . $this->https_check(JURI::root()) . 'index.php?option=com_virtuemart&view=user&task=editaddresscart&addrtype=ST">Edit Address</a></strong>';
	   }
	else
	   {
	    $html .= '<a href="' . $this->https_check(JURI::root()) . 'index.php?option=com_virtuemart&view=user&task=editaddresscart&addrtype=BT">Edit Address</a></strong>';
	   }

      }
      
   	elseif($httpResponse["L_ERRORCODE" . $s] == "10729")
       {
       $html .= "Your Address do not include a State. Please add a State.<br><br>";	
      
       if(($bt==1 && $st==1) || isset($order['details']['ST']))
          {
	      $html .= '<a href="' . $this->https_check(JURI::root()) . 'index.php?option=com_virtuemart&view=user&task=editaddresscart&addrtype=ST">Edit Address</a></strong>';
	      }   
	   else
	      {
	      $html .= '<a href="' . $this->https_check(JURI::root()) . 'index.php?option=com_virtuemart&view=user&task=editaddresscart&addrtype=BT">Edit Address</a></strong>';
	      }
      }
  
  	elseif($httpResponse["L_ERRORCODE" . $s] == "10730")
       {
       $html .=  "Your Address do not include a Zip Code. Please add a Zip Code.<br><br>";	
      
       if(($bt==1 && $st==1) || isset($order['details']['ST']))
          {
	      $html .= '<a href="' . $this->https_check(JURI::root()) . 'index.php?option=com_virtuemart&view=user&task=editaddresscart&addrtype=ST">Edit Address</a></strong>';
	      }   
	   else
	      {
	      $html .= '<a href="' . $this->https_check(JURI::root()) . 'index.php?option=com_virtuemart&view=user&task=editaddresscart&addrtype=BT">Edit Address</a></strong>';
	      }
      }

   
  
   else
      {
   
      if($error == 'No')
         {      
         $html .=  "<br>" . JText::_('VMPAYMENT_PPC_SSC_TRY_AGAIN') . "<br>";
         $error='Yes';
         }
         	         
      $html .= $httpResponse["L_ERRORCODE" . $s] . ": " . urldecode($httpResponse["L_LONGMESSAGE" . $s]) . " <br><br>\r\n";  
      }
   $s++;
     
   }
    $html .= $return_button;
    $html .= "<br></span><br>";
}

/*
if($method->debug)
	{
	$html .= print_r($cart);
  $html .= print_r($order);
	echo "Amount " . $totalInPaymentCurrency;
	echo "<br>currency code " . $currency_code_3;
	echo "<br>Currency ID " . $method->payment_currency;
	echo "<br>order_total " . $order["details"]["BT"]->order_total;
	echo "<br>Total in Shop Currency " . round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, false),$dp);
	echo "<br>";
	print "Order number " . $order["details"]["BT"]->order_number . "<br>";
	print "Order id " . $cart->virtuemart_order_id . "<br>";
	print "Shipping - SHIPPINGAMT" . $shipping . "<br>";
	print "Line Order Total - ITEMAMT - no number format" . $line_order_total . "<br>";
	print "totalInPaymentCurrency - AMT " . $amount . "<br>";
	print "Order Total line order total + shipping: " . $order_total . "<br>";
	print "Line Order Details " . htmlspecialchars($line_order_details) . "<br>";
	print "APIrequest " . htmlspecialchars($APIrequest) . "<br>";
	
	}
*/


//$html='
//-->';
//echo $html;

///$this->handlePaymentUserCancel($cart->virtuemart_order_id);

if($eco == 1)
	{
	echo $html;
	//echo 'eco is one with error';
	$html = '';
	}
		
//$opc_enabled = 0;

//$opc_enabled = $this->opc_enabled();

//if($opc_enabled == '1' || $eco == 1)
//    {
    //echo 'enabled:' . $opc_enabled;
//    echo $html;
//    $html='';
//    }



echo $this->hidessc();


// 	2 = don't delete the cart, don't send email and don't redirect
	return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $new_status);


}


function create_webhook($method,$pm)
{
	

### begin wh ####
	
$sandbox_ext='';

$ssc1 = $method->ssc_ssc1;
$ssc2 = $method->ssc_ssc2;
$webhookID = $method->ssc_whc;

### check webhook if is already defined ###


if($method->ssc_environment == "sandbox")
   {
	$sandbox_ext='_sb';
	$ssc1 = $method->ssc_ssc1_sb;
	$ssc2 = $method->ssc_ssc2_sb;
	$webhookID = $method->ssc_whc_sb;
   }

$ssc1 = trim($ssc1);
$ssc2 = trim($ssc2);
$webhookID = trim($webhookID);	
	
if($webhookID != '')
	{
	return;
	}	
	
	
	#$this->log('Webhook ID: ' . $webhookID);	
	

$apiContext = new \PayPal\Rest\ApiContext
	(
	new \PayPal\Auth\OAuthTokenCredential(
	$ssc1,
	$ssc2
	)
);


$m = "LIVE";

if($method->ssc_environment == "sandbox")
   {
   $m = "SANDBOX";
   }


$apiContext->setConfig(
    array('mode' => $m)
); 


##### does webhook already exist #####
		
$url = JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginnotification&tmpl=component&w=1';

	
if(substr( $url,0,5 ) === "http:")
	{
	//echo 'http';
	return;
	}


if(strpos($url, 'localhost') !== false)
	{
   //echo "localhost";
	return;
	}

try
	{
	$webhookList = \PayPal\Api\Webhook::getAll($apiContext);
	}
catch (Exception $ex)
	{
   //echo "List all webhooks" . $ex;
   return;
	}


$id = '';

// ### does a webhook id already exist online
try {
    foreach ($webhookList->getWebhooks() as $webhook)
		{
		// echo $url;
		// echo '<br>Webhook url: ' . $webhook->url;
		if(trim($webhook->url) === $url)
			{
		//	echo 'Webhook id: ' . $webhook->id;
			$id = $webhook->id;
			
			try
				{
			   $output = $webhook->delete($apiContext);
				}
			catch (Exception $ex)
				{
				$data = $ex->getData();     
			//	echo "webhook delete exception<br><br>" . $ex . '<br><br>getData:<br><br>' . $ex->getData();
				return;
				}
			
		//	$this->update_webhook($id,$sandbox_ext,$pm);
		//	return $id;
			}
		}
	 
	}
catch (Exception $ex)
	{
   echo "Test all Webhooks Exception";
   return;
	}


//return;


$webhook = new \PayPal\Api\Webhook();

$webhook->setUrl($url);

// # Event Types
// Event types correspond to what kind of notifications you want to receive on the given URL.
$webhookEventTypes = array();


$webhookEventTypes[] = new \PayPal\Api\WebhookEventType(
	'{
		"name": "PAYMENT.AUTHORIZATION.CREATED"    
	}'
	);


$webhookEventTypes[] = new \PayPal\Api\WebhookEventType(
	'{
		"name": "CHECKOUT.ORDER.APPROVED"    
	}'
	);


$webhookEventTypes[] = new \PayPal\Api\WebhookEventType(
	'
	{
		"name": "CHECKOUT.PAYMENT-APPROVAL.REVERSED"
	}'
	);


$webhookEventTypes[] = new \PayPal\Api\WebhookEventType(
	'
	{
		"name": "PAYMENT.CAPTURE.PENDING"
	}'
	);


$webhookEventTypes[] = new \PayPal\Api\WebhookEventType(
	'
	{
		"name": "PAYMENT.CAPTURE.COMPLETED"
	}'
	);


$webhookEventTypes[] = new \PayPal\Api\WebhookEventType(
	'
	{
	"name": "PAYMENT.CAPTURE.DENIED"
	}'
	);




$webhook->setEventTypes($webhookEventTypes);

// ### Create Webhook
try{
   $output = $webhook->create($apiContext);
	}
catch (Exception $ex)
	{
   if ($ex instanceof \PayPal\Exception\PayPalConnectionException)
		{
      $data = $ex->getData();     
      echo "catch webhook exception<br><br>" . $ex . '<br><br>getData:<br><br>' . $ex->getData();
	   return;
		}
		
	   echo "webhook exception:<br><br>" . $ex;
      return;	
    // Print Success Result
	}
		
		
		//print_r($output);
		
		
		$this->update_webhook($output->id,$sandbox_ext,$pm);
		##########  end create webhook ############
		

	}


function update_webhook($id,$ext,$pm)

{
	
	
	

	$db = JFactory::getDbo();
	$db->setQuery("SELECT `payment_params` FROM `#__virtuemart_paymentmethods` WHERE `virtuemart_paymentmethod_id` = " . $pm . " AND `payment_element` = 'paypalcheckoutssc'");
	$config = $db->loadResult();

//echo $config;
	//$str = '/(.*)(\|ssc_whc' . $ext . '="\s*"\|)(.*)/';	
	$str = '/(.*)(\|ssc_whc' . $ext . '=".*?"\|)(.*)/';

	if (preg_match($str, $config,$matches))
		{
		$replace = '|ssc_whc' . $ext . '="' . $id . '"|';
	

		$config = $matches[1] . $replace . $matches[3];


		$db = JFactory::getDBO();

		try
			{
			$q =  "UPDATE `#__virtuemart_paymentmethods` SET `payment_params` = '" . $db->escape($config) . "' WHERE `virtuemart_paymentmethod_id` = ". $pm . " AND `payment_element` = 'paypalcheckoutssc'";
			$db->setQuery($q);
			//$db->query($q);
			$db->execute();
			}
		catch (Exception $e)
			{
			echo $e->getMessage();
			}
		return;
		}
		
	$str = '/(.*)(\|ssc_wh[a-z]' . $ext . '=".*?"\|)(.*)/';

	if (preg_match($str, $config,$matches))
		{
		$replace = '|ssc_whc' . $ext . '="' . $id . '"|';
	

		$config = $matches[1] . $replace . $matches[3];


		$db = JFactory::getDBO();

		try
			{
			$q =  "UPDATE `#__virtuemart_paymentmethods` SET `payment_params` = '" . $db->escape($config) . "' WHERE `virtuemart_paymentmethod_id` = ". $pm . " AND `payment_element` = 'paypalcheckoutssc'";
			$db->setQuery($q);
			//$db->query($q);
			$db->execute();
			}
		catch (Exception $e)
			{
			echo $e->getMessage();
			}
		return;
		}	
		
		
	/*	
	$str = '/(\ssc_whc' . $ext . '=)/';

	if (!preg_match($str, $config,$matches))
		{
		$replace = 'ssc_whc' . $ext . '="' . $id . '"|';
	
		$config = $replace . $config;

		$db = JFactory::getDBO();

		try
			{
			$q =  "UPDATE `#__virtuemart_paymentmethods` SET `payment_params` = '" . $db->escape($config) . "' WHERE `virtuemart_paymentmethod_id` = ". $pm . " AND `payment_element` = 'paypalcheckoutssc'";
			$db->setQuery($q);
			//$db->query($q);
			$db->execute();
			}
		catch (Exception $e)
			{
			echo $e->getMessage();
			}

		}	
		*/

	#### end wh ####	


return;
	
}



function show_order_buttons($method,$order,$currency_code_3,$virtuemart_order_id,$zulu)
{
#print_r($order);

$paypal_url = "api.paypal.com";
	
if($method->ssc_environment == "sandbox")
	{
	$paypal_url = "api.sandbox.paypal.com";
	}
		
$cart = VirtueMartCart::getCart ();
$cart->prepareCartData(); //xxx
$cart->getCartPrices();

$currency_type = '0';
$currency_type = $cart->pricesCurrency;


#echo $currency_type;

$pppitems = array();

	$button_url='';
	
	//$order = null;
	
	$address = null;
	$del_address = null;	
	
	
	if($order)
		{
		$address = $order['details']['BT'];
		
		$cc_name = $address->first_name . ' ' . $address->last_name;
		$cc_address_line_1 = $address->address_1;
		$cc_address_line_2 = $address->address_2;
		//$admin_area_2 = $address->city;
		$cc_city = $address->city;
		$cc_country = ShopFunctions::getCountryByID($address->virtuemart_country_id, 'country_2_code');
		$cc_postal_code = $address->zip;
		$cc_phone = $address->phone_1;
		$cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id) : "";	
		
		$del_address = $order['details']['BT'];

		if($order['details']['BT']->STsameAsBT == 0)
			{
			$del_address = $order['details']['ST'];
			}
	
		
		$del_recipient_name = $del_address->first_name . ' ' . $del_address->last_name;
		$del_address_line_1 = $del_address->address_1;
		$del_address_line_2 = $del_address->address_2;
		$del_admin_area_2 = $del_address->city;
		$del_city = $del_address->city;
		$del_country_code = ShopFunctions::getCountryByID($del_address->virtuemart_country_id, 'country_2_code');
		$del_postal_code = $del_address->zip;
		$del_phone = $del_address->phone_1;
		$del_state = isset($del_address->virtuemart_state_id) ? ShopFunctions::getStateByID($del_address->virtuemart_state_id) : "";
		
		list($table,$return_button,$order_total,$line_order_total,$total_discount,$total_tax,$total_shipping,$line_order_details,$rest_line_items,$req,$line_items_total) = $this->order_form_checkout($order,$method,$button_url);
	
		if($method->debug)
			{
			echo '<br>Order Total: ';
			echo $order_total;
			echo '<br>Line Order Total:';
			echo $line_order_total;
			echo '<br>Total Discount: ';
			echo $total_discount;
			echo '<br>Total Tax: ';
			echo $total_tax;
			echo '<br>Total Shipping: ';
			echo $total_shipping;
			echo '<br>Line Items Total: ';
			echo $line_items_total;
			echo '<br>';
			echo $rest_line_items;
			echo '<br>';
			}
		}
	else
		{
	
		list($table,$return_button,$order_total,$line_order_total,$total_discount,$total_tax,$total_shipping,$line_order_details,$pppitems,$rest_line_items,$line_items_total) = $this->order_form_cart(null,$method,$currency_type);
	 		
		
		//$cart = VirtueMartCart::getCart ();
		//$cart->prepareCartData(); //xxx
		//$cart->getCartPrices();
		
		$address = $cart->BT;
	
//		$cart->STsameAsBT = 1;
			
		$cart_country = '';
		$cart_state = '';

		$cart_country = ShopFunctions::getCountryByID($address['virtuemart_country_id'], "country_2_code");
		$cart_state = isset($address['virtuemart_state_id']) ? ShopFunctions::getStateByID($address['virtuemart_state_id']) : "";

		if($cart_country === 'US' || $cart_country === 'CA')
		  {
		  $cart_state = isset($address['virtuemart_state_id']) ? ShopFunctions::getStateByID($address['virtuemart_state_id'],"state_2_code") : "";
		  }
				
		$cc_name = $address['first_name'] . ' ' . $address['last_name'];
		$cc_address_line_1 = $address['address_1'];
		$cc_address_line_2 = $address['address_2'];
		//$admin_area_2 = $address['city'];
		$cc_city = $address['city'];
		$cc_country = $cart_country;
		$cc_postal_code = $address['zip'];
		$cc_phone = $address['phone_1'];
		$cc_state = $cart_state;	
		
		$del_address = $cart->getST();
		
		$del_cart_country = ShopFunctions::getCountryByID($del_address['virtuemart_country_id'], "country_2_code");
		$del_cart_state = isset($del_address['virtuemart_state_id']) ? ShopFunctions::getStateByID($del_address['virtuemart_state_id']) : "";
		
		$del_recipient_name = $del_address['first_name'] . ' ' . $del_address['last_name'];
		$del_address_line_1 =  $del_address['address_1'];
		$del_address_line_2 =  $del_address['address_2'];
		$del_admin_area_2 = $del_address['city'];
		$del_city = $del_address['city'];
		$del_country_code = $del_cart_country;
		$del_postal_code = $del_address['zip'];
		$del_phone = $del_address['phone_1'];
		$del_state = $del_cart_state;
		
		
		
		
		if($method->debug)
			{
			echo '<br>Cart Total: ';
			echo $order_total;
			echo '<br>Line Order Total:';
			echo $line_order_total;
			echo '<br>Total Discount: ';
			echo $total_discount;
			echo '<br>Total Tax: ';
			echo $total_tax;
			echo '<br>Total Shipping: ';
			echo $total_shipping;
			echo '<br>Line Items Total: ';
			echo $line_items_total;
			echo '<br>';
			echo $rest_line_items;
			echo '<br>';
			}
		}

$clientId = $method->ssc_ssc1;
$secret = $method->ssc_ssc2;


if($method->ssc_environment == "sandbox")
   {
	$clientId = $method->ssc_ssc1_sb;
	$secret = $method->ssc_ssc2_sb;
   }
	
$clientId = trim($clientId);
$secret = trim($secret);	
	
$access_token = $this->create_access_token($clientId,$secret,$paypal_url);

if($this->_ap)
	{
	$client_token = $this->generate_client_token($access_token,$paypal_url);
	}

$headers = array(
'PayPal-Partner-Attribution-Id: OnlineStore_Cart_EC',
'Content-type: application/json',
'Authorization: Bearer ' . $access_token,
'Accept-Language: en_US'
);



$payment = $this->getDataByOrderId($virtuemart_order_id);

$pm = $payment->virtuemart_paymentmethod_id;


if($order)
	{
	$invoice_num = $order["details"]["BT"]->order_number;
	}
else
	{
	$invoice_num = uniqid();	
	}



$line_items_total = number_format($line_items_total,2,'.','');
$total_shipping = number_format($total_shipping,2,'.','');
$total_tax = number_format($total_tax,2,'.','');
$total_discount = abs($total_discount);
$total_discount = number_format($total_discount,2,'.','');



$postfields =
'
{
    "intent": "CAPTURE",
    "application_context": {
        "shipping_preference": "SET_PROVIDED_ADDRESS",
		  "user_action": "PAY_NOW",
			"cancel_url": ' . json_encode(JURI::root()) . '
    },
    "purchase_units": [
    {
	 
		"invoice_id": ' . json_encode($invoice_num) . ',
        "amount": {
		     "value": ' . json_encode($order_total) . ',
               "currency_code": ' . json_encode($currency_code_3) . ',
             
				"breakdown": {
                     "item_total": {"value": ' . json_encode($line_items_total) .  ', "currency_code": ' . json_encode($currency_code_3) . '},
							"shipping" : {"value": ' . json_encode($total_shipping) .  ', "currency_code": ' . json_encode($currency_code_3) . '},
							"tax_total" : {"value": ' . json_encode($total_tax) .  ', "currency_code": ' . json_encode($currency_code_3) . '},
							"discount" : {"value": ' . json_encode($total_discount) .  ', "currency_code": ' . json_encode($currency_code_3) . '}
							}
    },
    "items": [
        ' . $rest_line_items . '
    
    ],
    "shipping": {
        "address": {
            "recipient_name": ' . json_encode($del_recipient_name) . ',
            "address_line_1": ' . json_encode($del_address_line_1) . ',
            "address_line_2": ' . json_encode($del_address_line_2) . ',
				"admin_area_2": ' . json_encode($del_admin_area_2) . ',
				"city": ' . json_encode($del_city) . ',
            "country_code": ' . json_encode($del_country_code) . ',
            "postal_code": ' . json_encode($del_postal_code) . ',
	         "phone": ' . json_encode($del_phone) . ',
            "state": ' . json_encode($del_state) . '
        }
    }


 }
]
}';


if($method->debug)
	{
	echo $postfields;
	echo '<br><br>';
	}

$ch = curl_init();


curl_setopt($ch, CURLOPT_URL, "https://" . $paypal_url . "/v2/checkout/orders");
//curl_setopt($ch, CURLOPT_HEADER, false);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
//curl_setopt($ch, CURLOPT_SSLVERSION , 6); //NEW ADDITION
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); 
//curl_setopt($ch, CURLOPT_USERPWD, $clientId.":".$secret);
curl_setopt($ch, CURLOPT_POSTFIELDS, $postfields);
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);

if(empty($result))
	{
	echo 'Curl error: ' . curl_error($ch);
	}
else
	{
	$json = json_decode($result);
	if($method->debug)
	{
   print_r($json);
	}
	$order_id = trim($json->id);
	

$fetch_url = JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginnotification&format=json&paymentId=' . $order_id . '&token=' . $access_token . '&pm=' . $pm . '&capture=1&env=' . $method->ssc_environment;


$db = JFactory::getDBO();

try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_paypalcheckoutssc` SET `paymentId` = '" . $order_id . "' WHERE `order_number` = '" .  $invoice_num . "'";

	$db->setQuery($q);
	$result = $db->execute();

	}
catch (Exception $e)
	{
	echo $e->getMessage();
	}
	

	
	}

curl_close($ch);
$document = JFactory::getDocument();
//$document->addScript('/media/system/js/sample.js');
//   return "' . $order_id . '";

//$locale = 'de_DE';

$enable_funding = '';


if($method->ssc_enable_funding != '')
   {	
	$enable_funding = '&enable-funding=' . trim($method->ssc_enable_funding);
	}
	

$funding_name = '';
$funding_source  = '';

if( trim($this->_ssc_payment_option) != '')
	{
	$funding_source  = 'fundingSource: "' . $this->_ssc_payment_option . '",';
	$funding_name  = $this->_ssc_payment_option;
	}

	
	
	$alternative_payments = false;
	

		
		/*
		echo $funding_name;
		echo "<br>";	
		echo "Show Hosted: $method->ssc_show_hosted";
		echo "<br>";	
		echo "show PayPal: $method->ssc_show_paypal";
		echo "<br>";	
		echo "Show PayPal Payments: $paypal_payments";
		echo "<br>";	
		echo "Show Alertenative Payments: $alternative_payments";
		echo "<br>";
		
		*/



$cc_payment_fields =  '';

	$document = JFactory::getDocument();
	$url = JURI::root() . "plugins/vmpayment/paypalcheckoutssc/cardfields.css";
	$document->addStyleSheet($url);


/*
 style: {
    layout: 'vertical',
    color:  'blue',
    shape:  'rect',
    label:  'paypal'
  }
*/
	$session = JFactory::getSession();
	//$session->set('session_token', $token);


	if(is_null($session->get('ssc_payment_option')))
		{
		//echo 'Session Token is null<br/>';
		}
	else
		{
		$this->_ssc_payment_option = $session->get('ssc_payment_option');
		}

		

		

		
$paypal_buttons='';

if($method->ssc_show_paypal)
{

$paypal_buttons = '
<script>
  paypal.Buttons({
  

' . $funding_source . '

    createOrder: function (data, actions) {
	 
      return "' . $order_id . '";

    },

    onApprove: function (data, actions) {
	  return actions.order.capture().then(function(orderData) {

     // if (!orderData.ok) {

     //     alert(JSON.stringify(orderData));

     //   }
   document.getElementById("paypal-button-container").style.display = "none";
 
	document.getElementById("log_ssc").innerHTML = "<br>' . JText::_('VMPAYMENT_PPC_SSC_YOUR_PAYMENT_HAS_BEEN_SUCCESSFUL') . '<br><br>' . JText::_('VMPAYMENT_PPC_SSC_PLEASE_WAIT_FOR_THE_CONFIRMATION_PAGE_TO_LOAD') . '";
	document.getElementById("loader-ssc-2").style.display = "block";
	document.getElementById("ssc_order_details").style.display = "none";

  window.location.href = "' . JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&paymentId=" + data.orderID + "&token=" + data.facilitatorAccessToken + "&pm=' . $pm . '&pcs=1&type=PP";

//	document.getElementById("log_ssc").innerHTML = JSON.stringify(data, null, 2);

  });
    }

  }).render(\'#paypal-button-container\');
</script>
';

}


// page layout

echo $return_button;

$button_position = $method->ssc_button_position;

if($button_position == 1)
	{
	echo $table;
	$show_shipping = 1;
	$show_edit = 1;
	$this->print_address($virtuemart_order_id,$method, $show_shipping,$show_edit);
	}

echo '<div id="log_ssc"></div>';



echo '<div id="message-ssc" style="font-size: large; text-align: left; background-color: #FFFFFF; color:#000000 ;border-radius: 4px;" ></div>';	


	
if($method->ssc_show_paypal)
	{
	echo '<b>' . JText::_('VMPAYMENT_PPC_SSC_SELECT_PAYMENT') . '</b><br><br>';
	echo '<div id="loader-ssc-2" class="loader-ssc" style="display: none">' . JText::_('VMPAYMENT_PPC_SSC_PLEASE_WAIT') . '</div>';	
	}
	

echo '<div id="payment-fields" style="width: 50%;"></div>';
echo '<div id="paypal-button-container" style="width: 50%;"></div><br>';	

if($method->ssc_show_paypal)
	{
	echo $paypal_buttons;
	}
	



if($button_position == 0)
	{
	echo $table;
	$show_shipping = 1;
	$show_edit = 1;
	$this->print_address($virtuemart_order_id,$method, $show_shipping,$show_edit);
	}	
	
return;
}


/*
         onApprove: function(data, actions) {
                return actions.order.capture().then(function(orderData) {
                    // Successful capture! For demo purposes:
                    console.log('Capture result', orderData, JSON.stringify(orderData, null, 2));
                    var transaction = orderData.purchase_units[0].payments.captures[0];
                    alert('Transaction '+ transaction.status + ': ' + transaction.id + '\n\nSee console for all available details');

                    // Replace the above to show a success message within this page, e.g.
                    // const element = document.getElementById('paypal-button-container');
                    // element.innerHTML = '';
                    // element.innerHTML = '<h3>Thank you for your payment!</h3>';
                    // Or go to another URL:  actions.redirect('thank_you.html');
                });
            }
*/

function order_form_checkout($order,$method,$button_url='')
{


	if (!class_exists('CurrencyDisplay'))
	    require(JPATH_VM_ADMINISTRATOR . '/' . 'helpers' . '/' . 'currencydisplay.php');
	$paymentCurrency = CurrencyDisplay::getInstance();



$order_form_line_item='';
$br = "\n";	

$line_order_details = '';
$req = array();
$trusted_line_items='';    ## Tracking
$line_order_total = 0;

$inc_tax = 0;

	  if(isset($order['details']['BT']->order_tax) && $order['details']['BT']->order_tax > 0)
	     {
	     $inc_tax = 1;
	     }

$unit_price = JText::_('VMPAYMENT_PPC_SSC_UNIT_PRICE');

$unit_price = str_replace(' ','&nbsp;',$unit_price);

if (!class_exists('VirtueMartModelCurrency'))
	    require(JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'currency.php');

	$this->getPaymentCurrency($method);  // code 0 is default ??
	$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
	$db = JFactory::getDBO();
	$db->setQuery($q);
	$currency_code_3 = $db->loadResult();


    $q = 'SELECT `currency_symbol` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
	//$db = JFactory::getDBO();
	$db->setQuery($q);
	$currency_symbol = $db->loadResult();





$background = $method->ssc_order_button_background;
$foreground = $method->ssc_order_button_foreground;

$background = preg_replace("/[^A-Za-z0-9]/", "", $background);
$foreground = preg_replace("/[^A-Za-z0-9]/", "", $foreground);

///index.php?option=com_virtuemart&view=cart

$back = JText::_('VMPAYMENT_PPC_SSC_BACK_TO_CART');

if($button_url == '')
	{
	$url = $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=cart');
	
	if(isset($_POST["APIOperation"]))
		{
		$url = $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&update_order');
		}

	//echo 'No Button URL';
	}
else
	{
	$url = $button_url;
	}
	
	$return_button = '';
	
if(!isset($_POST["APIOperation"]))
	{
	$return_button = "<input style=\"background:#$background;color:#$foreground;border-style: solid;border-color:#$background;border-width:6x;border-radius:16px;font-weight:bold;cursor:pointer\" value=\"$back\" name=\"B2\" type=\"button\" onclick=\"window.location.href='$url'\"><br/><br/>";
	}

$table= '<table border="1" width="600" cellspacing="0" cellpadding="2" id="ssc_order_details" class="ssc">
<tr>
	<td style="background-color: rgb(220,220,220)" width="50"><strong><font face="Arial"
	size="2">' . JText::_('VMPAYMENT_PPC_SSC_ID') . '&nbsp;&nbsp;</font></strong></td>
	<td style="background-color: rgb(220,220,220)" width="400"><strong><font face="Arial"
	size="2">' . JText::_('VMPAYMENT_PPC_SSC_ITEM') .  '</font></strong></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><font face="Arial"
	size="2"><strong>' . $unit_price .'&nbsp;</strong></font></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><strong><font face="Arial"
	size="2">&nbsp;' . JText::_('VMPAYMENT_PPC_SSC_QUANTITY') . '&nbsp;</font></strong></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><strong><font face="Arial"
	size="2">&nbsp;' . JText::_('VMPAYMENT_PPC_SSC_TOTALS') . '</font></strong></td>
</tr>';


	  $i = 1;

	  foreach ($order["items"] as $key => $product)
	     {
	     $line_item_name = substr(strip_tags($product->order_item_name), 0, 127);
	     $line_id = substr(strip_tags($product->order_item_sku), 0, 127);
	     
	     //$cost = number_format($product->product_item_price,2,'.','');
	     
	     
	     $cost = $product->product_item_price;
	     
	     $cost = $paymentCurrency->convertCurrencyTo($method->payment_currency, $cost, false);
	     
	     $cost = number_format($cost,2,'.','');
	     
	

	     $line = $product->product_subtotal_with_tax;
	     
	     $line = $paymentCurrency->convertCurrencyTo($method->payment_currency, $line, false);
	     
	     $line = number_format($line,2,'.','');
	     

     
	     $qty = $product->product_quantity;
	     
	 
    	
$line_fields='';
    	
if (!empty($product->product_attribute))
	{
	if(!class_exists('VirtueMartModelCustomfields'))require(JPATH_VM_ADMINISTRATOR.DS.'models'.DS.'customfields.php');
	$line_fields = VirtueMartModelCustomfields::CustomsFieldOrderDisplay($product,'FE');
	}
	
$strip_line_fields = strip_tags($line_fields);

if($line_fields === '')
	{
	$line_description = substr($line_id, 0, 127);
	}
else
	{
	$line_description = substr($line_id . ' ' . $strip_line_fields, 0, 127);
	}

//$line_description = substr($line_id . $line_fields, 0, 127);
	     
	    $n = $i-1;
	    
	$line_order_details .= 
    "&L_NAME" . "$n=" . urlencode($line_item_name) .
    "&L_NUMBER" . "$n=" . urlencode($line_description) .
    "&L_QTY" . "$n=" . $qty .  
    "&L_AMT" . "$n=" . $cost;
    
   // $req["L_NAME$n"] = $line_item_name;
   // $req["L_NUMBER$n"] = $line_description;
  //  $req["L_QTY$n"] = $qty;
  //  $req["L_AMT$n"] = $cost;
    
   $req["L_NAME" . $n] = $line_item_name; 
	$req["L_DESC" . $n] = substr($strip_line_fields, 0, 127);
	$req["L_SKU" . $n] =  $line_id;
	$req["L_QTY" . $n] =  $qty;
	$req["L_COST" . $n] = $cost;
    
    
    
#trusted1 items   ## Tacking

	//$trusted_line_items .=
	//'<span class="gts-item">' .
	//'<span class="gts-i-name">' . urlencode($line_item_name) . '</span>' .
	//# urlencode($line_description) .
	//'<span class="gts-i-price">' . $cost . '</span>' .
	//'<span class="gts-i-quantity">' . $qty . '</span>' .
	//'</span>'; 
	
	
	/*
	{
            "name": "Product Name 1",
            "unit_amount": {
                "currency_code": "USD",
                "value": "10.00"
            },
        "quantity": "1"
        }
	 */
	
	if($i>1){$trusted_line_items = $trusted_line_items .  ',';}
	
	$trusted_line_items .=
	'{' .
	'"name": ' . json_encode($line_item_name) . ',' .
	# urlencode($line_description) .
		'"unit_amount":  {
					"value": ' . json_encode($cost) . ',
               "currency_code": ' . json_encode($currency_code_3) . '
               
            },' .
		'"quantity": ' . json_encode($qty) .
	'}'; 
	
	
## Tracking End    
    
   $line_order_total += $qty * $cost;
     
     
   $table = $table . '<tr>';    
   
   $table = $table . '<td valign="top">' . $line_id . "</td>"; 
     
   $table = $table . '<td valign="top">' . $line_item_name  . '&nbsp;' . $line_fields;   
     
   $table = $table . '</td>'; 
      
   $table = $table . '<td valign="top" align="right">' . $currency_symbol . $cost . "</td>"; 
      
   $table = $table . '<td valign="top" align="right">' . $qty . "</td>"; 
      
   $table = $table . '<td valign="top" align="right">&nbsp;&nbsp;' .  $currency_symbol . number_format($qty * $cost,2,'.','') . '</td>'; 
  
   
// $table = $table . '<td valign="top" align="right">&nbsp;&nbsp;' . number_format($line,2,'.','') . '</td>'; 
  
   $table = $table . '</tr>';
    
	     $i++;
	     
	     } 	  
	     	     


//order_payment ???
	  if(isset($order['details']['BT']->order_payment) && $order['details']['BT']->order_payment > 0)
	     {  
	     $order_payment = $order['details']['BT']->order_payment;
	     
         $order_payment = $paymentCurrency->convertCurrencyTo($method->payment_currency, $order_payment, false);
         
         $order_payment = number_format($order_payment,2,'.','');
	     
	     $n = $i-1;
	     
         $payment_fee = JText::_('VMPAYMENT_PPC_SSC_PAYMENT_FEE');
	     
	     $line_order_details .= 
         "&L_NAME" . "$n=" . urlencode($payment_fee) . 
         "&L_NUMBER" . "$n=" .
         "&L_QTY" . "$n=1" .  
         "&L_AMT" . "$n=" . $order_payment;
         
		//	$req["L_NAME$n"] = urlencode($payment_fee);
		//	$req["L_NUMBER$n"] = '';
		//	$req["L_QTY$n"] = 1;
		//	$req["L_AMT$n"] = $order_payment;
			
			
		$req["L_NAME" . $n] =  $payment_fee;
    	$req["L_DESC" . $n] =  '';
    	$req["L_SKU" . $n] =  '';
    	$req["L_QTY" . $n] =  1;
    	$req["L_COST" . $n] =  $order_payment;
			
  
         
         
      // #trusted 2 payment fee  ## Tracking Begin
      //  $trusted_line_items .=
		//	'<span class="gts-item">' .
		//	'<span class="gts-i-name">' . urlencode($payment_fee) . '</span>' .
			# urlencode($line_description) .
		//	'<span class="gts-i-price">' . $order_payment . '</span>' .
		//	'<span class="gts-i-quantity">1</span>' .
		//	'</span>';
## Tracking End
		  
		  	$trusted_line_items .=
	',{' .
	'"name": ' . json_encode($payment_fee) . ',' .
	'"unit_amount":  {
						"value": ' . json_encode($order_payment) . ',
						"currency_code": ' . json_encode($currency_code_3) . '
							},' .
	'"quantity": "1"' .
	'}';
		  
		  
		  
    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total + $order_payment;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4"><p align="right">' . htmlspecialchars($payment_fee) . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($order_payment,2,'.','') . '</td></tr>';

	     }



$table = $table . '<tr>';
$table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPC_SSC_ITEM_TOTAL') . ':&nbsp;</td>';
$table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($line_order_total,2,'.','') . '</td></tr>';     
	     
	    
$line_order_total = round($line_order_total,2);

$line_items_total =  $line_order_total;

$shipping = 0;

	if(isset($order['details']['BT']->order_shipment) && $order['details']['BT']->order_shipment > 0)
		{  
	    $shipping = $order['details']['BT']->order_shipment;
	    
	    
	    $shipping = $paymentCurrency->convertCurrencyTo($method->payment_currency, $shipping, false);    
	    
	    $shipping = number_format($shipping,2,'.','');
	     	     
		$table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPC_SSC_SHIPPING') .':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($shipping,2,'.','') . '</td></tr>';
	    }


//number_format($amount,2,'.','');

//start of surcharge adjustment

$total_tax = 0;

	  if(isset($order['details']['BT']->order_tax) && $order['details']['BT']->order_tax > 0)
	     {  
	     $total_tax = $order['details']['BT']->order_tax;
	     
	     $total_tax = $paymentCurrency->convertCurrencyTo($method->payment_currency, $total_tax, false);
	     }
	     
	  if(isset($order['details']['BT']->order_shipment_tax) && $order['details']['BT']->order_shipment_tax > 0)
	     {
         $order_shippment_tax = $order['details']['BT']->order_shipment_tax;
         
         $order_shippment_tax = $paymentCurrency->convertCurrencyTo($method->payment_currency, $order_shippment_tax, false);
         
	     $total_tax += $order_shippment_tax;
	     }

	  if(isset($order['details']['BT']->order_payment_tax) && $order['details']['BT']->order_payment_tax > 0)
	     {
         $order_payment_tax = $order['details']['BT']->order_payment_tax;
         
         $order_payment_tax = $paymentCurrency->convertCurrencyTo($method->payment_currency, $order_payment_tax, false);
         
	     $total_tax += $order_payment_tax;
	     }

	  
  	if(isset($order['details']['BT']->order_billTaxAmount) && $order['details']['BT']->order_billTaxAmount > 0)
	     {
         $order_bill_tax = $order['details']['BT']->order_billTaxAmount;
         
         $order_bill_tax = $paymentCurrency->convertCurrencyTo($method->payment_currency, $order_bill_tax, false);
         
         if($order_bill_tax > $total_tax)
         	{
	     	$total_tax = $order_bill_tax;
	     	//	echo 'Order bill tax set ' . $order_bill_tax;
	     	}
	     }

	  
	  
      if($total_tax > 0)
       {
	    $total_tax = number_format($total_tax,2,'.','');
	    
// add surcharge to tax total	    

	    $line_order_total2 = number_format($line_order_total,2,'.','');
		$shipping2 = number_format($shipping,2,'.','');
		$total_tax2 = number_format($total_tax,2,'.','');

		$order_total2 = $line_order_total2 + $shipping2 + $total_tax2;
		$order_total2 = number_format($order_total2,2,'.','');

		$cart_order_total2 = $order['details']['BT']->order_total;
		
#### begin convert ####		
$payment_currency = $method->payment_currency;
$cart_order_total2 = $paymentCurrency->convertCurrencyTo($payment_currency,$cart_order_total2,false);
####  end convert  ####			

		$cart_order_total2 = number_format($cart_order_total2,2,'.','');

		if($order_total2 < $cart_order_total2)
			{  
			$total_discount2 = $cart_order_total2 - $order_total2;
	     
			//$order_total2 = $cart_order_total2;
			$total_discount2 = number_format($total_discount2,2,'.','');
			    
	    	//if($total_tax-$total_discount2>0)
	    	//	{
	    		$total_tax += $total_discount2;
	    	//	}
	    
	    	}

//end of surchange adjustment


		$table = $table . '<tr>';
		$table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPC_SSC_TAX') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($total_tax,2,'.','') . '</td></tr>';


	     }
	     
	     
$total_discount = 0;
//billDiscountAmount

/*
	  if(isset($order['details']['BT']->coupon_discount) && $order['details']['BT']->coupon_discount > 0)
	     {  
	     $total_discount = $order['details']['BT']->coupon_discount;
	     
         $total_discount = $paymentCurrency->convertCurrencyTo($method->payment_currency, $total_discount, false);
         
         $total_discount = number_format($total_discount,2,'.','');
	     
	     $n = $i-1;
	     
	     $line_order_details .= 
         "&L_NAME" . "$n=Coupon+Discount" . 
         "&L_NUMBER" . "$n=$order->couponCode" .
         "&L_QTY" . "$n=1" .  
         "&L_AMT" . "$n=-" . $total_discount;
    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total - $total_discount;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4"><p align="right">Coupon:&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' . number_format($total_discount,2,'.','') . '</td></tr>';

	     }
	     
	     
$total_discount = 0;
//billDiscountAmount
	  if(isset($order['details']['BT']->order_billDiscountAmount) && $order['details']['BT']->order_billDiscountAmount >0)
	     {  
	     $total_discount = $order['details']['BT']->order_billDiscountAmount;
	     
         $total_discount = $paymentCurrency->convertCurrencyTo($method->payment_currency, $total_discount, false);
         
         $total_discount = number_format($total_discount,2,'.','');
	     
	     // $total_discount = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $total_discount, false),2);
	     
	     $n = $i-1;
	     
	     $line_order_details .= 
         "&L_NAME" . "$n=Discount" . 
         "&L_NUMBER" . "$n=Discount" .
         "&L_QTY" . "$n=1" .  
         "&L_AMT" . "$n=-" . $total_discount;
    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total - $total_discount;
    
	     $i++;
	     
	    $table = $table . '<tr>';
	    $table = $table . '<td colspan="4"><p align="right">Discount:&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' . number_format($total_discount,2,'.','') . '</td></tr>';

	     }
*/


$line_order_total = number_format($line_order_total,2,'.','');
$shipping = number_format($shipping,2,'.','');
$total_tax = number_format($total_tax,2,'.','');

$order_total = $line_order_total + $shipping + $total_tax;
$order_total = number_format($order_total,2,'.','');


$cart_order_total = $order['details']['BT']->order_total;

#### begin convert ####		
$payment_currency = $method->payment_currency;
$cart_order_total = $paymentCurrency->convertCurrencyTo($payment_currency,$cart_order_total,false);
####  end convert  ####	

$cart_order_total = number_format($cart_order_total,2,'.','');

if($order_total > $cart_order_total)
	     {  
	     $total_discount = $cart_order_total - $order_total;
	     
	     $order_total = $cart_order_total;
	     
         $total_discount = number_format($total_discount,2,'.','');
	     
	     $n = $i-1;
	     
	     $line_order_details .= 
         "&L_NAME" . "$n=Discount" . 
         "&L_NUMBER" . "$n=Discount" .
         "&L_QTY" . "$n=1" .  
         "&L_AMT" . "$n=" . $total_discount;
         
    //$req["L_NAME$n"] = 'Discount';
    //$req["L_NUMBER$n"] = 'Discount';
    //$req["L_QTY$n"] = 1;
    //$req["L_AMT$n"] = $total_discount;
    
  // $req["L_NAME" . "$n"] =  'Discount';
  // $req["L_DESC" . "$n"] =  '';
  //  $req["L_QTY" . "$n"] =  '1';
  //  $req["L_COST" . "$n"] =  $total_discount;
  //  $req["L_SKU" . "$n"] =  'Discount';
    
#trusted3 discount ## Tracking
        
 // 	$trusted_line_items .=
//	'<span class="gts-item">' .
//	'<span class="gts-i-name">Discount</span>' .
	# urlencode($line_description) .
//	'<span class="gts-i-price">$total_discount</span>' .
//	'<span class="gts-i-quantity">1</span>' .
//	'</span>';   
	
	
	
	

## Tracking End

 #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total + $total_discount;
    
	     $i++;
	     
        $table = $table . '<tr>';
  	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPC_SSC_DISCOUNT') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($total_discount,2,'.','') . '</td></tr>';

	     }


if($order_total < $cart_order_total)
	     {  
	     $adjustment = $cart_order_total - $order_total;
	     
	     $order_total = $cart_order_total;
	     
         $adjustment = number_format($adjustment,2,'.','');
	     
	     $n = $i-1;
	     
	     $line_order_details .= 
         "&L_NAME" . "$n=Surcharge" . 
         "&L_NUMBER" . "$n=Surcharge" .
         "&L_QTY" . "$n=1" .  
         "&L_AMT" . "$n=" . $adjustment;
        
    //$req["L_NAME$n"] = 'Surcharge';
    //$req["L_NUMBER$n"] = 'Surcharge';
    //$req["L_QTY$n"] = 1;
    //$req["L_AMT$n"] = $adjustment;
    
    $req["L_NAME" . $n] =  'Adjustment';
    $req["L_DESC" . $n] =  'Adjustment';
    $req["L_QTY" . $n] =  '1';
   // $req["L_COST" . $n] =  $total_surcharge;
	$req["L_COST" . $n] =  $adjustment;
	 
    $req["L_SKU" . $n] =  'Adjustment';
        
        
    
 #trusted4 Surcharge ## Tracking
	//    $trusted_line_items .=
	//		'<span class="gts-item">' .
	//		'<span class="gts-i-name">Adjustment</span>' .
	//		# urlencode($line_description) .
	//		'<span class="gts-i-price">$adjustment</span>' .
	//		'<span class="gts-i-quantity">1</span>' .
	//		'</span>';

			  	$trusted_line_items .=
	',{' .
	'"name": ' . json_encode('Ajustment') . ',' .
	'"unit_amount":  {
							"value": ' . json_encode($adjustment) . ',
							"currency_code": ' . json_encode($currency_code_3) . '					
							},' .
	'"quantity": "1"' .
	'}';
		
		
		

        #    urlencode($line_item_name) . //## Tracking End
    
         $line_order_total = $line_order_total + $adjustment;
			
			$line_items_total =  number_format($line_order_total,2,'.','');
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPC_SSC_SURCHARGE') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($adjustment,2,'.','') . '</td></tr>';


		 
	     }





	    $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPC_SSC_ORDER_TOTAL') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($order_total,2,'.','') . '</td></tr>';

 $table .= '</table>';


 if(isset($_POST["APIOperation"]))
	{
	 
	 $table = '';
 }
 
##pplan

//list($html,$use_profile,$profile_error) = $this->get_payment_name($method,$order_total,$order);


//$table .= $html;

//$table .= $method->payment_name;

//$method->debug = 0;

/*
  if($method->debug)
     {
		echo '<span style="color: ' . '#' . 'FF0000">';
		echo "<br/>You have enabled debugging in setup. Turn it off to remove any debug information<br/><br/>";
		echo '</span>';  
		print_r($order);
     }
*/

return array($table,$return_button,$order_total,$line_order_total,$total_discount,$total_tax,$shipping,$line_order_details,$trusted_line_items,$req,$line_items_total);

}

  
function get_payment_name($method,$order_total,$order)
	{
	$html ='';
	$first_payment_html = '';
	
	
	
	$cart = VirtueMartCart::getCart ();
	
	//print_r($cart);
	
	
	#### begin check #####
	

$use_profile = 0;
$no_profile_trig = 0;
$profile_error=0;
$profile_trig = 0;

//if(!isset($cart->pricesUnformatted["billTotal"]))
//	{	
//	return array($html,$use_profile,$profile_error,$first_payment_html);
//	}

//foreach ($order["items"] as $key => $product)
//	{
	
if($order)
	{
	$products = $order["items"];
	}
else
	{
	if(!isset($cart->pricesUnformatted["billTotal"]))
	{	
	return array($html,$use_profile,$profile_error,$first_payment_html);
	}
	
	$products = $cart->products;
	}

foreach ($products as $key => $product)
	{
	
	if($order)
		{
		$line_id = substr(strip_tags($product->order_item_sku), 0, 127);
		$line_item_name = substr(strip_tags($product->order_item_name), 0, 127);
		}
	else
		{
		$line_id = substr(strip_tags($product->product_sku), 0, 127);
		$line_item_name = substr(strip_tags($product->product_name), 0, 127);
		}
	
	$PPlan = $method->ssc_pplan_id;
	
#echo $PPlan;

	if((preg_match("/Recurring/i",$line_id)) || (preg_match("/Month/i",$line_id)) || (preg_match("/$PPlan/i",$line_id)))
		{
	
	   $use_profile=1;
		$profile_trig = 1;
		
		if((preg_match("/Recurring/i",$line_id)) || (preg_match("/Month/i",$line_id)))
			{
			$recurring = 1;
			}

		if(preg_match("/$PPlan/i",$line_id))
			{
			$pplan=1;
			}
	   
		}
	else
		{
		$no_profile_trig = 1;
		}
	
	if($no_profile_trig == 1 && $profile_trig == 1)
		{
		$profile_error=1;
		}
			
	}	


//	echo '<br> no profile trig';
//	echo $no_profile_trig;
//	echo '<br> profile trig';
//	echo $profile_trig;
//	echo '<br> profile error';
//	echo $profile_error;
//	echo '<br>';
		

if($use_profile == 0)
	{
	//return array($html,$use_profile,$profile_error,$first_payment_html);
	return array('',$use_profile,$profile_error,'');
	}

	//echo '--this:' . $this_profile . '++first' . $first_profile . '===';
	//$i++;

	
	#### end check ####################
	
	
	
	

	$pplan_INITAMT = $method->ssc_pplan_INITAMT;

	$pplan_BILLINGPERIOD = $method->ssc_pplan_BILLINGPERIOD;
	
	
	// Joomla 2.5 begin

	$pplan_TOTALBILLINGCYCLES = 1;

	if($method->ssc_pplan_TOTALBILLINGCYCLES > 1)
		{
		$pplan_TOTALBILLINGCYCLES = $method->ssc_pplan_TOTALBILLINGCYCLES;
		}

	//$pplan_TOTALBILLINGCYCLES = $method->ssc_pplan_TOTALBILLINGCYCLES;
	
	// Joomla 2.5 end
	
	$pplan_BILLINGFREQUENCY = $method->ssc_pplan_BILLINGFREQUENCY;

		
		
	$payments = $order_total;// - $pplan_admin_fee;
		
		
	$no_of_payments = $pplan_TOTALBILLINGCYCLES;
		
		
	if($pplan_INITAMT == '1')
		{
		$no_of_payments = $pplan_TOTALBILLINGCYCLES + 1;
		}
		
		
	date_default_timezone_set('UTC');
	$t=time();
	$zulu = date("Y-m-d");

	if($method->ssc_pplan_defer == '1')
		{
		$zulu = $method->ssc_pplan_defer_date;
		}	
		
		
		
//	$pppitems = array();

if($order_total == 0)
	{
	$order_total = $cart->pricesUnformatted["billTotal"];
	$order_total = number_format($order_total ,2,'.','');
	}
		
	//echo '<br>Bill Total: ' . 	$cart->pricesUnformatted["billTotal"];
	//echo '<br>Payment Tax' . 	$cart->pricesUnformatted["paymentTax"];
	//echo '<br>Payment Tax' . 	$cart->pricesUnformatted["paymentValue"];
	//echo '<br>Payment Total' . 	$cart->pricesUnformatted["paymentTotal"];
	//echo '<br>Payment Total: ' . 	$order_total;
	
		
	$order_payment = 0;
	
	
	if(isset($cart->pricesUnformatted["paymentValue"]) && $cart->pricesUnformatted["paymentValue"] > 0)
		{  
		//echo 'a';
		$order_payment = $cart->pricesUnformatted["paymentValue"];
		}

	if(isset($order['details']['BT']->order_payment) && $order['details']['BT']->order_payment > 0)
		{
		//echo 'b'; 
		$order_payment = $order['details']['BT']->order_payment;
		}
		
	//echo $order_payment;	
		
	$order_payment_tax = 0;
	
	
	if(isset($cart->pricesUnformatted["paymentTax"]) && $cart->pricesUnformatted["paymentTax"] > 0)
		{
		//echo 'c';
		$order_payment_tax = $cart->pricesUnformatted["paymentTax"];
		}

	
	
	if(isset($order['details']['BT']->order_payment_tax) && $order['details']['BT']->order_payment_tax > 0)
		{
		//echo 'd'; 
		$order_payment_tax = $order['details']['BT']->order_payment_tax;
		}
		
		
	//echo $order_payment_tax;
		
	if($order_total > 0)
		{
		$payments = $order_total - $order_payment - $order_payment_tax;// - $pplan_admin_fee;
		
		$installment = $payments/$no_of_payments;
		
		$installment = floor($installment * 100) / 100;
		
		$remainer = $payments - ($installment*$no_of_payments);
		
		$INITAMT = $installment + $remainer + $order_payment + $order_payment_tax;
		
		$INITAMT = number_format($INITAMT,2,'.','');
		
		$installment = number_format($installment,2,'.','');
		
				//$this->getPaymentCurrency($method); //?????


$paymentCurrency = 0;

if(isset($cart->paymentCurrency))				
	{
	$paymentCurrency = $cart->paymentCurrency;
	}
	
//$method->payment_currency				

$q = 'SELECT `currency_symbol` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $paymentCurrency . '" ';
$db = JFactory::getDBO();
$db->setQuery($q);
$currency_symbol = $db->loadResult();


$payment_due = 1;

if($method->ssc_BILLINGPERIOD == 'None' && $method->ssc_pplan_BILLINGPERIOD == 'None')
	{
	$payment_due = 0;
	}


		if($pplan_INITAMT == '1')
			{
			$no_of_payments = $pplan_TOTALBILLINGCYCLES + 1;
			$html .= "Pay in $no_of_payments instalments.<br>";
			
			if($payment_due == 1)
				{
				$html .= "First payment of $currency_symbol$INITAMT payable immediately,<br>followed by $pplan_TOTALBILLINGCYCLES $pplan_BILLINGPERIOD" . "ly payments of $currency_symbol$installment starting on the $zulu";
				}
			}
		else
			{
			$html .= "<br>Pay in $pplan_TOTALBILLINGCYCLES instalments of $currency_symbol$installment<br>";
			if($payment_due == 1)
				{
				$html .= "First Payment on $pplan_INITAMT $zulu<br/>";
				}
			}
		}
	else
		{
		if($pplan_INITAMT == '1')
			{
			$no_of_payments = $pplan_TOTALBILLINGCYCLES + 1;
			$html .= "<br>Pay in $no_of_payments instalments.<br>";
			if($payment_due == 1)
				{
				$html .= "First payment payable immediately,<br>followed by $pplan_TOTALBILLINGCYCLES $pplan_BILLINGPERIOD" . "ly payments starting on the $zulu";
				}
			}
		else
			{
			$html .= "<br>Pay in $pplan_TOTALBILLINGCYCLES instalments.<br>";
			if($payment_due == 1)
				{
				$html .= "First Payment on $pplan_INITAMT $zulu<br/>";
				}
			}
	
	}
	
	
	$first_payment_html = "First payment of $currency_symbol$INITAMT ";
	
	if($use_profile == 0)
		{
		$html = '';
		$first_payment_html = '';
		}
	
	return array($html,$use_profile,$profile_error,$first_payment_html);


	}
	
	
	function create_access_token($clientId,$secret,$paypal_url)
{
	
	 
$ch = curl_init();


$headers = array(
'Content-type: application/json',
'Accept-Language: en_US'
);

curl_setopt($ch, CURLOPT_URL, "https://" . $paypal_url . "/v1/oauth2/token");
#curl_setopt($ch, CURLOPT_HEADER, false);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
//curl_setopt($ch, CURLOPT_SSLVERSION , 6); //NEW ADDITION
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); 
curl_setopt($ch, CURLOPT_USERPWD, $clientId.":".$secret);
curl_setopt($ch, CURLOPT_POSTFIELDS, "grant_type=client_credentials");
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);


$result = curl_exec($ch);

if(empty($result))
	{
	echo 'Curl error: ' . curl_error($ch);
	}
else
	{
   $json = json_decode($result);
	
	if(isset($json->error))
		{
		echo '<b>Error</b><br><br>';
		if(isset($json->error_description))
			{
			//echo "<b>Client ID: $clientId </b><br><br>";
			echo "<b>PayPal Url: $paypal_url </b><br><br>";
			echo "<b>$json->error_description</b><br><br>";
			echo '<b>There has been an error<br><br>Check your Client ID and Secret</b><br><br>';
			#print_r($json);
			}
		
		}
 #  print_r($json);
	$access_token = $json->access_token;
	//	 echo '<br>access_token: ';
	//	 echo $access_token;
	//	 echo '<br>';
	}

curl_close($ch);

return $access_token;
	
}

#curl -X POST https://api-m.sandbox.paypal.com/v1/identity/generate-token \

#-H 'Content-Type: application/json' \

#-H 'Authorization: Bearer <ACCESS-TOKEN>' \

#-H 'Accept-Language: en_US' \
	
	
	function generate_client_token($access_token,$paypal_url)

{
	
	
	$ch = curl_init();
 #CURLOPT_HTTPHEADER, array('Connection: Close'));
$headers = array(
'Content-type: application/json',
'Authorization: Bearer ' . $access_token,
'Accept-Language: en_US'
);


$postfields = '{}';

curl_setopt($ch, CURLOPT_URL, "https://" . $paypal_url . "/v1/identity/generate-token");
//curl_setopt($ch, CURLOPT_HEADER, false);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
//curl_setopt($ch, CURLOPT_SSLVERSION , 6); //NEW ADDITION
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); 
//curl_setopt($ch, CURLOPT_USERPWD, $clientId.":".$secret);
curl_setopt($ch, CURLOPT_POSTFIELDS, $postfields);
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);

if(empty($result))
	{
	echo 'Curl error: ' . curl_error($ch);
	}
else
	{
   $json = json_decode($result);
  # print_r($json);
	
	#echo '<br>Access Token: ';
	#echo $access_token;
	#echo '<br>JSON: ';
   #print_r($json);
	#echo '<br>PayPal URL: ';
	#echo $paypal_url;
	#echo '<br>';
	
	 
	$client_token = $json->client_token;
	//echo '<br>client_token:&nbsp;';
	//echo $client_token;
	//echo '<br>';
	}

$client_token = trim($json->client_token);

//	$id_token = $json->id_token;

curl_close($ch);

return $client_token;
	
}


function patch_payment($invoice_num,$amount,$pppitems,$shipping_address,$apiContext)//,$id,$payer,$payerinfo)
{

$patchRequest = new \PayPal\Api\PatchRequest();
/*			
$patch = new \PayPal\Api\Patch();
$patch->setOp('add')
   ->setPath('/payer/payerinfo')
   ->setValue($payerinfo);

$patchRequest->addPatch($patch); 
*/
/*
if($id != null)
	{
	$patch = new \PayPal\Api\Patch();
	$patch->setOp('add')
		->setPath('/experience_profile_id')
		->setValue($id);
	$patchRequest->addPatch($patch);
	}
*/

$patch = new \PayPal\Api\Patch();
$patch->setOp('replace')
    ->setPath('/transactions/0/invoice_number')
    ->setValue($invoice_num);

$patchRequest->addPatch($patch); 

/*
$pppitems = array();

	$pppitem = new \PayPal\Api\Item();
  

    $pppitem->setName('Test Item')
    ->setCurrency('EUR')
    ->setQuantity('1')
    ->setSku('TestSKU') // Similar to `item_number` in Classic API
    ->setPrice('142.00');
    
$pppitems[0] = $pppitem;


$patch->setOp('replace')
   ->setPath('/transactions/0/item_list/items')
   ->setValue($pppitems);

$patchRequest->addPatch($patch);  //******************

$patch = new \PayPal\Api\Patch();
$details = new \PayPal\Api\Details();
$details->setShipping('2.49')
	->setTax('28.70')
	->setSubtotal('142.00');

$amount = new \PayPal\Api\Amount();
$amount->setCurrency($processor_currency_code_3)
	->setTotal('173.19')
	->setDetails($details);

$patch->setOp('replace')
    ->setPath('/transactions/0/amount')
    ->setValue($amount);

$patchRequest->addPatch($patch);   //************************


$patch = new \PayPal\Api\Patch();


$patch->setOp('add')
    ->setPath('/transactions/0/item_list/shipping_address')
    ->setValue(json_decode('{
                    "recipient_name": "Gruneberg, Anna",
                    "line1": "52 N Main St",
                    "city": "San Jose",
                    "state": "CA",
                    "postal_code": "95112",
                    "country_code": "US"
                }'));

$patchRequest->addPatch($patch); // ********************
*/

//$details = new \PayPal\Api\Details();
//$details->setShipping($shipping)
//	->setTax($total_tax)
//	->setSubtotal($line_order_total);

//$amount = new \PayPal\Api\Amount();
//$amount->setCurrency($processor_currency_code_3)
//	->setTotal($order_total)
//	->setDetails($details);

$patch = new \PayPal\Api\Patch();

$patch->setOp('replace')
   ->setPath('/transactions/0/amount')
   ->setValue($amount);

$patchRequest->addPatch($patch); 

$patch = new \PayPal\Api\Patch();


$patch->setOp('replace')
   ->setPath('/transactions/0/item_list/items')
   ->setValue($pppitems);

$patchRequest->addPatch($patch);


$patch = new \PayPal\Api\Patch();

$patch->setOp('add')
    ->setPath('/transactions/0/item_list/shipping_address')
    ->setValue($shipping_address);

$patchRequest->addPatch($patch); 

$session = JFactory::getSession();
$paymentId = $session->get('ppp_payment_id');


$db = JFactory::getDBO();

try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_paypalcheckoutssc` SET `paymentId` = '" . $paymentId . "' WHERE `order_number` = '" .  $invoice_num . "'";

	$db->setQuery($q);
	//$db->query($q);
	$result = $db->execute();

	}
catch (Exception $e)
	{
	echo $e->getMessage();
	}


//	$q = "SELECT `order_number` FROM `#__virtuemart_payment_plg_paypalcheckoutssc` WHERE `paymentId` = '" .  $paymentId . "'";
//	$db->setQuery($q);
//	$number = $db->loadResult();

//echo '##############' . $number . '************';



$payment = Payment::get($paymentId, $apiContext);

//echo $payment->getState();

if($payment->getState() != 'created')
	{
	echo 'This payment has already been processed<br/><br/>';
	return;
	//created", "approved", "failed", "partially_completed", "in_progress"
	}


try
	{
	$result = $payment->update($patchRequest, $apiContext);
	}
catch (Exception $ex)
	{
	
	echo 'Patch Exception:<br><br>' . $ex;
	
	}


//echo $paymentId;
//print '############################################<br>';	

$patched_payment = Payment::get($payment->getId(), $apiContext);
	
$link = $patched_payment->getApprovalLink();
//		print '<br>########### result 2 #################################<br>';
//		print_r($patched_payment);
		
return $link;
	
	
}




















function get_payment_params()
	{
	/*
	virtuemart_paymentmethods

	[virtuemart_paymentmethod_id] =>
	[virtuemart_vendor_id] =>
	[payment_jplugin_id] => 
	[payment_name] => 
	[payment_desc] => 
	[slug] => paypal-plus-ssc
	[payment_element] => paypalcheckoutssc
	[payment_params] => 
	[currency_id] => 
	[ordering] => 
	[shared] =>
	[published] =>
	*/
	$payment_params = null;
	
	$db = JFactory::getDbo();
	$q = 'SELECT `payment_params` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "paypalcheckoutssc" AND `published` = 1';
	
	$db->setQuery($q);
		
	$payment_string = $db->loadResult();
	
	$pairs = explode("|", $payment_string);
		
	foreach ($pairs as $pair)
		{
		if (empty($pair))
			{
			continue;
			}
		
		$temp = explode('=', $pair);
		$payment_params[$temp[0]] = substr($temp[1], 1, -1);
		}
		
		
	$vendorModel = VmModel::getModel('Vendor');
	$vendorModel->setId(1);
	$vendor = $vendorModel->getVendor();
	$currency_id = $vendor->vendor_currency;
	
	$payment_params['currency_id']	= $currency_id;

	//	echo '################';
	//	echo $payment_params['currency_id'];
	
	return $payment_params;
	}
	

function redirectToCart ($msg = NULL)
	{
	if($msg != NULL)
		{
		$session = JFactory::getSession();
		$session->set('ssc_message', $msg);
		}
	else
		{
		$session = JFactory::getSession();
		$session->set('ssc_message', '');
		}

	if (!$msg)
		{
		$msg = vmText::_('VMPAYMENT_PAYPAL_ERROR_TRY_AGAIN');
		}
			
			
	//		$app = JFactory::getApplication();

	//$app->enqueueMessage('Redirect to another page was successful', 'success');
	//$app->redirect(JRoute::_('index.php'));	
	//$this->customerData->clear();
	$app = JFactory::getApplication();
	$app->enqueueMessage($msg,JText::_('VMPAYMENT_PPC_SSC_ERROR_CONNECTING_TO_SERVER'));
	//$app->redirect(JRoute::_('index.php?option=com_virtuemart&view=cart&Itemid=' . JRequest::getInt('Itemid'), false));
	$app->redirect(JRoute::_('index.php?option=com_virtuemart&view=cart', false));
	
	}






function opc_enabled()
	{
	$opc = 0;
	$vp_opc = 0;
	$opc_enabled = 0;

	//VmConfig::loadConfig();
	//$vm_opc = vmConfig::get('oncheckout_opc',"0");
	//	vmConfig::set('oncheckout_opc', true);	
	//
	//if($method->ssc_one_page == '1' && $vm_opc == '0')
	
	$db = JFactory::getDbo();
	//$db->setQuery("SELECT `enabled` FROM `#__extensions` WHERE `name` = 'plg_system_opc'");
	//$opc_enabled = $db->loadResult();
	//$opc = $opc_enabled;

	if($opc_enabled != '1')
		{
		$db->setQuery("SELECT `enabled` FROM `#__extensions` WHERE `name` = 'VP One Page Checkout'");
		$opc_enabled = $db->loadResult();
		$vp_opc = $opc_enabled;
		}

	if($opc_enabled != '1')
		{
		$db->setQuery("SELECT `enabled` FROM `#__extensions` WHERE `name` = 'System - VP One Page Checkout'");
		$opc_enabled = $db->loadResult();
		$vp_opc = $opc_enabled;
		}

	return $opc_enabled;
	}

        
        



function handlePaymentUserCancel ($virtuemart_order_id)
	{
	if ($virtuemart_order_id)
		{
		// set the order to cancel , to handle the stock correctly
		if (!class_exists ('VirtueMartModelOrders'))
			{
			require(VMPATH_ADMIN . '/' . 'models' . '/' . 'orders.php');
			}

		$modelOrder = VmModel::getModel ('orders');
		$order['order_status'] = 'X';
		$order['virtuemart_order_id'] = $virtuemart_order_id;
		$order['customer_notified'] = 0;
		$order['comments'] = vmText::_ ('COM_VIRTUEMART_PAYMENT_CANCELLED_BY_SHOPPER');
		$modelOrder->updateStatusForOneOrder ($virtuemart_order_id, $order, TRUE);
		//$modelOrder->remove (array('virtuemart_order_id' => $virtuemart_order_id));
		}
	}



// return from PayPal
// $cart is null
// $order is null
// find cart in session and make order

function update_cart($token,$PayerID)
{

$db = JFactory::getDbo();
$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "paypalcheckoutssc" AND `published` = 1';
$db->setQuery($q);
$virtuemart_paymentmethod_id = $db->loadResult();
$method = $this->getVmPluginMethod($virtuemart_paymentmethod_id);

if($virtuemart_paymentmethod_id == null)
{
return;
}

$session = JFactory::getSession();
$session->set('session_token', $token);
$session->set('session_PayerID', $PayerID);

$session_token = $session->get('session_token');


$APIrequest =
"&TOKEN=" . $token .

"&PAYMENTACTION=" . $method->ssc_payment_action;
//"&IPADDRESS=" . $ipaddress .

//"&RETURNURL=". urlencode($ReturnURL) . urlencode('&pectransid=' . $order["details"]["BT"]->order_number) .
//encode twice

//"&CANCELURL=". urlencode($CancelURL) .

//"&INVNUM=" . urlencode($cart->virtuemart_order_id) .
# new custom field 23-11-11
//"&CUSTOM=" . 
#"&SHIPPINGOPTIONNAME=" . $ _POST["pro_shipping"] .

//"&LOCALECODE=" . $cc_country .

//"&CURRENCYCODE=" . $currency_code_3 .
//"&ITEMAMT=" . $line_order_total .
//"&SHIPPINGAMT=" . $shipping .
//"&TAXAMT=" . $total_tax .
//"&AMT=" . $amount .

//"&SHIPTONAME=" . urlencode($del_address->first_name . ' ' . $del_address->last_name) .
//"&SHIPTOSTREET=" . urlencode($del_address->address_1) .
//"&SHIPTOSTREET2=" . urlencode($del_address->address_2) .
//"&SHIPTOSTATE=" . urlencode($del_state) . 
//"&SHIPTOCITY=" . urlencode($del_address->city) . 
//"&SHIPTOZIP=" . urlencode($del_address->zip) .
//"&SHIPTOCOUNTRYCODE=" . urlencode($del_country) .
//"&SHIPTOPHONENUM=" . urlencode($address->phone_1) .


//"&EMAIL=" . urlencode($address->email) .

//$line_order_details .


$httpResponse = $this->PPHttpPost($method,"GetExpressCheckoutDetails", $APIrequest);


//if(isset($httpResponse['AMT']))
//	{
//	$ssc_AMT = urldecode($httpResponse['AMT']);
//	$session->set('session_ssc_AMT', $ssc_AMT);
//	}




// ************* begin mods for save address****************************



$first_name = '';
$middle_name ='';
$last_name = '';
$address_1 = '';
$address_2 = '';
$house_no = '';
$zip = '';
$city = '';
$state_name='';
$state_id='0';
$virtuemart_country_id='';
$phone_1='';
$email = '';

//print_r($httpResponse);

if(isset($httpResponse['FIRSTNAME']))
	{
	$first_name = urldecode($httpResponse['FIRSTNAME']);
	}

if(isset($httpResponse['MIDDLENAME']))
	{
	$middle_name = urldecode($httpResponse['MIDDLENAME']);
	}

if(isset($httpResponse['LASTNAME']))
	{
	$last_name = urldecode($httpResponse['LASTNAME']);
	}


if(isset($httpResponse['FIRSTNAME']) && isset($httpResponse['LASTNAME']))
	{
	if(urldecode($httpResponse['SHIPTONAME']) == urldecode($httpResponse['FIRSTNAME']) . ' ' . urldecode($httpResponse['LASTNAME']))
		{
		$first_name = urldecode($httpResponse['FIRSTNAME']);
		$last_name = urldecode($httpResponse['LASTNAME']);
		}
	else
		{
		$shipToName = explode(' ', urldecode($httpResponse['SHIPTONAME']));
		$first_name = $shipToName[0];
		$last_name = '';
		if (count($shipToName) > 1)
			{
			$last_name = str_replace($first_name . ' ', '', urldecode($httpResponse['SHIPTONAME']));
			}
		}
	}	


if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOSTREET']))
	{
	$address_1 = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOSTREET']);
	}


if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOCITY']))
	{
	$city = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOCITY']);
	}

if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOZIP']))
	{
	$zip = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOZIP']);
	}
	
	
if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE']))
	{
	$cc = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE']);
	$virtuemart_country_id = ShopFunctions::getCountryIDByName($cc);
	}


if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOSTATE']))
	{
	$state_name = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOSTATE']);
	
	
	if(strlen($state_name) === 2)
		{
		$q = 'SELECT `virtuemart_state_id` FROM `#__virtuemart_states` WHERE `state_2_code`="' . $state_name . '" ';
		$db = JFactory::getDBO();
		$db->setQuery($q);
		$state_id_2 = $db->loadResult();
		//echo 'state id 2:' . $state_id_2;

		if(!is_null($state_id_2))
			{
			$state_id = $state_id_2;
			}
		
		//$city .= ' ' . urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOSTATE']);
		$city = trim($city);	
		}
	
	if(strlen($state_name) > 2)
		{
		$q = 'SELECT `virtuemart_state_id` FROM `#__virtuemart_states` WHERE `state_name`="' . $state_name . '" ';
		$db = JFactory::getDBO();
		$db->setQuery($q);
		$state_id_3 = $db->loadResult();
		//echo 'state id 3:' . $state_id_3;

		if(!is_null($state_id_3))
			{
			$state_id = $state_id_3;
			}
		else
			{
			$city .= ' ' . urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOSTATE']);
			$city = trim($city);	
			}
		}

	}

	
//if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOPHONENUM']))
//	{
//	$phone_1 = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOPHONENUM']);
//	}

if(isset($httpResponse['PHONENUM']))
	{
	$phone_1 = urldecode($httpResponse['PHONENUM']);
	}


	
if(isset($httpResponse['EMAIL']))
	{
	$email = urldecode($httpResponse['EMAIL']);
	}



/////// begin update_data array

if(!class_exists('VirtueMartCart')) require(JPATH_VM_SITE . '/' . 'helpers' . '/' . 'cart.php');
		$cart = VirtueMartCart::getCart();

//$test = array_filter($cart->BT);xx
//$cart->BT['last_name']

$address_type='BT';
$cart->STsameAsBT = 1;
$prefix = '';

//if (!empty($test)) xx
//if($cart->BT <> 0)
if(isset($cart->BT['last_name']))
	{
	$address_type='ST';
	$prefix = 'shipto_';
	$cart->STsameAsBT = 0;
//	echo '********* not empty *******************';
	}
//else
//	{
//	echo '********* empty *******************';
//	}


$update_data = array(
$prefix . 'address_type_name'     => 'PayPal Shipping Address',
$prefix . 'company'               => '',
$prefix . 'title'                 => '',
$prefix . 'first_name'            => $first_name,
$prefix . 'middle_name'           => $middle_name,
$prefix . 'last_name'             => $last_name,
$prefix . 'address_1'             => $address_1,
$prefix . 'address_2'             => $address_2,
$prefix . 'house_no'              => '',
$prefix . 'zip'                   => $zip,
$prefix . 'city'                  => $city,
$prefix . 'virtuemart_country_id' => $virtuemart_country_id,
$prefix . 'virtuemart_state_id'   => $state_id,
$prefix . 'phone_1'               => $phone_1,
$prefix . 'phone_2'               => '',
$prefix . 'fax'                   => '',
$prefix . 'birthday'              => '',
$prefix . 'socialNumber'          => '',
'address_type'                    => $address_type
);

//virtuemart_state_id

if ($address_type === 'BT')
	{
	$update_data['email'] = $email;
	}


/////// end update_data array

///if(!class_exists('VirtueMartCart')) require(JPATH_VM_SITE . '/' . 'helpers' . '/' . 'cart.php');
///		$cart = VirtueMartCart::getCart();

//*if ($this->cart->BT == 0 or empty($this->cart->BT))
//* $this->cart->STsameAsBT = 0;
//* $this->cart->setCartIntoSession ();
//* $this->cart->saveAddressInCart($addressST, 'ST', true);
	

$cart->saveAddressInCart($update_data, $update_data['address_type']);

$cart = VirtueMartCart::getCart ();
//$cart->dataValidated = TRUE;
$cart->setCartIntoSession();
//print_r($cart);

////////////////////////


//virtuemart_state_id virtuemart_userfields required
//virtuemart_userfield_id
//virtuemart_country_id
//name=
$extension_id='17';	
	
	try
	{	 
	$db = JFactory::getDBO();
	$query =
	"SELECT " . $db->quoteName('virtuemart_userfield_id') .
	" FROM " . $db->quoteName('#__virtuemart_userfields') .
	" WHERE " . $db->quoteName('name') ." = " . $db->quote('virtuemart_state_id').";";
	$db->setQuery($query);
	$extension_id = $db->loadResult();
	}
	catch (Exception $e)
		{
		//if($debug)
		//	{
		//	echo $e->getMessage();
    	//	}
		}


if($state_id === '' || $state_id == '0')
	{
	try
		{
	
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
		$fields = array($db->quoteName('required') . '=0');
	
		$conditions = array($db->quoteName('virtuemart_userfield_id') . '=' . $extension_id);
		//	$conditions = array($db->quoteName('name') . '=' . 'virtuemart_state_id');
	
		$query->update($db->quoteName('#__virtuemart_userfields'))->set($fields)->where($conditions);
		$db->setQuery($query);
		//$result = $db->query();
		$result = $db->execute();
		}
	catch (Exception $e)
		{
		//if($debug)
		//	{
		//	echo $e->getMessage();
    	//	}
		}
	
	
	}

$url= $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&amp;view=cart&amp;task=checkout&amp;mes=exp');


//echo '<br>Installed Version: ' . VmConfig::getInstalledVersion() . '<br>';

$ver = VmConfig::getInstalledVersion();
echo '<script type="text/javascript">
document.cookie = "c=1;path=/";
</script>
';


if($ver < '2.9')
	{
	print '
<form method="post" id="checkoutForm" name="checkoutForm" action="' . $url . '">';
	print "
	<input type='hidden' id='token' name='token' value='$token'/>
	<input type='hidden' name='PayerID' value='$PayerID'/>
	<input type='hidden' id='STsameAsBT' name='STsameAsBT' value='" . $cart->STsameAsBT . "'/>
	<input type='hidden' name='task' value='checkout'/>
	<input type='hidden' name='option' value='com_virtuemart'/>
	<input type='hidden' name='view' value='cart'/>
	<input type='submit' value='Connecting to server: Please wait'/>
	</form>";
	}

//VmConfig::getInstalledVersion();


$url= $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&amp;view=cart&amp;mes=exp');

if($ver >= '2.9')
	{
	print '
	<form method="post" id="checkoutForm" name="checkoutForm" action="' . $url . '">';

	print "
	<input type='hidden' name='token' value='$token'/>
	<input type='hidden' name='PayerID' value='$PayerID'/>
	<input type='hidden' name='task' value='updatecart'/>
	<input type='hidden' name='option' value='com_virtuemart'/>
	<input type='hidden' name='view' value='cart'/>
	<input type='submit' value='Connecting to server: Please wait'/>
	</form>";
	}
	
//*<input type='hidden' name='checkout' value='1'/>
//*<input type="hidden" name="tos" value="1" />
//*<input name="order_language" value="en-GB" type="hidden">
//<input type='hidden' name='STsameAsBT' value='" . $cart->STsameAsBT . "'/>
//<input type='hidden' name='task' value='updatecart'/> xx

//<input type='hidden' name='customer-comment' value=''/>

//<input type='hidden' name='order_language' value='en-GB'/>
//<input type='hidden' id='token' name='customer_comment' value='$customer_comment'/>

if(!$method->debug)
   {
   print '<script type="text/javascript">';
   print 'document.checkoutForm.submit();';
   print '</script>';
   }

if($method->debug)
	{
	echo '<span style="color: ' . '#' . 'FF0000">';
	echo "<br/>You have enabled debugging in setup. Turn it off to remove the debug information below<br/>1<br/>";
	echo '</span>';
	//print_r($cart);
	echo("Http Response: " . print_r($httpResponse, true));
	echo '<br/>';
	//print_r($update_data);
	//echo '123***';
	//print_r($httpResponse);
	
	}



echo $this->hidessc();

}


function show_payment_details($httpResponse,$virtuemart_order_id,$order_data,$use_profile)

{
	
	$this_profile=1;
	$billing_period = '';
	$order_total=0;
	

	
	if (!class_exists('VirtueMartModelOrders'))
		require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );
	
	
	$modelOrder = new VirtueMartModelOrders(); 
	
	$order = $modelOrder->getOrder($virtuemart_order_id);	
  
	$payment = $this->getDataByOrderId($virtuemart_order_id);
	
	//	$virtuemart_paymentmethod_id = $order_data["pm"];

	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
	

	
	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
	
	$modelOrder = VmModel::getModel("orders");
	
	$order = $modelOrder->getOrder($virtuemart_order_id);	
  
//	$payment = $this->getDataByOrderId($virtuemart_order_id);

//	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
		
		$currency = trim($payment->alt_currency);
		
	$payment_processed = true;
	
	

## update9 end
   
		list($table,$order_total,$line_order_total,$total_discount,$total_tax,$total_shipping,$line_order_details,$trusted_line_items) = $this->order_form($order,$method,$currency);
echo $table;
   
   echo "<p style='font-size: x-large'>" . JText::_('VMPAYMENT_PPC_SSC_THANK_YOU_FOR_YOUR_ORDER') . "</p>";

	
	//print Recurring Payment Details $html_pplan
	/*
   if($this_profile==1)
	{
	$billing_period = trim($method->ssc_pplan_BILLINGPERIOD);	
	list($html_pplan,$use_profile,$profile_error,$first_payment_html) = $this->get_payment_name($method,$order_total,$order);
	}
	*/

	if(trim($method->ssc_receipt_header) != '')
		{
		echo $method->ssc_receipt_header;
		echo '<br/>';
		}
   
	
	//if($method->ssc_show_items == 1)
	//   {
	//	$this->print_order_details($virtuemart_order_id,$method,$method->ssc_show_shipping);
	//	
echo '<br/>';

$order_form_line_item='';
$br = "\n";	

$line_order_details = '';
$line_order_total = 0;

$order_total=0;
$total_discount=0;
$total_tax=0;
$total_shipping=0;

$table='';

// modelorders

$modelOrders = new VirtueMartModelOrders();
$order = $modelOrders->getOrder($virtuemart_order_id);

$button_url = $this->https_check(JURI::root());	
## Tracking
list($table,$order_total,$line_order_total,$total_discount,$total_tax,$total_shipping,$line_order_details,$trusted_line_items) = $this->order_form($order,$method,$button_url);


	//	}
	
	
	//if($method->ssc_show_address == 1)
  // 	{
		$this->print_address($virtuemart_order_id,$method,1);
		//$this->print_address($virtuemart_order_id,$method,$method->ssc_show_shipping);
	//	}

	
	
  
	echo '<p style="font-size: small">';
	
	echo '<table cellspacing="0" cellpadding="2">';
	
	echo '<tr><td style="padding: 2px; border-style:hidden">';
	echo JText::_('VMPAYMENT_PPC_SSC_ORDER_NUMBER') . ':</td>';
	echo '<td style="padding: 2px; border-style:hidden">&nbsp;&nbsp;';
	echo $order["details"]["BT"]->order_number;
	echo '</td></tr>';
	
	
	if(trim(($order["details"]["BT"]->customer_note)) != '')
		{
		$notes = '';	
		$notes .= '<tr><td style="border-style:hidden">';
		$notes .= JText::_('VMPAYMENT_PPC_SSC_ORDER_PRINT_CUSTOMER_NOTE') . ':</td>';
		$notes .= '<td style="border-style:hidden">&nbsp;&nbsp;';
		$notes .= $order["details"]["BT"]->customer_note;
		$notes .= '</td></tr>';
		echo $notes;
		}
	
		
	//	$this->getPaymentCurrency($method); //?????
$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
$db = JFactory::getDBO();
$db->setQuery($q);
$currency_code_3 = $db->loadResult();


$q = 'SELECT `currency_symbol` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
//$db = JFactory::getDBO();
$db->setQuery($q);
$currency_symbol = $db->loadResult();
		
		
	
	//custom 2
	echo '<tr><td style="padding: 2px; border-style:hidden; text-align: right;">';
	echo 'Currency' . ':</td><td style="padding: 2px; border-style:hidden">&nbsp;&nbsp;';
	echo $currency_code_3;
	echo '</td></tr>';

	
	//custom 3
	
	if(isset($httpResponse['ACK']))
	{
	echo '<tr><td style="padding: 2px; border-style:hidden; text-align: right;">';
	echo 'Result' . ':</td><td style="padding: 2px; border-style:hidden">&nbsp;&nbsp;';
	echo $httpResponse['ACK'];
	echo '</td>';
	}

	//custom 4
	
	if(isset($httpResponse['TRANSACTIONID']))
	{
	echo '<tr><td style="padding: 2px; border-style:hidden; text-align: right;">';
	echo 'Transaction ID' . ':</td><td style="padding: 2px; border-style:hidden">&nbsp;&nbsp;';
	echo $httpResponse['TRANSACTIONID'];

	echo '</td></tr>';
	}
	
	echo '</table>';
	
	
	echo '</p>'; # mod4
	
	if(trim($method->ssc_receipt_footer) != '')
		{
		echo '<br/>';
		echo $method->ssc_receipt_footer;
		echo '<br/>';
   	}
	
	if(trim($method->ssc_raw) != '')
		{
		echo $method->ssc_raw;
		}
  	
		
	/*	
	if (!class_exists("VirtueMartModelOrders"))
				require( JPATH_VM_ADMINISTRATOR . '/' . "models" . '/' . "orders.php" );

	$modelOrder = VmModel::getModel("orders");
	$orders["order_status"] =  $method->status_success;
	
	//$httpResponse['PaymentMethod'] = 'RecurringPayment';
	if($use_profile)
		{
		$orders["order_status"] = $method->status_success;
		}
	
	$orders["virtuemart_order_id"] = $virtuemart_order_id;
	$orders["customer_notified"] = 1;
	
	
	
	if(isset($httpResponse['PaymentMethod']))
		{  
		$orders["comments"] = $httpResponse['PaymentMethod'];
		}
	
	if($use_profile)
		{
		$orders["order_status"] = $method->status_success;
		
		list($html_pplan,$use_profile,$profile_error,$first_payment_html) = $this->get_payment_name($method,$order_total,$order);
		
		
		if(isset($orders["comments"]))
		{
		$orders["comments"] .= "<br/>$html_pplan";
		}
		}
	*/



echo $this->hidessc();



if (!class_exists ('VirtueMartCart'))
	{
	require(JPATH_VM_SITE . '/' . 'helpers' . '/' . 'cart.php'); //xxx
	}

$cart = VirtueMartCart::getCart ();
$cart->emptyCart ();




return;

		
	//return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, 'PayPal Checkout');

   

	
	
}




function print_order_details($virtuemart_order_id,$method,$show_shipping)

{
        
echo '<br/>';

$order_form_line_item='';
$br = "\n";	

$line_order_details = '';
$line_order_total = 0;

$order_total=0;
$total_discount=0;
$total_tax=0;
$total_shipping=0;

$table='';

// modelorders

$modelOrders = new VirtueMartModelOrders();
$order = $modelOrders->getOrder($virtuemart_order_id);

$button_url = $this->https_check(JURI::root());	
## Tracking
list($table,$order_total,$line_order_total,$total_discount,$total_tax,$total_shipping,$line_order_details,$trusted_line_items) = $this->order_form($order,$method,$button_url);

echo $table;


}







function print_address($virtuemart_order_id,$method,$show_shipping,$show_edit = 0)

{

$order_form_line_item='';
$br = "\n";	

$line_order_details = '';
$line_order_total = 0;

$order_total=0;
$total_discount=0;
$total_tax=0;
$total_shipping=0;

$table='';

// modelorders

$modelOrders = new VirtueMartModelOrders();
$order = $modelOrders->getOrder($virtuemart_order_id);	

//list($table,$order_total,$line_order_total,$total_discount,$total_tax,$total_shipping,$line_order_details) = $this->order_form($order,$method);

//echo $table;

$address = $order['details']['BT'];

$del_address;
	
	if(isset($order['details']['ST']))
	   {
	   $del_address = $order['details']['ST'];
	   }
	else
	   {
	   $del_address = $order['details']['BT'];
	   }


$country = ShopFunctions::getCountryByID($address->virtuemart_country_id, "country_2_code");
$cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id) : "";

$name = $this->tfield($address->first_name,50) . ' ' . $this->tfield($address->last_name,50);

$del_country = ShopFunctions::getCountryByID($del_address->virtuemart_country_id, "country_2_code");
$del_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($del_address->virtuemart_state_id) : "";
//$del_state_name = $del_state;


if($country === 'US' || $country === 'CA')
  {
  $cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id,"state_2_code") : "";
  }




if($del_country === 'US' || $del_country === 'CA')
  {
  $del_state = isset($del_address->virtuemart_state_id) ? ShopFunctions::getStateByID($del_address->virtuemart_state_id,"state_2_code") : "";
  }



print '<table style="width: 600px"  cellspacing="0" cellpadding="2">';
print '<tr><td valign="top">&nbsp;&nbsp;&nbsp;&nbsp;';

#if($shipping_address == 1)
#	{
	print '<br/><b>&nbsp;&nbsp;&nbsp;&nbsp;' . JText::_('VMPAYMENT_PPC_SSC_BILLING_ADDRESS')  . '</b><br/>';
	print $this->billing_address_html($address,$country,$cc_state);
#	}
#else
#	{
#	print '<a href="' . JROUTE::_(JURI::root()) . 'index.php?option=com_virtuemart&view=user&task=editaddresscart&addrtype=BT">' . JText::_('VMPAYMENT_PPC_SSC_EDIT_ADDRESS') . '</a></strong>';
#	print $this->billing_address_html($address,$country,$state);
#	}
	
if($show_edit == 1)	
	{
	echo '<br>';
	}

print '<a href="' . JROUTE::_(JURI::root()) . 'index.php?option=com_virtuemart&view=user&task=editaddresscart&addrtype=BT">' . JText::_('VMPAYMENT_PPC_SSC_EDIT_ADDRESS') . '</a></strong>';
	

print '</td><td valign="top">&nbsp;&nbsp;&nbsp;&nbsp;';

if($show_shipping == '1' || isset($order['details']['ST']))

	{
	print '<br/><b>&nbsp;' . JText::_('VMPAYMENT_PPC_SSC_SHIPPING_ADDRESS') . '</b><br/>';
	print $this->shipping_address_html($del_address,$del_country,$del_state);

	}

print '</td></tr></table>';

echo '<br/>';
 
    
    
}




























function billing_address_html($address,$country,$state)
{

$editbillingaddress =  JText::_('VMPAYMENT_PPC_SSC_EDIT_BILLING_ADDRESS');
$order_form_name = JText::_('VMPAYMENT_PPC_SSC_NAME');
$order_form_address = JText::_('VMPAYMENT_PPC_SSC_ADDRESS');
$order_form_city = JText::_('VMPAYMENT_PPC_SSC_CITY');
$order_form_state = JText::_('VMPAYMENT_PPC_SSC_STATE');
$order_form_country = JText::_('VMPAYMENT_PPC_SSC_COUNTRY');
$order_form_state = JText::_('VMPAYMENT_PPC_SSC_STATE');
$order_form_zip = JText::_('VMPAYMENT_PPC_SSC_ZIP');
#$order_form_telephone = JText::_('VMPAYMENT_PPC_SSC_TELEPHONE');
#$order_form_email = JText::_('VMPAYMENT_PPC_SSC_EMAIL');
#$order_form_paypal_billing_address = JText::_('VMPAYMENT_PPC_SSC_PAYPAL_BILLING_ADDRESS');
#$order_form_item_total = JText::_('VMPAYMENT_PPC_SSC_ITEM_TOTAL');
#Thani_tax = JText::_('VMPAYMENT_PPC_SSC_TAX');
#$order_form_surcharge = JText::_('VMPAYMENT_PPC_SSC_SURCHARGE');
#$order_form_shipping = JText::_('VMPAYMENT_PPC_SSC_SHIPPING');
#$order_form_order_total = JText::_('VMPAYMENT_PPC_SSC_ORDER_TOTAL');


$order_form_html_shipping = <<<directorderform
<table  cellspacing="0" cellpadding="2">
    <tr align="center">
       <td align="right">$order_form_name:</td>
       <td align="left" >&nbsp;
$address->first_name $address->last_name
      </td>
    </tr>
    <tr align="center">
       <td align="right">$order_form_address:</td>
       <td align="left" >&nbsp;
$address->address_1      
      </td>
    </tr>
directorderform;

if(trim($address->address_2) != '')  
{
$order_form_html_shipping .= <<<directorderform
	<tr align="center">
       <td align="right"></td>
       <td align="left" >&nbsp;
$address->address_2
      </td>
    </tr>
directorderform;
}		  
		  
$order_form_html_shipping .= <<<directorderform
    <tr align="center">
       <td align="right">$order_form_city:</td>
       <td align="left" >&nbsp;
$address->city
      </td>
    </tr><tr align="center">
       <td align="right">$order_form_state:</td>
       <td align="left" >&nbsp;
$state
      </td>
    </tr><tr align="center">
       <td align="right">$order_form_country:</td>
       <td align="left" >&nbsp;
$country      
      </td>
    </tr>
    <tr align="center">
       <td align="right">$order_form_zip:</td>
       <td align="left" >&nbsp;
$address->zip
      </td>
    </tr>
    </tbody>
  </table>
directorderform;

return $order_form_html_shipping;
}




/*
function shipping_address_html($del_address,$del_country,$del_state)
{

$e*rder_form_state = JText::_('VMPAYMENT_PPC_SSC_STATE');
$order_form_country = JText::_('VMPAYMENT_PPC_SSC_COUNTRY');
$order_form_state = JText::_('VMPAYMENT_PPC_SSC_STATE');
$order_form_zip = JText::_('VMPAYMENT_PPC_SSC_ZIP');
#$order_form_telephone = JText::_('VMPAYMENT_PPC_SSC_TELEPHONE');
#$order_form_email = JText::_('VMPAYMENT_PPC_SSC_EMAIL');
#$order_form_paypal_billing_address = JText::_('VMPAYMENT_PPC_SSC_PAYPAL_BILLING_ADDRESS');
#$order_form_item_total = JText::_('VMPAYMENT_PPC_SSC_ITEM_TOTAL');
#$order_form_tax = JText::_('VMPAYMENT_PPC_SSC_TAX');
#$order_form_surcharge = JText::_('VMPAYMENT_PPC_SSC_SURCHARGE');
#$order_form_shipping = JText::_('VMPAYMENT_PPC_SSC_SHIPPING');
#$order_form_order_total = JText::_('VMPAYMENT_PPC_SSC_ORDER_TOTAL');


$order_form_html_shipping = <<<directorderform
<table cellspacing="0" cellpadding="2">
    <tr align="center">
       <td align="right">$order_form_name:</td>
       <td align="left" >&nbsp;
$del_address->first_name $del_address->last_name
      </td>
    </tr>
    <tr align="center">
       <td align="right">$order_form_address:</td>
       <td align="left" >&nbsp;
$del_address->address_1      
      </td>
    </tr>
    <tr align="center">
       <td align="right"></td>
       <td align="left" >&nbsp;
$del_address->address_2
      </td>
    </tr>
    <tr align="center">
       <td align="right">$order_form_city:</td>
       <td align="left" >&nbsp;
$del_address->city
      </td>
    </tr><tr align="center">
       <td align="right">$order_form_state:</td>
       <td align="left" >&nbsp;
$del_state
      </td>
    </tr><tr align="center">
       <td align="right">$order_form_country:</td>
       <td align="left" >&nbsp;
$del_country      
      </td>
    </tr>
    <tr align="center">
       <td align="right">$order_form_zip:</td>
       <td align="left" >&nbsp;
$del_address->zip
      </td>
    </tr>
    </tbody>
  </table>
directorderform;

return $order_form_html_shipping;
}
*/

    
function tfield($field,$len)
	{
	$field = str_replace('"',"''",$field);
	$field = substr($field,0,$len);
	//$field = htmlspecialchars($field);
	return $field;
	}


function capture_payments($order_id,$token,$paypal_url,$comment)
{


//curl -v -X POST https://api-m.sandbox.paypal.com/v2/checkout/orders/<ORDER-ID>/capture \

//-H "Content-Type: application/json" \

//-H 'Authorization: Bearer <ACCESS-TOKEN>' \

//-H 'Accept-Language: en_US' \ 
 
$ch = curl_init();
 #CURLOPT_HTTPHEADER, array('Connection: Close'));
$headers = array(
'Content-type: application/json',
'Authorization: Bearer ' . $token,
'Accept-Language: en_US'
);

$postfields = '{}';

curl_setopt($ch, CURLOPT_URL, "https://" . $paypal_url . "/v2/checkout/orders/" . $order_id . "/capture");
//curl_setopt($ch, CURLOPT_HEADER, false);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
//curl_setopt($ch, CURLOPT_SSLVERSION , 6); //NEW ADDITION
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); 
//curl_setopt($ch, CURLOPT_USERPWD, $clientId.":".$secret);
curl_setopt($ch, CURLOPT_POSTFIELDS, $postfields);
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);

/*
(
[name] =&gt; UNPROCESSABLE_ENTITY
    [details] =&gt; Array
        (
            [0] =&gt; stdClass Object
                (
                    [issue] =&gt; ORDER_ALREADY_CAPTURED
                    [description] =&gt; Order already captured.If 'intent=CAPTURE' only one capture per order is allowed.
                )

        )

    [message] =&gt; The requested action could not be performed, semantically incorrect, or failed business validation.
    [debug_id] =&gt; b3a23249f5668
    [links] =&gt; Array
        (
            [0] =&gt; stdClass Object
                (
                    [href] =&gt; https://developer.paypal.com/docs/api/orders/v2/#error-ORDER_ALREADY_CAPTURED
                    [rel] =&gt; information_link
                    [method] =&gt; GET
                )

        )
*/

curl_close($ch);	
	
$this->update_orders($order_id,$result,$paypal_url,$comment);	

return $result;	
}




function update_orders($paymentId,$result,$paypal_url,$comment)
	{

	$db = JFactory::getDBO();
	$q = "SELECT `order_number` FROM `#__virtuemart_payment_plg_paypalcheckoutssc` WHERE `paymentId` = '" .  $paymentId . "'";
	$db->setQuery($q);
	$order_number = $db->loadResult();
	
	$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);

	if (!$virtuemart_order_id)
	  {
	  return;
	  }

	$payment = $this->getDataByOrderId($virtuemart_order_id);
	
	### ppplus add to express, pro ???
	if($payment == null)
		{
		return false;
		}

	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
	
	if (!$this->selectedThisElement($method->payment_element))
		{
		return false;
		}
	
	
	if ($virtuemart_order_id)
	   {
		if (!class_exists("VirtueMartModelOrders"))
				require( JPATH_VM_ADMINISTRATOR . '/' . "models" . '/' . "orders.php" );

		$modelOrder = VmModel::getModel("orders");
		$orders["order_status"] = $method->status_success;
	
	   $orders['comments'] = 'Payment Captured: ' . $comment; //JText::sprintf('VMPAYMENT_PPC_SSC_CONFIRMED_BY_JS');
		$orders["virtuemart_order_id"] = $virtuemart_order_id;
		$orders["customer_notified"] = 1;
	

	if(empty($result))
		echo "Error: No response.";
	else
		{
		$json = json_decode($result);
		//if($method->debug)
		//{
		//print_r($json);
		//}
	
	//if((isset($json->status)) && $json->status == 'COMPLETED')
	//	{
		
	if((isset($json->purchase_units[0]->payments->captures[0]->status)) && $json->purchase_units[0]->payments->captures[0]->status === 'COMPLETED')
		{	
		$orderitems = $modelOrder->getOrder($virtuemart_order_id);
	
		if((isset($orderitems['details']['BT']->order_status) && ($orderitems['details']['BT']->order_status == 'P')))
			{
			$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $orders, true);	
			}
		//echo $orderitems['details']['BT']->order_status;
		}
	
	}

	
	return;

		
   }

	

	
	
	echo 'Status Updated';
	
	return;
	
	
}















function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId) {
    

	if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
	    return null; // Another method was selected, do nothing
	}
	if (!$this->selectedThisElement($method->payment_element)) {
	    return false;
	}                                                                                                       
	$this->getPaymentCurrency($method);
	$paymentCurrencyId = $method->payment_currency;
//	$paymentCurrencyId = trim($payment->paypal_custom);
    }

// html response
	 
	 
	 
function onAjaxPaypalcheckoutssc()
//function captureAjax()
{
	$data = array("test");
        return $data;
		  
	$order_id = $_GET["paymentId"];
 
 $token = $_GET["token"];
 
 $paypal_url = $_GET["paypal_url"];
 
//curl -v -X POST https://api-m.sandbox.paypal.com/v2/checkout/orders/<ORDER-ID>/capture \

//-H "Content-Type: application/json" \

//-H 'Authorization: Bearer <ACCESS-TOKEN>' \

//-H 'Accept-Language: en_US' \ 
 
$ch = curl_init();
 #CURLOPT_HTTPHEADER, array('Connection: Close'));
$headers = array(
'Content-type: application/json',
'Authorization: Bearer ' . $token,
'Accept-Language: en_US'
);

$postfields = '{}';

curl_setopt($ch, CURLOPT_URL, "https://" . $paypal_url . "/v2/checkout/orders/" . $order_id . "/capture");
//curl_setopt($ch, CURLOPT_HEADER, false);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
//curl_setopt($ch, CURLOPT_SSLVERSION , 6); //NEW ADDITION
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); 
//curl_setopt($ch, CURLOPT_USERPWD, $clientId.":".$secret);
curl_setopt($ch, CURLOPT_POSTFIELDS, $postfields);
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);

if(empty($result))
	{
	echo 'Curl error: ' . curl_error($ch);
	}
else
{
	
	echo $result;
    $json = json_decode($result);
  #  print_r($json);

}

curl_close($ch);
	return $result;
}	 



function plgVmOnPaymentResponseReceived(&$html)
{
    
if (!class_exists('VirtueMartModelOrders'))
	    require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );

	//$order_data = J Request::get('get');
	
	$order_data = $this->get_strings();

	
	//$post_msg ='';
		
	//foreach ($order_data as $key => $value)
	//   {
	//   $post_msg .= $key . "=" . $value . "<br />";
	//   }
	
	//echo $post_msg;
	
	//$post_data = J Request::get('post');
	
	$post_data = $this->post_strings();
	$get_data = $this->get_strings();

		
	$jinput =JFactory::getApplication()->input;
	 
	$value='ecocheckout'; $order_data[$value] = $jinput->get->get($value, null, 'ALNUM');
	$value='pectransid'; $order_data[$value] = $jinput->get->get($value, null, 'CMD');
	$value='e'; $order_data[$value] = $jinput->get->get($value, null, 'ALNUM');
	$value='token'; $order_data[$value] = $jinput->get->get($value, null, 'CMD');
	$value='PayerID'; $order_data[$value] = $jinput->get->get($value, null, 'CMD');
	
	$value='paymentId'; $order_data[$value] = $jinput->get->get($value, null, 'CMD');

	$value='s'; $post_data[$value] = $jinput->post->get($value, null, 'ALNUM');
	
	

	if (isset($post_data["s"]))
	   {
	   if($post_data["s"] == 'eccheckout')
	      {
          $this->doexpress('','','');
  	      return;
	      }
	   }


   if (isset($order_data["ecocheckout"]))
	   {
	   
	   if(!class_exists('VirtueMartCart')) require(JPATH_VM_SITE . '/' . 'helpers' . '/' . 'cart.php');
		$cart = VirtueMartCart::getCart();
		
		$value = $this->plgVmConfirmedOrder($cart,null);

	   return $value;
	   }

		
		
	$virtuemart_order_id='';
	
	if(isset($get_data["pcsc"]))
		{
		
		//print_r($order_data);
			
		
		if(!isset($get_data["token"]))
			{
			echo 'token not defined';
			return;
			}
			
	$paymentId = $get_data["token"];			
 		
	if(trim($paymentId === ''))
		{
		echo 'There has been a error';
		return;
		}
		
	$db = JFactory::getDBO();
	$q = "SELECT `order_number` FROM `#__virtuemart_payment_plg_paypalcheckoutssc` WHERE `paymentId` = '" .  $paymentId . "'";

	$db->setQuery($q);
	$order_number = $db->loadResult();
	
	$access_token = $get_data["token"];
	
	$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);

	if (!$virtuemart_order_id)
	  {
	  return;
	  }

	
	$vendorId = 0;
	$payment = $this->getDataByOrderId($virtuemart_order_id);
	
	if($payment == null)
		{
		return false;
		}

	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
	
	if (!$this->selectedThisElement($method->payment_element))
		{
		return false;
		}
		
	$paypal_url = "api.paypal.com";
	
	
if($method->ssc_environment == "sandbox")
	{
	$paypal_url = "api.sandbox.paypal.com";
	}
		
		
	$clientId = $method->ssc_ssc1;
	$secret = $method->ssc_ssc2;
	
	if($method->ssc_environment == "sandbox")
		{
		$clientId = $method->ssc_ssc1_sb;
		$secret = $method->ssc_ssc2_sb;
		}
		
	$clientId = trim($clientId);
	$secret = trim($secret);		
		
	$token =	 $this->create_access_token($clientId,$secret,$paypal_url);		
		
	$result = $this->capture_payments($paymentId,$token,$paypal_url,'PayPal Redirect');
		
	
		if(empty($result))
			{
			echo "Error: No response.";
			}
		else
			{
			$json = json_decode($result);
			if($method->debug)
				{
				print_r($json);
				}
	
			if((isset($json->status)) && $json->status === 'COMPLETED')
				{
				//echo "Payment is completed:";
				
				$paypal_fullresponse = '';// '{"PROFILEID":"' . urlencode($order_data["subcriptions_id"]) . '"}';
    			$use_profile=true;
				$orders =  null;
				$this->show_payment_details($paypal_fullresponse,$virtuemart_order_id,$order_data,$use_profile);
				return;
				}
			else
				{
					
				if(isset($json->details[0]->issue) && $json->details[0]->issue === 'ORDER_ALREADY_CAPTURED')
					{
					echo $json->details[0]->description;
					
					$paypal_fullresponse = '';// '{"PROFILEID":"' . urlencode($order_data["subcriptions_id"]) . '"}';
					$use_profile=true;
					$orders=null;
					$this->show_payment_details($paypal_fullresponse,$virtuemart_order_id,$order_data,$use_profile);
	
					return;
					}
				
				
				if(isset($json->details[0]->description))
					{
					echo $json->details[0]->description;
					
					return;
					}
				
				echo "There as been an error in processing your request.";
				}
				
				
			}

		return;	
		}
	
	
if(isset($get_data["pcs"]))
	{
	
	$db = JFactory::getDBO();
	$q = "SELECT `order_number` FROM `#__virtuemart_payment_plg_paypalcheckoutssc` WHERE `paymentId` = '" .  $get_data["paymentId"] . "'";
	$db->setQuery($q);
	$order_number = $db->loadResult();
	
	$access_token = $get_data["token"];
	
	$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);

	
	if (!$virtuemart_order_id)
	  {
	  return;
	  }
	
	
	$vendorId = 0;
	$payment = $this->getDataByOrderId($virtuemart_order_id);
	
	### ppplus add to express, pro ???
	if($payment == null)
		{
		return false;
		}

	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
	
	if (!$this->selectedThisElement($method->payment_element))
		{
		return false;
		}
		
	$paypal_url = "api.paypal.com";
	
	
if($method->ssc_environment == "sandbox")
	{
	$paypal_url = "api.sandbox.paypal.com";
	}
	
	if ($virtuemart_order_id)
	   {
		if (!class_exists("VirtueMartModelOrders"))
				require( JPATH_VM_ADMINISTRATOR . '/' . "models" . '/' . "orders.php" );



	$paypal_fullresponse = '';// '{"PROFILEID":"' . urlencode($order_data["subcriptions_id"]) . '"}';
    
	$use_profile=true;
	$this->show_payment_details($paypal_fullresponse,$virtuemart_order_id,$order_data,$use_profile);
	
	
$headers = array(
'Content-type: application/json',
'Authorization: Bearer ' . $access_token,
'Accept-Language: en_US'
);


$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://" . $paypal_url . "/v2/checkout/orders/" . $get_data["paymentId"]);
//curl_setopt($ch, CURLOPT_HEADER, false);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
//curl_setopt($ch, CURLOPT_SSLVERSION , 6); //NEW ADDITION
//curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); 
//curl_setopt($ch, CURLOPT_USERPWD, $clientId.":".$secret);
//curl_setopt($ch, CURLOPT_POSTFIELDS, $postfields);
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);

if(empty($result))
	{
	echo 'Curl error: ' . curl_error($ch);
	}
else
	{
	$json = json_decode($result);
	if($method->debug)
	{
   print_r($json);
	}
	$order_id = trim($json->id);

	
	if(isset($get_data["type"]) && $get_data['type'] === 'PP')
	{
	//print_r($json);
		
		if (!class_exists('VirtueMartModelOrders'))
		require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );
		
		
		$modelOrder = VmModel::getModel("orders");
		$orderitems = $modelOrder->getOrder($virtuemart_order_id);
			
	$already_confirmed = 0;
		
	foreach($orderitems['history'] as $status)
		{
		//echo $status->order_status_code;
		if($status->order_status_code === $method->status_success)
			{
			$already_confirmed = 1;
			}
		}
		
	$already_authorized = 0;
		
	foreach($orderitems['history'] as $status)
		{
		//echo $status->order_status_code;
		if($status->order_status_code === $method->status_authorize)
			{
			$already_authorized = 1;
			}
		}	
		

		
	//if((isset($json->status)) && $json->status === 'COMPLETED')
	if((isset($json->purchase_units[0]->payments->captures[0]->status)) && $json->purchase_units[0]->payments->captures[0]->status === 'COMPLETED')
		{

		
		$orders["order_status"] = $method->status_success;
	
	   $orders['comments'] = JText::sprintf('VMPAYMENT_PPC_SSC_CONFIRMED_BY_JS');
		$orders["virtuemart_order_id"] = $virtuemart_order_id;
		$orders["customer_notified"] = 1;			

	if($already_confirmed === 0)
		{
		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $orders, true);	
		}
		
		//echo $orderitems['details']['BT']->order_status;
		}
	
		
	}

	}
	




	
	
	return;
	
		
		
	  } 

	

	
	
	echo 'Status Updated';
	
	return;
	
	
}


$order_number = '';

	if (!isset($order_data["pectransid"]))
	   {
		
		### find order number from paymentId
		
		if(isset($order_data["paymentId"]))	
			{
			$db = JFactory::getDBO();
			$q = "SELECT `order_number` FROM `#__virtuemart_payment_plg_paypalcheckoutssc` WHERE `paymentId` = '" .  $order_data["paymentId"] . "'";
			$db->setQuery($q);
			$order_number = $db->loadResult();
			
			$order_data["pectransid"] = $order_number;
			}
		else
			{
			return;
			}
		
	   }
//echo $order_number;


if (isset($order_data["e"]) && $order_data["e"] === '1')
   {
	//echo '- update cart  --<br>';
	$this->update_cart($order_data['token'],$order_data['PayerID']);
	return;
	}

	$order_number = $order_data["pectransid"];
	$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_data["pectransid"]);
//**	$this->logInfo('plgVmOnPaymentNotification: virtuemart_order_id  found ' . $virtuemart_order_id, 'message');

	if (!$virtuemart_order_id)
	  {
	  return;
	  }
	
	
	$vendorId = 0;
	$payment = $this->getDataByOrderId($virtuemart_order_id);
	
	### ppplus add to express, pro ???
	if($payment == null)
		{
		return false;
		}

	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
	
	if (!$this->selectedThisElement($method->payment_element))
		{
		//echo $method->payment_element;
		//print 'no order id PP P';
		return false;
		}
	
	
//	&pectransid=G25C0166&api=rest&paymentId=PAY-1L213597SS097060FLFLZIMY&token=EC-4D717483T38936052&PayerID=EMM5HTHZPRXMQ

if(isset($order_data["paymentId"]))
	{
	
	if (!isset($order_data["PayerID"]))
	   {
	   echo 'PayerID is not Set';
	   return;
	   }
	
	$this->process_success($order_data["paymentId"],$order_data["PayerID"],$order_number);
	return;
	}

	

if (!class_exists('VirtueMartModelOrders'))
		require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );
	    $modelOrder = new VirtueMartModelOrders();
	    
	    $order = $modelOrder->getOrder($virtuemart_order_id);

//$method->debug = 0;

//print_r($method);
//print print_r($order);

//print print_r($payment);

//Payment

//[product_attribute] =>


$order_form_line_item='';
$br = "\n";	

$line_order_details = '';
$line_order_total = 0;

$order_total=0;
$total_discount=0;
$total_tax=0;
$total_shipping=0;

$table='';

$customer_currency = 0;

//if($method->ssc_multi_currency)
//	{
	$customer_currency = trim($payment->alt_currency);
//	}
//else
//	{
//	$customer_currency = $method->payment_currency;
//	}


list($table,$order_total,$line_order_total,$total_discount,$total_tax,$total_shipping,$line_order_details,$pppitems) = $this->order_form($order,$method,$customer_currency);

$APIrequest =
"&TOKEN=" . $order_data['token'] .

"&PAYMENTACTION=" . $method->ssc_payment_action;
//"&IPADDRESS=" . $ipaddress .

//"&RETURNURL=". urlencode($ReturnURL) . urlencode('&pectransid=' . $order["details"]["BT"]->order_number) .
//encode twice

//"&CANCELURL=". urlencode($CancelURL) .

//"&INVNUM=" . urlencode($cart->virtuemart_order_id) .
# new custom field 23-11-11
//"&CUSTOM=" . 
#"&SHIPPINGOPTIONNAME=" . $ _POST["pro_shipping"] .

//"&LOCALECODE=" . $cc_country .

//"&CURRENCYCODE=" . $currency_code_3 .
//"&ITEMAMT=" . $line_order_total .
//"&SHIPPINGAMT=" . $shipping .
//"&TAXAMT=" . $total_tax .
//"&AMT=" . $amount .

//"&SHIPTONAME=" . urlencode($del_address->first_name . ' ' . $del_address->last_name) .
//"&SHIPTOSTREET=" . urlencode($del_address->address_1) .
//"&SHIPTOSTREET2=" . urlencode($del_address->address_2) .
//"&SHIPTOSTATE=" . urlencode($del_state) . 
//"&SHIPTOCITY=" . urlencode($del_address->city) . 
//"&SHIPTOZIP=" . urlencode($del_address->zip) .
//"&SHIPTOCOUNTRYCODE=" . urlencode($del_country) .
//"&SHIPTOPHONENUM=" . urlencode($address->phone_1) .


//"&EMAIL=" . urlencode($address->email) .

//$line_order_details .





$httpResponse = $this->PPHttpPost($method,"GetExpressCheckoutDetails", $APIrequest);


///// begin mods for save address ///

///*
$method->ssc_address_override=1;

if($method->ssc_address_override == 0)
{
$first_name = '';
$middle_name ='';
$last_name = '';
$address_1 = '';
$address_2 = '';
$house_no = '';
$zip = '';
$city = '';
$state_name='';
$state_id='0';
$virtuemart_country_id='';
$phone_1='';
$email = '';


if(isset($httpResponse['FIRSTNAME']))
	{
	$first_name = urldecode($httpResponse['FIRSTNAME']);
	}

if(isset($httpResponse['MIDDLENAME']))
	{
	$middle_name = urldecode($httpResponse['MIDDLENAME']);
	}

if(isset($httpResponse['LASTNAME']))
	{
	$last_name = urldecode($httpResponse['LASTNAME']);
	}

if(isset($httpResponse['FIRSTNAME']) && isset($httpResponse['LASTNAME']))
	{
	if(urldecode($httpResponse['SHIPTONAME']) == urldecode($httpResponse['FIRSTNAME']) . ' ' . urldecode($httpResponse['LASTNAME']))
		{
		$first_name = urldecode($httpResponse['FIRSTNAME']);
		$last_name = urldecode($httpResponse['LASTNAME']);
		}
	else
		{
		$shipToName = explode(' ', urldecode($httpResponse['SHIPTONAME']));
		$first_name = $shipToName[0];
		$last_name = '';
		if (count($shipToName) > 1)
			{
			$last_name = str_replace($first_name . ' ', '', urldecode($httpResponse['SHIPTONAME']));
			}
		}
	}


if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOSTREET']))
	{
	$address_1 = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOSTREET']);
	}


if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOCITY']))
	{
	$city = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOCITY']);
	}

if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOZIP']))
	{
	$zip = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOZIP']);
	}
	
	
if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE']))
	{
	$cc = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE']);
	$virtuemart_country_id = ShopFunctions::getCountryIDByName($cc);
	}


if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOSTATE']))
	{
	$state_name = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOSTATE']);
	
	
	if(strlen($state_name) === 2)
		{
		$q = 'SELECT `virtuemart_state_id` FROM `#__virtuemart_states` WHERE `state_2_code`="' . $state_name . '" ';
		$db = JFactory::getDBO();
		$db->setQuery($q);
		$state_id_2 = $db->loadResult();
		//echo 'state id 2:' . $state_id_2;

		if(!is_null($state_id_2))
			{
			$state_id = $state_id_2;
			}
		
		//$city .= ' ' . urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOSTATE']);
		$city = trim($city);	
		}
	
	if(strlen($state_name) > 2)
		{
		$q = 'SELECT `virtuemart_state_id` FROM `#__virtuemart_states` WHERE `state_name`="' . $state_name . '" ';
		$db = JFactory::getDBO();
		$db->setQuery($q);
		$state_id_3 = $db->loadResult();
		//echo 'state id 3:' . $state_id_3;

		if(!is_null($state_id_3))
			{
			$state_id = $state_id_3;
			}
		else
			{
			$city .= ' ' . urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOSTATE']);
			$city = trim($city);	
			}
		}

	}

	
//if(isset($httpResponse['PAYMENTREQUEST_0_SHIPTOPHONENUM']))
//	{
//	$phone_1 = urldecode($httpResponse['PAYMENTREQUEST_0_SHIPTOPHONENUM']);
//	}
	
if(isset($httpResponse['PHONENUM']))
	{
	$phone_1 = urldecode($httpResponse['PHONENUM']);
	}
	
	
if(isset($httpResponse['EMAIL']))
	{
	$email = urldecode($httpResponse['EMAIL']);
	}


//$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($invoice_num);

//// begin db update ////

$bt=0;
$st=0; 
  
$db = JFactory::getDBO();
$query = $db->getQuery(true);
$query->select($db->quoteName(array('virtuemart_order_userinfo_id','virtuemart_order_id','virtuemart_user_id','address_type')));
$query->from($db->quoteName('#__virtuemart_order_userinfos'));
$query->where(array($db->quoteName('virtuemart_order_id')." = " . $virtuemart_order_id,$db->quoteName('address_type') . '=' . $db->quote('ST')));
$db->setQuery($query);
//$row = $db->loadObject();
//$db->query();
$db->execute();
$st = $db->getNumRows();


$db = JFactory::getDBO();
$query = $db->getQuery(true);
$query->select($db->quoteName(array('virtuemart_order_userinfo_id','virtuemart_order_id','virtuemart_user_id','address_type','address_type_name','company','title','last_name','first_name','middle_name','phone_1','phone_2','fax','address_1','address_2','city','virtuemart_state_id','virtuemart_country_id','zip','email','agreed','created_on','created_by','modified_on','modified_by','locked_on','locked_by')));
$query->from($db->quoteName('#__virtuemart_order_userinfos'));
$query->where(array($db->quoteName('virtuemart_order_id')." = " . $virtuemart_order_id,$db->quoteName('address_type') . '=' . $db->quote('BT')));
$db->setQuery($query);
$row = $db->loadObject();
//$db->query();
$db->execute();
$bt = $db->getNumRows();   
   

if($bt == 1 && $st == 1)
	{
	$db = JFactory::getDBO();
	$query = $db->getQuery(true);
	//$fields = array($db->quoteName('first_name') . '=' . $db->quote('1 1 ' . $first_name),
	$fields = array($db->quoteName('first_name') . '=' . $db->quote($first_name),
	$db->quoteName('last_name') . '=' . $db->quote($last_name),
	$db->quoteName('middle_name') . '=' . $db->quote($middle_name),
	$db->quoteName('last_name') . '=' . $db->quote($last_name),
	$db->quoteName('address_1') . '=' . $db->quote($address_1),
	$db->quoteName('address_2') . '=' . $db->quote($address_2),
	$db->quoteName('zip') . '=' . $db->quote($zip),
	$db->quoteName('city') . '=' . $db->quote($city),
	$db->quoteName('virtuemart_state_id') . '=' . $state_id,
	$db->quoteName('virtuemart_country_id') . '=' . $virtuemart_country_id,
	$db->quoteName('phone_1') . '=' . $db->quote($phone_1),
	$db->quoteName('email') . '=' . $db->quote($email));
	$conditions = array($db->quoteName('virtuemart_order_id') . '=' . $virtuemart_order_id,$db->quoteName('address_type') . '=' . $db->quote('ST'));
	$query->update($db->quoteName('#__virtuemart_order_userinfos'))->set($fields)->where($conditions);
	$db->setQuery($query);
	//$result = $db->query();
	$result = $db->execute();
	}


if($bt == 1 && $st == 0)
	{
	$row->virtuemart_order_userinfo_id = null;
	$row->address_type='ST'; 
//	$row->first_name = '1 0 ' . $first_name;
	$row->first_name = $first_name;
	$row->last_name = $last_name;
	$row->middle_name = $middle_name;
	$row->last_name = $last_name;
	$row->address_1 = $address_1;
	$row->address_2 = $address_2;
	$row->zip = $zip;
	$row->city = $city;
	$row->virtuemart_state_id = $state_id;
	$row->virtuemart_country_id = $virtuemart_country_id;
	$row->phone_1 = $phone_1;
	$row->email = $email;
// Insert the object into the user profile table.
	$result = JFactory::getDbo()->insertObject('#__virtuemart_order_userinfos', $row);
	}
//// end db update ////
	//update $order variable
$order = $modelOrder->getOrder($virtuemart_order_id);
}

//*/


//////// end of save address //////////////////////




//echo '------------------------------------------------------------';
//print_r($httpResponse);
//echo '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++';

//$method->ssc_user_action = "override_commit";


//print("Http Response: " . print_r($httpResponse, true));

//************** end save address ***********************

if($method->ssc_user_action === "commit")
	{
	$this->doexpress(urldecode($httpResponse['TOKEN']),urldecode($httpResponse['PAYERID']),$order_data["pectransid"]);   
	return null;   
	}

if("SUCCESS" == strtoupper($httpResponse["ACK"]) || "SUCCESSWITHWARNING" == strtoupper($httpResponse["ACK"]))
   {
   print "<p style='font-size: x-large'>" . JText::_('VMPAYMENT_PPC_SSC_REVIEW') . "</p>";


$url = $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived');

$button =  
"<form method='POST' action='" . $url . "' onsubmit='return Form_Validator(this)'>
<input type='hidden' name='token' value='" . urldecode($httpResponse['TOKEN']) . "'>" .
"<input type='hidden' name='s' value='eccheckout'>" .
"<input type='hidden' name='PAYERID' value='" . urldecode($httpResponse['PAYERID']) . "'>" .

"<input type='hidden' name='pectransid' value='" . $order_data["pectransid"] . "'>" .

"<input type='submit' value='" . JText::_('VMPAYMENT_PPC_SSC_PLACE_ORDER') . "' name='B1'>" . 
"</form>";
   
   
echo $button;
echo '<br/>';
echo $table;

$address = $order['details']['BT'];

$del_address = null;
	
	if(isset($order['details']['ST']))
	   {
	   $del_address = $order['details']['ST'];
	   }
	else
	   {
	   $del_address = $order['details']['BT'];
	   }

$country = ShopFunctions::getCountryByID($address->virtuemart_country_id, "country_2_code");
$cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id) : "";


$del_country = ShopFunctions::getCountryByID($del_address->virtuemart_country_id, "country_2_code");
$del_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($del_address->virtuemart_state_id) : "";


list($order_form,$order_form_html_billing,$order_form_html_shipping) = $this->billing_shipping_address($address,$del_address,$country,$del_country,$cc_state,$del_state);

echo '<br/>';

$show_shipping=1;

print '<table style="width: 600px" cellspacing="0" cellpadding="2">';
print '<tr><td style="border-style:hidden" valign="top">&nbsp;&nbsp;&nbsp;&nbsp;';


print '<br/><b>&nbsp;&nbsp;&nbsp;&nbsp;' . JText::_('VMPAYMENT_PPC_SSC_BILLING_ADDRESS')  . '</b><br/>';
//print $this->billing_address_html($address,$country,$cc_state);
echo $order_form_html_billing;

print '</td><td style="border-style:hidden" valign="top">&nbsp;&nbsp;&nbsp;&nbsp;';

if($show_shipping == 1)
	{
	print '<br/><b>&nbsp;' . JText::_('VMPAYMENT_PPC_SSC_SHIPPING_ADDRESS') . '</b><br/>';
	//	print $this->shipping_address_html($del_address,$del_country,$del_state);
	echo $order_form_html_shipping;
	}

print '</td></tr></table>';

	
if($method->debug)
	{
	$real_shipping = $this->real_shipping_address($httpResponse); 
	echo "PayPal's Shipping Address:<br>" . $real_shipping . '<br>';
	}


print $button;
 
//print "<!-- Copyright Online Store 2012";

$html="";

		
//	return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $new_status);

   }
else
   {
   $s=0;
   $error ="No";
         print "<span style='font-family: Arial, Helvetica, sans-serif; font-size: large; color: #FF0000'>";
   while(isset($httpResponse["L_LONGMESSAGE" . $s]))
   {

   
   if($httpResponse["L_ERRORCODE" . $s] == "500")
      {
	  print JText::_('VMPAYMENT_PPC_SSC_UNKNOWN_ERROR');   
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "81234")
      {
      print "";        
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "10002" && $httpResponse["L_LONGMESSAGE" . $s] == 'Security%20header%20is%20not%20valid')
      {
      print "Please check your API Username, Password and Signature for your Live or Sandbox account.";	         
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "10002" && $httpResponse["L_LONGMESSAGE" . $s] == 'You%20do%20not%20have%20permissions%20to%20make%20this%20API%20call')
      {
      print "Do you have a valid Payments Pro Live or Sandbox account with the correct API Username, Password and Signature";	         
      }      
   else
      {
   
      if($error == 'No')
         {      
         print "<br>" . JText::_('VMPAYMENT_PPC_SSC_TRY_AGAIN') . ".<br>";
         $error='Yes';
         }
         	         
      print $httpResponse["L_ERRORCODE" . $s] . ": " . urldecode($httpResponse["L_LONGMESSAGE" . $s]) . " <br><br>\r\n";  
      }
   $s++;
     
   }
    print "<br></span><br>";
}
//print '--------- Review 1 -------------';
	


echo $this->hidessc();
	

//    print 'invnum found<br>';
    
    return null; 
    
    }

	 
function hidessc()
	{
	$hidessc = "<style>
img#hidessc + h1
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<style>
img#hidessc + h3
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<style>
img#hidessc + div > h3:first-child
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>
<style>
.vm-order-done
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
font-size: 8pt;
}
</style>

<img id='hidessc'/>
";
	return $hidessc;
	
	}
	 

function plgVmOnUserPaymentCancel()
	{

	if (!class_exists('VirtueMartModelOrders'))
	    require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );


	
	$jinput =JFactory::getApplication()->input;
	$order_number = $jinput->get->get('on', null, 'CMD');
	$virtuemart_paymentmethod_id = $jinput->get->get('pm', null, 'CMD');


	if (empty($order_number) or empty($virtuemart_paymentmethod_id) or !$this->selectedThisByMethodId($virtuemart_paymentmethod_id))
		{
		return NULL;
		}
   
	if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number)))
		{
		return NULL;
		}
   
   if (!($paymentTable = $this->getDataByOrderNumber($order_number)))
		{
		return NULL;
		}

	//check token?
		
	$method = $this->getPluginMethod($virtuemart_paymentmethod_id);
	$mod = VmModel::getModel('orders');
	$order = $mod->getOrder($virtuemart_order_id);
	if ($order['details']['BT']->order_status == $method->status_success) // || $order['details']['BT']->order_status == $method->status_pending) // || $order['details']['BT']->order_status == $method->status_capture)
		{
		return NULL;
		}
		
	if ($order['details']['BT']->order_status != $method->status_pending) // || $order['details']['BT']->order_status == $method->status_capture)
		{
		return NULL;
		}
		    
	$session = JFactory::getSession();
	$return_context = $session->getId();
	if (strcmp($paymentTable->paypal_custom, $return_context) === 0)
		{
		VmInfo(Jtext::_('VMPAYMENT_PPC_SSC_PAYMENT_CANCELLED'));
		$this->handlePaymentUserCancel($virtuemart_order_id);
		}    
	    

	return true;
    }




// Process silent post

// index.php?option=com_virtuemart&view=pluginresponse&task=pluginnotification&tmpl=component

function PPHttpPost($method,$methodName_, $nvpStr_) {

	if(!ini_get('safe_mode'))
		{
		if(ini_get('max_execution_time') < 45)
			{ 
			if(false === strpos(ini_get("disable_functions"), "set_time_limit"))
				{
				//echo "set_time_limit functions are available.<br />\n";
				set_time_limit(45);
				}
		//	else
		//		{
				//echo "set_time_limit are not available.<br />\n";
		//		}          
			}
		}
		
	//echo 'time: ' . ini_get('max_execution_time');
		
// Set up your API credentials, PayPal end point, and API version.
	
	$API_UserName = trim($method->ssc_api_username);
	$API_Password = trim($method->ssc_api_password);
	$API_Signature = trim($method->ssc_api_signature);
	$API_Endpoint = "https://api-3t.paypal.com/nvp";
	
	$d = 0;
	
	if($method->ssc_environment === "sandbox" || $d == 1)
		{
		$API_UserName = trim($method->ssc_api_sb_username);
		$API_Password = trim($method->ssc_api_sb_password);
		$API_Signature = trim($method->ssc_api_sb_signature);
   	$API_Endpoint = "https://api-3t.sandbox.paypal.com/nvp";
		}
	

	$version = urlencode('114.0');

	// Set the curl parameters.
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $API_Endpoint);
	curl_setopt($ch, CURLOPT_VERBOSE, 1);

	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
	
	 curl_setopt($ch, CURLOPT_CAINFO, dirname(__FILE__) . '/fields/cacert.pem');

	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_POST, 1);
	
		curl_setopt($ch, CURLOPT_TIMEOUT,35);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 35);

	
	// Set the API operation, version, and API signature in the request.
	$nvpreq = "METHOD=$methodName_&VERSION=$version&PWD=$API_Password&USER=$API_UserName&SIGNATURE=$API_Signature$nvpStr_";

//print 'nvpreq ' . "METHOD=$methodName_&VERSION=$version&PWD=$API_Password&USER=$API_UserName&SIGNATURE=$API_Signature" .'<br><br>';

	// Set the request as a POST FIELD for curl.
	curl_setopt($ch, CURLOPT_POSTFIELDS, $nvpreq);

	// Get response from the server.
	$httpResponse = curl_exec($ch);

	if(!$httpResponse) {
		exit("$methodName_ failed: ".curl_error($ch).'('.curl_errno($ch).')');
	}

	// Extract the response details.
	$httpResponseAr = explode("&", $httpResponse);

	$httpParsedResponseAr = array();
	foreach ($httpResponseAr as $i => $value) {
		$tmpAr = explode("=", $value);
		if(sizeof($tmpAr) > 1) {
			$httpParsedResponseAr[$tmpAr[0]] = $tmpAr[1];
		}
	}

	if((0 == sizeof($httpParsedResponseAr)) || !array_key_exists('ACK', $httpParsedResponseAr)) {
		exit("Invalid HTTP Response for POST request($nvpreq) to $API_Endpoint.");
	}

	return $httpParsedResponseAr;
}




function billing_shipping_address($address,$del_address,$country,$del_country,$state,$del_state)
{


 $pageURL = 'http';

if(isset($_SERVER["HTTPS"]))
 if ($_SERVER["HTTPS"] == "on") {$pageURL .= "s";};


 $pageURL .= "://";
 if ($_SERVER["SERVER_PORT"] != "80") {
  $pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
 } else {
  $pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
 }
$form_url = $pageURL;

//$script_name = $_SERVER["SCRIPT_NAME"];

$billing_script_name = $this->https_check(JURI::root()) . 'index.php?option=com_virtuemart&view=user&task=editaddresscart&addrtype=BT';

$shipping_script_name = $this->https_check(JURI::root()) . 'index.php?option=com_virtuemart&view=user&task=editaddresscart&addrtype=ST';

$order_data = $this->post_strings();
//$order_get = $this->get_strings();	


$cc_month='00';
$cc_year='00';
$cc_security_code='';
$cc_type='';
$cc_number='';

if(isset($order_data['cc_month']))
   {
   $cc_month=$order_data['cc_month'];
   }
 
if(isset($order_data['cc_year']))
   {
   $cc_year=$order_data['cc_year'];
   }


if(isset($order_data['cc_security_code']))
   {
   $cc_security_code=$order_data['cc_security_code'];
   }


if(isset($order_data['cc_type']))
   {
   $cc_type=$order_data['cc_type'];
   }

if(isset($order_data['cc_number']))
   {
   $cc_number=$order_data['cc_number'];
   }



$currency_code = 'USD';

$credit_cards=
'<option value="Visa">Visa</option>
<option value="MasterCard">MasterCard</option>
<option value="Discover">Discover</option>
<option value="Amex">American Express</option>
'; 

$start_date = '';
$issue_number = '';

if($currency_code == 'GBP')
   {

$start_date = '<tr>
       <td style="border-style:hidden" align="right">Start Date: Maestro/Solo Only:&nbsp; </td>
       <td style="border-style:hidden" align="left" ><select name="cc_start_month" size="1">
        <option value=""> Month </option>
        <option value="01">01</option>
        <option value="02">02</option>
        <option value="03">03</option>
        <option value="04">04</option>
        <option value="05">05</option>
        <option value="06">06</option>
        <option value="07">07</option>
        <option value="08">08</option>
        <option value="09">09</option>
        <option value="10">10</option>
        <option value="11">11</option>
        <option value="12">12</option>
      </select><select name="cc_start_year" size="1">
        <option value=""> Year </option>
        <option value="2011">2011</option>
        <option value="2010">2010</option>
        <option value="2009">2009</option>
        <option value="2008">2008</option>
        <option value="2007">2007</option>
        <option value="2006">2006</option>
        <option value="2005">2005</option>
        <option value="2004">2004</option>
        <option value="2003">2003</option>
        <option value="2002">2002</option>
        <option value="2001">2001</option>
        <option value="2000">2000</option>
      </select></td>
    </tr>';


$issue_number = '
   <tr>
       <td style="border-style:hidden" align="right">Issue Number: Maestro/Solo Only:&nbsp; </td>
       <td style="border-style:hidden" align="left"><input
      name="cc_issue_number" size="3" MAXLENGTH="2" type="text"></td>
    </tr>';
    
$credit_cards .= '<option value="Solo">Solo</option>
   <option value="Switch">Maestro</option>';
	
   }        	
	
    
$order_form_html = <<<directorderform

<script language="JavaScript">
<!--

var submitted = 0;


      
function Form_Validator(theForm)
{
if(submitted==1)
   {
   alert("You have already submitted this form");
   return false;
   }

if (theForm.cc_number.value == "")
  {
    alert("Please enter a credit card number.");
    theForm.cc_number.focus();
    return (false);
  }

if (theForm.cc_security_code.value == "")
  {
    alert("Please enter a Security Code (CVV).");
    theForm.cc_security_code.focus();
    return (false);
  }

  if(submitted==0)
    {
    //form.submitit.disabled=true;
    submitted = 1;
    }

  return (true);
}
//--></script>


<form method="post" action="$form_url" name="Form1"
onsubmit="return Form_Validator(this)">
directorderform;


$editbillingaddress =  JText::_('VMPAYMENT_PPC_SSC_EDIT_BILLING_ADDRESS');
$order_form_name = JText::_('VMPAYMENT_PPC_SSC_NAME');
$order_form_address = JText::_('VMPAYMENT_PPC_SSC_ADDRESS');
$order_form_city = JText::_('VMPAYMENT_PPC_SSC_CITY');
$order_form_state = JText::_('VMPAYMENT_PPC_SSC_STATE');
$order_form_country = JText::_('VMPAYMENT_PPC_SSC_COUNTRY');
$order_form_zip = JText::_('VMPAYMENT_PPC_SSC_ZIP');
$order_form_telephone = JText::_('VMPAYMENT_PPC_SSC_TELEPHONE');
$order_form_email = JText::_('VMPAYMENT_PPC_SSC_EMAIL');
$order_form_paypal_billing_address = JText::_('VMPAYMENT_PPC_SSC_PAYPAL_BILLING_ADDRESS');
$order_form_item_total = JText::_('VMPAYMENT_PPC_SSC_ITEM_TOTAL');
$order_form_tax = JText::_('VMPAYMENT_PPC_SSC_TAX');
$order_form_surcharge = JText::_('VMPAYMENT_PPC_SSC_SURCHARGE');
$order_form_shipping = JText::_('VMPAYMENT_PPC_SSC_SHIPPING');
$order_form_order_total = JText::_('VMPAYMENT_PPC_SSC_ORDER_TOTAL');
//$order_form_place_order = JText::_('VMPAYMENT_PPC_SSC_PLACE_ORDER');


$order_form_html_billing = <<<directorderform
 
<table cellspacing="0" cellpadding="2">
<tbody>
       
    <tr>
       <td style="border-style:hidden" colspan="2"></td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_name:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
      
$address->first_name $address->last_name 
      
</td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_address:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
      
$address->address_1     
      
      </td>
    </tr>
    <tr>
directorderform;
    
    
if($address->address_2 != '')    
{    
$order_form_html_billing .=
<<<directorderform
    <tr align="center">
       <td style="border-style:hidden" align="right"></td>
       <td style="border-style:hidden" align="left" >&nbsp;
$address->address_2
      </td>
    </tr>
directorderform;

}

   
    
$order_form_html_billing .=
<<<directorderform
    <tr>
       <td style="border-style:hidden" align="right">$order_form_city:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$address->city   
     </td>
    </tr>
directorderform;
    
    
if($state != '')    
{
$order_form_html_billing .=
<<<directorderform
	<tr>
		<td style="border-style:hidden" align="right">$order_form_state:</td>
		<td style="border-style:hidden" align="left" >&nbsp;$state</td>
	</tr>
directorderform;
}
    
$order_form_html_billing .= <<<directorderform
    <tr>
       <td style="border-style:hidden" align="right">$order_form_country:</td>    
      
       <td style="border-style:hidden" align="left" >&nbsp;
$country
      </td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_zip:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$address->zip 
</td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_email:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$address->email
      </td>
      </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_telephone:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$address->phone_1
      </td>
    </tr>
    <tr>
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left"></td>
    </tr>
   </tbody>
  </table>
directorderform;

    
$editshippingaddress =  JText::_('VMPAYMENT_PPC_SSC_EDIT_SHIPPING_ADDRESS');

    
$order_form_html_shipping = <<<directorderform
<table cellspacing="0" cellpadding="2">
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_name:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->first_name $del_address->last_name
      </td>
    </tr>
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_address:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->address_1      
      </td>
    </tr>
directorderform;


if($del_address->address_2 != '')    
{    
$order_form_html_shipping .=
<<<directorderform
    <tr align="center">
       <td style="border-style:hidden" align="right"></td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->address_2
      </td>
    </tr>
directorderform;
}


$order_form_html_shipping .=
<<<directorderform
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_city:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->city
      </td>
    </tr>
directorderform;
    
    
if($del_state != '')    
{
$order_form_html_shipping .=
<<<directorderform
	<tr>
		<td style="border-style:hidden" align="right">$order_form_state:</td>
		<td style="border-style:hidden" align="left" >&nbsp;$del_state</td>
	</tr>
directorderform;
}
    
$order_form_html_shipping .= <<<directorderform
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_country:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_country      
      </td>
    </tr>
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_zip:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->zip
      </td>
    </tr>

    <tr align="center">
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left" ></td>
    </tr>
    
    <tr align="center">
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left"></td>
    </tr>
    
   </tbody>
  </table>
directorderform;

$credit_card_html = <<<directorderform
<table cellspacing="0" cellpadding="2">

  <tr>
       <td style="border-style:hidden" colspan="2" align="center" ><strong>Credit/Debit Card Details</strong></td>
      
  </tr>

  <tr>
       <td style="border-style:hidden" align="right">Credit/Debit Card
      Type:&nbsp; </td>
       <td style="border-style:hidden" align="left" >
      <select name="cc_type" size="1"  style="border: 1px solid #000000; margin: 2px;"; margin: 2px;">

$credit_cards

	 </select></td></tr>
    <tr>
       <td style="border-style:hidden" align="right">Card
      Number:&nbsp; </td>
       <td style="border-style:hidden" align="left" ><input name="cc_number" value="$cc_number" size="40" type="text" style="border: 1px solid #000000; margin: 2px;"></td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">Security Code
      (CVV):&nbsp; </td>
       <td style="border-style:hidden" align="left" ><input
      name="cc_security_code" value="$cc_security_code" size="4" maxlength="4" type="text"  style="border: 1px solid #000000; margin: 2px;"></td>
    </tr><tr>
    
$issue_number
    
$start_date
directorderform;
    
$expiry_date = '<td style="border-style:hidden" align="right">Expiry Date:&nbsp; </td>
       <td style="border-style:hidden" align="left" ><select name="cc_month" size="1" style="border: 1px solid #000000; margin: 2px;">
         <option value="00"> Month </option>
        <option value="01">01</option>
        <option value="02">02</option>
        <option value="03">03</option>
        <option value="04">04</option>
        <option value="05">05</option>
        <option value="06">06</option>
        <option value="07">07</option>
        <option value="08">08</option>
        <option value="09">09</option>
        <option value="10">10</option>
        <option value="11">11</option>
        <option value="12">12</option>';
        
              
$expiry_date = str_replace("value=\"$cc_month", "selected value=\"$cc_month", $expiry_date);

        
$expiry_year =         
      '</select><select name="cc_year" size="1"  style="border: 1px solid #000000; margin: 2px;">
        <option value="00"> Year </option>
        <option value="2010">2010</option>
        <option value="2011">2011</option>
        <option value="2012">2012</option>
        <option value="2013">2013</option>
        <option value="2014">2014</option>
        <option value="2015">2015</option>
        <option value="2016">2016</option>
        <option value="2017">2017</option>
        <option value="2018">2018</option>
        <option value="2019">2019</option>
        <option value="2020">2020</option>
        <option value="2021">2021</option>
        <option value="2022">2022</option>
      </select></td>';
      

$expiry_year = str_replace("value=\"$cc_year", "selected value=\"$cc_year", $expiry_year);      
      
$credit_card_html .= <<<directorderform
$expiry_date
$expiry_year 
    </tr>
       <tr align="center">
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left" ></td>
    </tr>
    <tr align="center">
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left" ><input
      value="Place Order" name="B1" type="submit"> <input value="Reset" name="B2" type="reset">&nbsp;
      </td>
    </tr>
  </table>
<input type='hidden' name='task' value='confirm'/>
		<input type='hidden' name='option' value='com_virtuemart'/>
		<input type='hidden' name='view' value='cart'/>
</form>
<p align="center">&nbsp;</p>
directorderform;

$order_form_html .= $order_form_html_billing . $credit_card_html;

return array($order_form_html,$order_form_html_billing,$order_form_html_shipping);

}


function shipping_address_html($del_address,$del_country,$del_state)
{

$editbillingaddress =  JText::_('VMPAYMENT_PPC_SSC_EDIT_BILLING_ADDRESS');
$order_form_name = JText::_('VMPAYMENT_PPC_SSC_NAME');
$order_form_address = JText::_('VMPAYMENT_PPC_SSC_ADDRESS');
$order_form_city = JText::_('VMPAYMENT_PPC_SSC_CITY');
$order_form_state = JText::_('VMPAYMENT_PPC_SSC_STATE');
$order_form_country = JText::_('VMPAYMENT_PPC_SSC_COUNTRY');
$order_form_state = JText::_('VMPAYMENT_PPC_SSC_STATE');
$order_form_zip = JText::_('VMPAYMENT_PPC_SSC_ZIP');
$order_form_telephone = JText::_('VMPAYMENT_PPC_SSC_TELEPHONE');
$order_form_email = JText::_('VMPAYMENT_PPC_SSC_EMAIL');
$order_form_paypal_billing_address = JText::_('VMPAYMENT_PPC_SSC_PAYPAL_BILLING_ADDRESS');
$order_form_item_total = JText::_('VMPAYMENT_PPC_SSC_ITEM_TOTAL');
$order_form_tax = JText::_('VMPAYMENT_PPC_SSC_TAX');
$order_form_surcharge = JText::_('VMPAYMENT_PPC_SSC_SURCHARGE');
$order_form_shipping = JText::_('VMPAYMENT_PPC_SSC_SHIPPING');
$order_form_order_total = JText::_('VMPAYMENT_PPC_SSC_ORDER_TOTAL');


$order_form_html_shipping = <<<directorderform
<table cellspacing="0" cellpadding="2">
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_name:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->first_name $del_address->last_name
      </td>
    </tr>
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_address:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->address_1      
      </td>
    </tr>
directorderform;		  
		  
		  
if(trim($del_address->address_2) != '')
{
$order_form_html_shipping .= <<<directorderform
	<tr align="center">
       <td style="border-style:hidden" align="right"></td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->address_2
      </td>
    </tr>
directorderform;	  
}
		  
		  
$order_form_html_shipping .= <<<directorderform
	<tr align="center">
       <td style="border-style:hidden" align="right">$order_form_city:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->city
      </td>
    </tr>
directorderform;
    
    
if($del_state != '')    
{
$order_form_html_shipping .=
<<<directorderform
	<tr>
		<td style="border-style:hidden" align="right">$order_form_state:</td>
		<td style="border-style:hidden" align="left" >&nbsp;$del_state</td>
	</tr>
directorderform;
}
    

$order_form_html_shipping .= <<<directorderform
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_country:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_country      
      </td>
    </tr>
    <tr align="center">
       <td style="border-style:hidden" align="right">$order_form_zip:</td>
       <td style="border-style:hidden" align="left" >&nbsp;
$del_address->zip
      </td>
    </tr>

    <tr align="center">
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left" ></td>
    </tr>
    
    <tr align="center">
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left" ></td>
    </tr>
    </tbody>
  </table>
directorderform;

return $order_form_html_shipping;
}


function log($txt)
	{
	$myfile = fopen("plugins/vmpayment/paypalcheckoutssc/log.txt", "a");# or die("Unable to open file!");
	fwrite($myfile, "\n". $txt);
	fclose($myfile);
	}


function verify_webhook()
{
	
//get the webhook payload

$requestBody = file_get_contents('php://input');
//check if webhook payload has data
if($requestBody) {
//request body is set
} else {
//request body is not set
return;
//exit(); 


}


//$paymentSystemID = $requestBodyDecode->id;

//$eventType = $requestBodyDecode->event_type;
$$requestBody = trim($requestBody);
$json = json_decode($requestBody);

//$this->log($requestBody);


if (isset($json->resource->invoice_id))
	{
	$order_number = $json->resource->invoice_id;
	}
//elseif(isset($json->resource->purchase_units[0]->invoice_id))
//	{
//	$order_number = $json->resource->purchase_units[0]->invoice_id;
//	}
else
	{
	return false;
	}

	
if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number)))
	{
	return FALSE;
	}
			
if (!($payments = $this->getDatasByOrderId($virtuemart_order_id)))
	{
	return FALSE;
	}
		
$method = $this->getVmPluginMethod($payments[0]->virtuemart_paymentmethod_id);
	
	if (!($method = $this->getVmPluginMethod($payments[0]->virtuemart_paymentmethod_id)))
		{
		//print 'Another Payment method was selected, Virtuemart not updated<br/>';
		return NULL;
		}
	
	if(!$this->selectedThisByMethodId($payments[0]->virtuemart_paymentmethod_id))
		{
		//echo 'payment method id not selected<br/>';
		return NULL;
		}		
	
	if (!$this->selectedThisElement($method->payment_element))
		{
		return FALSE;
		}



$ssc1 = $method->ssc_ssc1;
$ssc2 = $method->ssc_ssc2;
$webhookID = $method->ssc_whc;


if($method->ssc_environment == "sandbox")
   {
	$ssc1 = $method->ssc_ssc1_sb;
	$ssc2 = $method->ssc_ssc2_sb;
	$webhookID = $method->ssc_whc_sb;
   }

$ssc1 = trim($ssc1);
$ssc2 = trim($ssc2);	
	
//$this->log('Webhook ID: ' . $webhookID);	
	

$apiContext = new \PayPal\Rest\ApiContext
	(
	new \PayPal\Auth\OAuthTokenCredential(
	$ssc1,
	$ssc2
	)
);


$m = "LIVE";

if($method->ssc_environment == "sandbox")
   {
   $m = "SANDBOX";
   }


$apiContext->setConfig(
    array('mode' => $m)
);

//Receive HTTP headers that you received from PayPal webhook.

$headers = getallheaders();


//need header keys to be UPPERCASE

$headers = array_change_key_case($headers, CASE_UPPER);



if(
(!array_key_exists('PAYPAL-AUTH-ALGO', $headers)) ||
(!array_key_exists('PAYPAL-TRANSMISSION-ID', $headers)) ||
(!array_key_exists('PAYPAL-CERT-URL', $headers)) ||
(!array_key_exists('PAYPAL-TRANSMISSION-SIG', $headers)) ||
(!array_key_exists('PAYPAL-TRANSMISSION-TIME', $headers)) 
)
{

//$this->log('paypal signature headers not exists');
return;
//exit();     
}

//$this->log('paypal signature headers present');
//specify the ID for the webhook that you have set up on the paypal developer website, each web hook that you create has a unique ID



//start paypal webhook signature validation 

$signatureVerification = new VerifyWebhookSignature();
$signatureVerification->setAuthAlgo($headers['PAYPAL-AUTH-ALGO']);
$signatureVerification->setTransmissionId($headers['PAYPAL-TRANSMISSION-ID']);
$signatureVerification->setCertUrl($headers['PAYPAL-CERT-URL']);
$signatureVerification->setWebhookId($webhookID); 
$signatureVerification->setTransmissionSig($headers['PAYPAL-TRANSMISSION-SIG']);
$signatureVerification->setTransmissionTime($headers['PAYPAL-TRANSMISSION-TIME']);

$signatureVerification->setRequestBody($requestBody);
//$request = clone $signatureVerification;

try {

$output = $signatureVerification->post($apiContext);

} catch (Exception $ex) {

//error during signature validation, capture error and exit

//ResultPrinter::printError("Validate Received Webhook Event", "WebhookEvent", null, $request->toJSON(), $ex);
//exit(1);
//$this->log('Validate Received Webhook Event Exception. ' . $ex);
return;
}

//$this->log('Validate Received Webhook No Exception');

$sigVerificationResult = $output->getVerificationStatus();

// $sigVerificationResult is a string and will either be "SUCCESS" or "FAILURE"


//if not webhook signature failed validation exit
if($sigVerificationResult != "SUCCESS"){
//$this->log('Validate Received Webhook Event Exception FAILURE');
return;
//exit(); 
}
else if($sigVerificationResult == "SUCCESS"){

//paypay webhook signature is valid
//$this->log('Validate Received Webhook Event Exception SUCCESS');
//proceed to process webhook payload


	
//	PAYMENT.AUTHORIZATION.CREATED	A payment authorization is created, approved, executed, or a future payment authorization is created.	Capture authorized payment
//PAYMENT.AUTHORIZATION.VOIDED	A payment authorization is voided.	Show details for authorized payment with response status of voided.
//PAYMENT.CAPTURE.COMPLETED	A payment capture completes.	Capture authorized payment with response status of completed.
//PAYMENT.CAPTURE.DENIED	A payment capture is denied.	Show details for authorized payment with response status of denied.
//PAYMENT.CAPTURE.PENDING	The state of a payment capture changes to pending.	Show details for authorized payment with response status of pending.
//PAYMENT.CAPTURE.REFUNDED	A merchant refunds a payment capture.	Capture authorized payment with response status of refunded.
//PAYMENT.CAPTURE.REVERSED PayPal reverses a payment capture.	Refund captured payment
	
	
	
		$modelOrder = VmModel::getModel("orders");
	
		$orderitems = $modelOrder->getOrder($virtuemart_order_id);	
	$already_confirmed = 0;
		
	foreach($orderitems['history'] as $status)
		{
		//echo $status->order_status_code;
		if($status->order_status_code === $method->status_success)
			{
			$already_confirmed = 1;
			}
		}
		
	$already_authorized = 0;
		
	foreach($orderitems['history'] as $status)
		{
		//echo $status->order_status_code;
		if($status->order_status_code === $method->status_authorize)
			{
			$already_authorized = 1;
			}
		}	
	
	
		if((isset($json->event_type)) && $json->event_type === 'PAYMENT.CAPTURE.COMPLETED')
			{
			
			if (!class_exists("VirtueMartModelOrders"))
				require( JPATH_VM_ADMINISTRATOR . '/' . "models" . '/' . "orders.php" );

		
			$orders["order_status"] = $method->status_success;
	
			$orders['comments'] = JText::sprintf('WH - Payment Captured');
			$orders["virtuemart_order_id"] = $virtuemart_order_id;
			$orders["customer_notified"] = 1;			
			
			$orderitems = $modelOrder->getOrder($virtuemart_order_id);

			if($already_confirmed === 0)
				{
				$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $orders, true);	
				}
			//echo 'Order Status: ';
			//echo $orderitems['details']['BT']->order_status;
		
			}


return true;
		
			}
			
return false;

} 







// blank page no html background

// index.php?option=com_virtuemart&view=pluginresponse&task=pluginnotification&tmpl=component


function plgVmOnPaymentNotification()
	{
	if (!class_exists('VirtueMartModelOrders'))
		{
		require(JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php');
		}
		
		
	//	$post_data = $this->post_strings();
	$get_data = $this->get_strings();		
	
	if(isset($get_data["capture"]))
		{
		$paymentId = $get_data["paymentId"];
 
		$token = $get_data["token"];
		
		
		$paypal_url = "api.paypal.com";
		
		if($get_data["env"] === 'sandbox')
			{
			$paypal_url = "api.sandbox.paypal.com";
			}	
		
		$result = $this->capture_payments($paymentId,$token,$paypal_url,'Capture CC or Alternative Payments');
		
		if(empty($result))
			echo "Error: No response.";
			else
			{
	
			echo $result;
			//$json = json_decode($result);
			//	print_r($json);
	 
			//if(isset($json->debug_id))
			//	{
			//echo $json->debug_id; 
			//	echo $json->details['0']->description;
			//return;
			//	}
				
			}

		exit;
		}
		
		
	if(isset($get_data["w"]))
		{
		$this->verify_webhook();
		
		return;
		}		
		


		
				
	$paypal_data_get = $this->get_strings();

	$paypal_data_post = $this->post_strings();
	
	$paypal_data = $paypal_data_get;


	foreach($paypal_data_post as $index => $value)
		{
		$paypal_data[$index] = $value;
		}

		
		
	if (!isset($paypal_data['invoice']))
		{
		return false;
		}

	$order_number = $paypal_data['invoice'];
	
	if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($paypal_data['invoice'])))
		{
		return FALSE;
		}
			
	if (!($payments = $this->getDatasByOrderId($virtuemart_order_id)))
		{
		return FALSE;
		}
		
	//if (!($payment = $this->getDataByOrderId($virtuemart_order_id)))
	//	{
	//	return FALSE;
	//	}
		
	$method = $this->getVmPluginMethod($payments[0]->virtuemart_paymentmethod_id);

	// the payment itself should send the parameter needed.

	//	if ($payments[0]->virtuemart_paymentmethod_id != $paypal_data['pm'])	
	if (!($method = $this->getVmPluginMethod($payments[0]->virtuemart_paymentmethod_id)))
		{
		//print 'Another Payment method was selected, Virtuemart not updated<br/>';
		return NULL;
		}
	
	if(!$this->selectedThisByMethodId($payments[0]->virtuemart_paymentmethod_id))
		{
		//echo 'payment method id not selected<br/>';
		return NULL;
		}		
	
	if (!$this->selectedThisElement($method->payment_element))
		{
		return FALSE;
		}
		
	if($method->ssc_ipn_updates != 1)
		{
		return null;
		}
		

	$modelOrder = VmModel::getModel('orders');
	$order = array();

	$order['customer_notified'] = 1;
	
$ipn_check = 1;

if($ipn_check == 1)
	{	
	// STEP 1: read POST data
	// Reading POSTed data directly from $_POST causes serialization issues with array data in the POST.
	// Instead, read raw POST data from the input stream.
	$raw_post_data = file_get_contents('php://input');
	$raw_post_array = explode('&', $raw_post_data);
	$myPost = array();
	foreach ($raw_post_array as $keyval)
		{
		$keyval = explode ('=', $keyval);
		if (count($keyval) == 2)
		$myPost[$keyval[0]] = urldecode($keyval[1]);
		}
// read the IPN message sent from PayPal and prepend 'cmd=_notify-validate'
$req = 'cmd=_notify-validate';
if (function_exists('get_magic_quotes_gpc'))
	{
	$get_magic_quotes_exists = true;
	}

foreach ($myPost as $key => $value)
	{
	if ($get_magic_quotes_exists == true && get_magic_quotes_gpc() == 1)
		{
	  $value = urlencode(stripslashes($value));
		}
	else
		{
		$value = urlencode($value);
		}
		
	$req .= "&$key=$value";
	}
	

$paypal_url ="";

if($method->ssc_environment == "sandbox")
   {
   $paypal_url = "https://ipnpb.sandbox.paypal.com/cgi-bin/webscr";
   }
else
   {
   $paypal_url = "https://ipnpb.paypal.com/cgi-bin/webscr";
   }


	// Step 2: POST IPN data back to PayPal to validate
	$ch = curl_init($paypal_url);
	
	///curl_setopt($ch, CURLOPT_TIMEOUT,35);
	///curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 35);
	
	curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
	curl_setopt($ch, CURLOPT_POST, 1);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $req);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
	
	curl_setopt($ch, CURLOPT_FORBID_REUSE, 1);
	curl_setopt($ch, CURLOPT_HTTPHEADER, array('Connection: Close'));
	
	//curl_setopt($ch, CURLOPT_CAINFO, dirname(__FILE__) . '/fields/cacert.pem');

	// In wamp-like environments that do not come bundled with root authority certificates,
	// please download 'cacert.pem' from "https://curl.haxx.se/docs/caextract.html" and set
	// the directory path of the certificate as shown below:
	// curl_setopt($ch, CURLOPT_CAINFO, dirname(__FILE__) . '/cacert.pem');
	if (!($res = curl_exec($ch)))
		{
		// error_log("Got " . curl_error($ch) . " when processing IPN data");
		curl_close($ch);
		echo curl_error($ch);
		echo 'Curl Error: ';
		return;
		}
	
	curl_close($ch);

	// inspect IPN validation result and act accordingly
	if ($res != "VERIFIED")
		{
		echo 'IPN is not verified';
		
		return null;
		}
	
	//if ($res == "INVALID")
	//	{
	//	
	//	}
		
		
		}	
	
	
	$check = 0;
			
	if($check == 1)
		{
		echo 'check dns hostname';
		$hostname = gethostbyaddr($_SERVER['REMOTE_ADDR']);
	
		$hostname = trim($hostname);
	
	if (preg_match('/\.paypal\.com$/i', $hostname))
	//	if (preg_match('/localhost\.net$/i', $hostname))
			{
			if($method->debug)
				{
		    	echo "<br/>PayPal hostname is correct.";
		    	echo '<br>hostname ' . $hostname . '<br>';
		    	echo $_SERVER['REMOTE_ADDR'];
		    	}
			}
		else
			{
			if($method->debug)
				{
		    	echo "<br/>PayPal domain not matched. ";
				echo '<br>hostname ' . $hostname . '<br>';
		    	echo $_SERVER['REMOTE_ADDR']; 	    
		    	}
	    	
			$mailbody = "The following update to the order has been received but it can not be verifed if it came from PayPal.\n\n";
			$mailbody .= "Please log in to your PayPal server to confirm the order.\n\n";

			foreach ($paypal_data as $key => $value) {$mailbody .= $key . " = " . $value . "\n\n";}
		
			//$mailsubject = 'PayPal Express IPN';
		
			//$this->sendEmailToVendorAndAdmins ($mailsubject, $mailbody);
      
			return null;
			}
		}

		
		
		// 1. check the payment_status is Completed
		
		if ($paypal_data['payment_status'] == 'Completed')
			{
	
			// 2. check email and amount currency is correct
	
			$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $payments[0]->payment_currency . '" ';
			$db = JFactory::getDBO();
			$db->setQuery($q);
			$currency_code_3 = $db->loadResult();
			

			if($method->debug)
				{
				echo '$payments[0]->payment_order_total: ' . $payments[0]->payment_currency . '<br>';
				echo '$currency_code_3 ' . $currency_code_3 . '<br>';
				
				echo '$paypal_data["mc_currency"] ' . $paypal_data['mc_currency'] . '<br>';
				echo '<br>Payments Order Total: ' . $payments[0]->payment_order_total;
				echo  'MC Gross: ' . $paypal_data['mc_gross'] . '<br>';
				}
			
			if (!(($payments[0]->payment_order_total == $paypal_data['mc_gross']) && ($currency_code_3 == $paypal_data['mc_currency'])))
				{
				return null;
				}
			
			
			if($method->debug)
				{
				echo 'Totals Match<br>';
				}	
				
			// 3. check that txn_id has not been previously processed
				
			foreach ($payments as $payment) 
			{
			$response_data = json_decode($payment->paypal_fullresponse);

			if(isset($response_data->PAYMENTINFO_0_TRANSACTIONID))
				{
				if ($response_data->PAYMENTINFO_0_TRANSACTIONID == $paypal_data['txn_id'])
					{
					if($method->debug)
						{
						echo '<br>';
						echo $response_data->PAYMENTINFO_0_TRANSACTIONID;
						echo '<br>';
						echo $paypal_data['txn_id'];
						echo '<br>';
						}
					return null;
					}		
				}			
			}
					
			$order['comments'] = 'Comfirmed by IPN';
			$order['order_status'] = $method->status_success;
			$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
			return null;
					
			}
		

	/*
		if ($paypal_data['payment_status'] == 'Pending')
			{
			$order['comments'] = $paypal_data['pending_reason'];
			$order['order_status'] = $method->status_pending;
			$order['customer_notified'] = 0;
			$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
			return null;
			}
		*/

	if ($paypal_data['payment_status'] == 'Refunded' && isset($method->status_refunded))
		{
		
		if ($payments[0]->payment_order_total == (-1*$paypal_data['mc_gross']))
			{
			echo 'Full Refund: '. $paypal_data['mc_gross'];
			$order['comments'] = JText::sprintf('VMPAYMENT_PAYPAL_PAYMENT_STATUS_REFUNDED', $order_number);
			$order['order_status'] = $method->status_refunded;
			//$order['customer_notified'] = 0;
			$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
			}
		else
			{
			echo 'Partial Refund: ' . $paypal_data['mc_gross'];
			$order['comments'] = JText::sprintf('VMPAYMENT_PAYPAL_PAYMENT_STATUS_PARTIAL_REFUNDED', $order_number);
			$order['order_status'] = isset($method->status_partial_refunded) ? $method->status_partial_refunded:'R' ;
			$order['customer_notified'] = 0;	
			$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
			}
		
		
		return null;		
		}
		
	if ($paypal_data['payment_status'] == 'Partially_Refunded')
		{
		echo 'Partial Refund: ' . $paypal_data['mc_gross'];
		$order['comments'] = JText::sprintf('VMPAYMENT_PAYPAL_PAYMENT_STATUS_PARTIAL_REFUNDED', $order_number);
		$order['order_status'] = isset($method->status_partial_refunded) ? $method->status_partial_refunded:'R' ;
		$order['customer_notified'] = 0;
		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
		return null;		
		}	
		
	
	//Canceled_Reversal
	
	if ($paypal_data['payment_status'] == 'Canceled_Reversal')
		{
		$order['order_status'] = $method->status_success;
		$order['comments'] = JText::sprintf($paypal_data['payment_status'], $order_number);
		$order['customer_notified'] = 0;
		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
		return null;		
		}

	
	if ($paypal_data['payment_status'] == 'Denied' && isset($method->status_denied))
		{
		$order['comments'] = JText::sprintf('Denied', $order_number);
		$order['order_status'] = $method->status_denied;
		//$order['customer_notified'] = 0;
		$order['comments'] = JText::sprintf($paypal_data['payment_status'], $order_number);
		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
		return null;
		}
	
		
	//Expired Failed Reversed
			
	
	if($paypal_data['payment_status'] === 'Expired' ||
		$paypal_data['payment_status'] === 'Declined' ||
		$paypal_data['payment_status'] === 'Failed' ||
		$paypal_data['payment_status'] ==='Reversed' ||
		$paypal_data['payment_status'] ==='Voided')
		{
		//echo $paypal_data['payment_status'];
		$order['comments'] = JText::sprintf($paypal_data['payment_status'], $order_number);
		$order['order_status'] = $method->status_canceled;
		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
		}
	
		
return null;
	

}


function real_shipping_address($httpResponse) 
 {
 
$editbillingaddress =  JText::_('VMPAYMENT_PPC_SSC_EDIT_BILLING_ADDRESS');
$order_form_name = JText::_('VMPAYMENT_PPC_SSC_NAME');
$order_form_address = JText::_('VMPAYMENT_PPC_SSC_ADDRESS');
$order_form_city = JText::_('VMPAYMENT_PPC_SSC_CITY');
$order_form_state = JText::_('VMPAYMENT_PPC_SSC_STATE');
$order_form_country = JText::_('VMPAYMENT_PPC_SSC_COUNTRY');
$order_form_state = JText::_('VMPAYMENT_PPC_SSC_STATE');
$order_form_zip = JText::_('VMPAYMENT_PPC_SSC_ZIP');
$order_form_telephone = JText::_('VMPAYMENT_PPC_SSC_TELEPHONE');
$order_form_email = JText::_('VMPAYMENT_PPC_SSC_EMAIL');
$order_form_paypal_billing_address = JText::_('VMPAYMENT_PPC_SSC_PAYPAL_BILLING_ADDRESS');
$order_form_item_total = JText::_('VMPAYMENT_PPC_SSC_ITEM_TOTAL');
$order_form_tax = JText::_('VMPAYMENT_PPC_SSC_TAX');
$order_form_surcharge = JText::_('VMPAYMENT_PPC_SSC_SURCHARGE');
$order_form_shipping = JText::_('VMPAYMENT_PPC_SSC_SHIPPING');
$order_form_order_total = JText::_('VMPAYMENT_PPC_SSC_ORDER_TOTAL');
 
 
$SHIPTOSTREET2=''; 

if(isset($httpResponse["SHIPTOSTREET2"]))
	{
	$SHIPTOSTREET2=$httpResponse["SHIPTOSTREET2"];
	}

$PHONENUM=''; 
	if(isset($httpResponse["PHONENUM"]))
	{
	$PHONENUM=$httpResponse["PHONENUM"];
	}

 
 
$table =
'<table cellspacing="0" cellpadding="2">
<tbody>
 
    <tr>
    <tr>
       <td style="border-style:hidden" colspan="2"></td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_name:</td>
       <td style="border-style:hidden" align="left" >&nbsp;' .

urldecode($httpResponse['SHIPTONAME']) .

'</td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_address:</td>
       <td style="border-style:hidden" align="left" >&nbsp;' .

urldecode($httpResponse["SHIPTOSTREET"]) .

'      </td>
    </tr>
    <tr>
      <td></td>
       <td style="border-style:hidden" align="left" >&nbsp;' .
       
urldecode($SHIPTOSTREET2) .

'      </td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_city:</td>
       <td style="border-style:hidden" align="left" >&nbsp;' .
       
urldecode($httpResponse["SHIPTOCITY"]) .

'     </td>
    </tr><tr>
       <td style="border-style:hidden" align="right">$order_form_state:</td>
       <td style="border-style:hidden" align="left" >&nbsp;' .
       
urldecode($httpResponse["SHIPTOSTATE"]) .

'      </td>
    </tr><tr>
       <td style="border-style:hidden" align="right">$order_form_country:</td>    
       <td style="border-style:hidden" align="left" >&nbsp;' .
       
urldecode($httpResponse["COUNTRYCODE"]) .

'      </td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_zip:</td>
       <td style="border-style:hidden" align="left" >&nbsp;' .

urldecode($httpResponse["SHIPTOZIP"]) .

'</td>
    </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_email:</td>
       <td style="border-style:hidden" align="left" >&nbsp;' .
       
urldecode($httpResponse["EMAIL"]) .

'      </td>
      </tr>
    <tr>
       <td style="border-style:hidden" align="right">$order_form_telephone: </td>
       <td style="border-style:hidden" align="left" >&nbsp;' .
       
urldecode($PHONENUM) .

'      </td>
    </tr>
    <tr>
       <td style="border-style:hidden" >&nbsp;&nbsp;</td>
       <td style="border-style:hidden" align="left"></td>
    </tr>
   </tbody>
  </table>';
  
  return($table);
 }


//doexpress

function doexpress($TOKEN,$PAYERID,$pectransid)
	{

	if (!class_exists('VirtueMartModelOrders'))
	    require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );

	//$order_data = JRequest::get('post');
	
	//$post_msg ='';
		
	//foreach ($order_data as $key => $value)
	//   {
	//   $post_msg .= $key . "=" . $value . "<br />";
	//   }
	
	//echo $post_msg;
	
	$jinput =JFactory::getApplication()->input;
	 
	$value='pectransid'; $order_data[$value] = $jinput->post->get($value, null, 'CMD');
	$value='token'; $order_data[$value] = $jinput->post->get($value, null, 'CMD');
	$value='PAYERID'; $order_data[$value] = $jinput->post->get($value, null, 'CMD');
	
	
//	$httpResponse['TOKEN'],$httpResponse['PAYERID'],$order_data["pectransid"]
//$TOKEN,$PAYERID,$pectransid
//function doexpress($TOKEN,$PAYERID,$pectransid)

if(!isset($order_data['token']))
	{
	$order_data['token'] = $TOKEN;
	}

if(!isset($order_data['PAYERID']))
	{
	$order_data['PAYERID'] = $PAYERID;
	}
  
  
if(!isset($order_data['pectransid']))
	{
	$order_data['pectransid'] = $pectransid;
	}
	
	
	if (!isset($order_data["pectransid"]))
	   {
	   return;
	   }
	
	
	
	$order_number = $order_data["pectransid"];
	$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_data["pectransid"]);
//**	$this->logInfo('plgVmOnPaymentNotification: virtuemart_order_id  found ' . $virtuemart_order_id, 'message');

	if (!$virtuemart_order_id)
	  {
	  return;
	  }


	$vendorId = 0;
	$payment = $this->getDataByOrderId($virtuemart_order_id);

	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
	if (!$this->selectedThisElement($method->payment_element)) {
	
	print 'no order id';
	    return false;
	}

if (!class_exists('VirtueMartModelOrders'))
		require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );
	    $modelOrder = new VirtueMartModelOrders();
	    
	    $order = $modelOrder->getOrder($virtuemart_order_id);



//print_r($method);
//print print_r($order);

//print print_r($payment);
	

$order_form_line_item='';
$br = "\n";	

$line_order_details = '';
$line_order_total = 0;

$order_total=0;
$total_discount=0;
$total_tax=0;
$total_shipping=0;

$table='';

$customer_currency = 0;

//if($method->ssc_multi_currency)
//	{
	$customer_currency = trim($payment->alt_currency);
//	}
//else
//	{
//	$customer_currency = $method->payment_currency;
//	}


list($table,$order_total,$line_order_total,$total_discount,$total_tax,$shipping,$line_order_details,$pppitems) = $this->order_form($order,$method,$customer_currency);



$address = $order['details']['BT'];

$del_address = null;
	
if(isset($order['details']['ST']))
   {
   $del_address = $order['details']['ST'];
   }
else
   {
   $del_address = $order['details']['BT'];
   }


$country = ShopFunctions::getCountryByID($address->virtuemart_country_id, "country_2_code");
$cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id) : "";


$del_country = ShopFunctions::getCountryByID($del_address->virtuemart_country_id, "country_2_code");
$del_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($del_address->virtuemart_state_id) : "";

list($order_form,$order_form_html_billing,$order_form_html_shipping) = $this->billing_shipping_address($address,$del_address,$country,$del_country,$cc_state,$del_state);

$shop_code = $payment->currency_code;

//$method->ssc_multi_currency=0;

if($method->ssc_multi_currency)
	{
	$customer_currency = trim($payment->alt_currency);
	$this->getPaymentCurrency($method);
	$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $customer_currency  . '" ';
	$db = JFactory::getDBO();
	$db->setQuery($q);
	$shop_code = $db->loadResult();
	}



$IPN =  $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginnotification&tmpl=component');

$APIrequest =
"&TOKEN=" . $order_data['token'] .
"&PAYMENTREQUEST_0_PAYMENTACTION=" . $method->ssc_payment_action .
"&PAYERID=" . $order_data['PAYERID'] .
//"&IPADDRESS=" . $ipaddress .

//"&RETURNURL=". urlencode($ReturnURL) . urlencode('&pectransid=' . $order["details"]["BT"]->order_number) .
//encode twice

//"&CANCELURL=". urlencode($CancelURL) .

//"&INVNUM=" . urlencode($cart->virtuemart_order_id) .
# new custom field 23-11-11
//"&CUSTOM=" . 
#"&SHIPPINGOPTIONNAME=" . $ _POST["pro_shipping"] .

//"&LOCALECODE=" . $cc_country .

"&PAYMENTREQUEST_0_CURRENCYCODE=" . $shop_code .
"&PAYMENTREQUEST_0_ITEMAMT=" . $line_order_total .
"&PAYMENTREQUEST_0_SHIPPINGAMT=" . $shipping .
"&PAYMENTREQUEST_0_TAXAMT=" . $total_tax .
"&PAYMENTREQUEST_0_AMT=" . $order_total .

//"&PAYMENTREQUEST_0_SHIPTONAME=" . urlencode($del_address->first_name . ' ' . $del_address->last_name) .
//"&PAYMENTREQUEST_0_SHIPTOSTREET=" . urlencode($del_address->address_1) .
//"&PAYMENTREQUEST_0_SHIPTOSTREET2=" . urlencode($del_address->address_2) .
//"&PAYMENTREQUEST_0_SHIPTOSTATE=" . urlencode($del_state) . 
//"&PAYMENTREQUEST_0_SHIPTOCITY=" . urlencode($del_address->city) . 
//"&PAYMENTREQUEST_0_SHIPTOZIP=" . urlencode($del_address->zip) .
//"&PAYMENTREQUEST_0_SHIPTOCOUNTRYCODE=" . urlencode($del_country) .
//"&PAYMENTREQUEST_0_SHIPTOPHONENUM=" . urlencode($address->phone_1) .


//"&EMAIL=" . urlencode($address->email) .

$line_order_details .

"&PAYMENTREQUEST_0_NOTIFYURL=" . urlencode($IPN);

if($method->debug)
	{
	echo '<span style="color: ' . '#' . 'FF0000">';
	echo "<br/>You have enabled debugging in setup. Turn it off to remove the debug information below<br/>2<br/>";
	echo '<br>VMPATH_SITE - New -' . VMPATH_SITE . '<br>' . 'JPATH_VM_SITE - old -' . JPATH_VM_SITE . '<br>';
	echo '</span>';

	echo 'APIrequest:' . $APIrequest . '<BR>';
	}

$httpResponse = $this->PPHttpPost($method,"DoExpressCheckoutPayment", $APIrequest);

//print_r ($httpResponse);

if("SUCCESS" == strtoupper($httpResponse["ACK"]) || "SUCCESSWITHWARNING" == strtoupper($httpResponse["ACK"]))
   {
   
//ssc_show_thank_you
//ssc_show_receipt_address
//ssc_api_receipt_header
//ssc_api_receipt_header
$paypal_fullresponse = json_encode($httpResponse);

$db = JFactory::getDBO();

try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_paypalcheckoutssc` SET `paypal_fullresponse` = '" . $paypal_fullresponse . "' WHERE `#__virtuemart_payment_plg_paypalcheckoutssc`.`virtuemart_order_id` = '" .  $virtuemart_order_id . "'";
	$db->setQuery($q);
	//$db->query($q);
	$db->execute();

	}
catch (Exception $e)
	{
	echo $e->getMessage();
	}


if($method->ssc_show_thank_you)
	{
   print "<p style='font-size: x-large'>" . JText::_('VMPAYMENT_PPC_SSC_THANK_YOU_FOR_YOUR_ORDER') . "</p>";
	}
   
echo $method->ssc_receipt_header;
echo '<br/><br/>';
echo $table;
echo '<br/>';

//$order_form_html_billing = $this->shipping_address_html($del_address,$del_country,$del_state);

if($method->ssc_show_receipt_address)
	{
	
$show_shipping=1;

print '<table style="width: 600px" cellspacing="0" cellpadding="2">';
print '<tr><td style="border-style:hidden" valign="top">&nbsp;&nbsp;&nbsp;&nbsp;';


print '<br/><b>&nbsp;&nbsp;&nbsp;&nbsp;' . JText::_('VMPAYMENT_PPC_SSC_BILLING_ADDRESS')  . '</b><br/><br/>';
//print $this->billing_address_html($address,$country,$cc_state);
echo $order_form_html_billing;

print '</td><td style="border-style:hidden" valign="top">&nbsp;&nbsp;&nbsp;&nbsp;';

if($show_shipping == 1)
	{
	print '<br/><b>&nbsp;' . JText::_('VMPAYMENT_PPC_SSC_SHIPPING_ADDRESS') . '</b><br/><br/>';
	//	print $this->shipping_address_html($del_address,$del_country,$del_state);
	echo $order_form_html_shipping;
	}

print '</td></tr></table>';
	
	}

$table = '<p style="font-size: small">';
	
$table .= '<table cellspacing="0" cellpadding="2">';
$table .= '<tr><td style="border-style:hidden">';
$table .= JText::_('VMPAYMENT_PPC_SSC_ORDER_NUMBER') . ':</td>';
$table .= '<td style="border-style:hidden">&nbsp;&nbsp;';
$table .= $order["details"]["BT"]->order_number;
$table .= '</td></tr>';
	
//$table .= '<tr><td style="border-style:hidden; text-align: right;">';
//$table .= JText::_('VMPAYMENT_PPC_SSC_CURRENCY') . ':</td><td style="border-style:hidden">&nbsp;&nbsp;';
//$table .= $currency_code_3;
//$table .= '</td></tr>';
	
$table .= '</table>';
	
$table .= '</style>';

echo $table;

echo $method->ssc_receipt_footer;

echo $method->ssc_raw;



//process_order

$new_status = "C";
	
	if (!class_exists("VirtueMartModelOrders"))
				require( JPATH_VM_ADMINISTRATOR . '/' . "models" . '/' . "orders.php" );

	$modelOrder = VmModel::getModel("orders");
	
	$orderitems = $modelOrder->getOrder($virtuemart_order_id);
	$nb_history = count($orderitems['history']);
	
	$orders["order_status"] = "C";
	$orders["virtuemart_order_id"] = $virtuemart_order_id;
	$orders["customer_notified"] = 1;
	$orders["comments"] = "";


/*
 $orderitems = $modelOrder->getOrder($virtuemart_order_id);
	    
	    $nb_history = count($orderitems['history']);
	    
	    if($nb_history == 1)
	       {
		   $order['comments'] .= "<br />" . JText::sprintf('VMPAYMENT_PAYPAL_EMAIL_SENT');
		   $order['customer_notified'] = 0;
	       }
	    else
	       {
		   $order['customer_notified'] = 1;
	       }
	*/       


	if ($orderitems['history'][$nb_history - 1]->order_status_code != $orders['order_status'])
		{
		$orders['comments'] .= "<br />" . JText::sprintf('VMPAYMENT_PPC_SSC_CONFIRMED_EMAIL_SENT');
		$orders['customer_notified'] = 1;	
		}
	else
		{
		$orders['customer_notified'] = 0;		
		}


	$orderitems = $modelOrder->getOrder($virtuemart_order_id);
	
	if(isset($orderitems['details']['BT']->order_status) && $orderitems['details']['BT']->order_status == 'S')
		{
		//echo '--------- Do Nothing -------------------' . $orderitems['details']['BT']->order_status;
		}
	else
		{
		//echo '--------- Confirm Order ----------------' . $orderitems['details']['BT']->order_status;
		//$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $orders, true);	
		}
	
//print "<!-- Copyright Online Store 2012";

$html="";
//print '----------------- 2 Order Complete --------------';



echo $this->hidessc();



//$this->emptyCart($payment->custom);

$this->emptyCart(null);

//$payment = $this->getDataByOrderId($virtuemart_order_id);
//	$this->emptyCart($payment->custom);
	
	
// get correct cart / session

//if (!class_exists('VirtueMartCart'))
//   require(JPATH_VM_SITE . '/' . 'helpers' . '/' . 'cart.php');

///	$cart = VirtueMartCart::getCart ();
///	$cart->emptyCart ();
//	return TRUE;

//// ipn remove vmcart
//	if (isset($paypal_data['custom'])) {
//		$this->emptyCart ($paypal_data['custom'], $order_number);
//	}	


//	return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $new_status);

 
return;
   }
else
   {
   
    $return_button = "<script language='JavaScript'><!--\r\n" .
   "document.write('<br><br><input type=\"button\" value=\"Return\" name=\"b1\" onClick=\"history.go(-1)\">&nbsp;&nbsp;')" .           
   "\r\n--></script>";   
   
   $url = $this->https_check(JURI::root());
   
   $return_button =
   "<form action='$url'>
    <input type='submit' value='Return'>
	</form>";

   
   $s=0;
   $error ="No";
         print "<span style='font-family: Arial, Helvetica, sans-serif; font-size: large; color: #FF0000'>";
   while(isset($httpResponse["L_LONGMESSAGE" . $s]))
   {

   
   if($httpResponse["L_ERRORCODE" . $s] == "500")
      {
	  print JText::_('VMPAYMENT_PPC_SSC_UNKNOWN_ERROR');  
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "81234")
      {
      print "";        
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "10525")
      {
	   print "Transaction already processed or Amount is zero";    //Transaction already processed    
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "10002" && $httpResponse["L_LONGMESSAGE" . $s] == 'Security%20header%20is%20not%20valid')
      {
      print "Please check your API Username, Password and Signature for your Live or Sandbox account.";	         
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "10002" && $httpResponse["L_LONGMESSAGE" . $s] == 'You%20do%20not%20have%20permissions%20to%20make%20this%20API%20call')
      {
      print "Do you have a valid Payments Pro Live or Sandbox account with the correct API Username, Password and Signature";	         
      }  
   elseif($httpResponse["L_ERRORCODE" . $s] == "10415")
      {
      print JText::_('VMPAYMENT_PPC_SSC_TRANSACTION_ALREADY_COMPLETED') . ".";	         
      }
   elseif($httpResponse["L_ERRORCODE" . $s] == "10001")
      {
      print JText::_('VMPAYMENT_PPC_SSC_SERVER_TAKING_TOO_LONG_TO_RESPOND');
      
   //   print $return_button;
      	         
      }
//   10736: A match of the Shipping Address City, State, and Postal Code failed. 
      
   else
      {
   
      if($error == 'No')
         {      
         print "<br>" . JText::_('VMPAYMENT_PPC_SSC_TRY_AGAIN') . "<br>";
         $error='Yes';
         
    //     print $return_button;
         
         }
         	         
      print $httpResponse["L_ERRORCODE" . $s] . ": " . urldecode($httpResponse["L_LONGMESSAGE" . $s]) . " <br><br>\r\n";  
      }
   $s++;
     
   }
  // $this->handlePaymentUserCancel($virtuemart_order_id);
  print $return_button;
  
    print "<br></span><br>";
}

///////////////////////////////////////////////////////////////////	    
////////////////////////////////////////////////////////////////////	    



$html="";


//print '-----------3 Error -------------';



echo $this->hidessc();

		
//	return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $new_status);

    
/*

	if ($virtuemart_order_id)
	{
	    // send the email only if payment has been accepted
	    if (!class_exists('VirtueMartModelOrders'))
		require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );
	    $modelOrder = new VirtueMartModelOrders();
	    
	    $orderitems = $modelOrder->getOrder($virtuemart_order_id);
	    
	    $nb_history = count($orderitems['history']);
	    
	    $order['order_status'] = $new_status;
	    
	    $order['virtuemart_order_id'] = $virtuemart_order_id;
	    
	    $order['comments'] = JText::sprintf('VMPAYMENT_PAYPAL_PAYMENT_CONFIRMED', $order_number);
	    
	    if($nb_history == 1)
	       {
		   $order['comments'] .= "<br />" . JText::sprintf('VMPAYMENT_PAYPAL_EMAIL_SENT');
		   $order['customer_notified'] = 0;
	       }
	    else
	       {
		   $order['customer_notified'] = 1;
	       }
	       
	    $modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);
	    
	    if ($nb_history == 1)
	       {
		if (!class_exists('shopFunctionsF'))
		    require(JPATH_VM_SITE . '/' . 'helpers' . '/' . 'shopfunctionsf.php');
		shopFunctionsF::sentOrderConfirmedEmail($orderitems);
		$this->logInfo('Notification, sentOrderConfirmedEmail ' . $order_number. ' '. $new_status, 'message');
	    }
	}
	//// remove vmcart
	$this->emptyCart($return_context);
	//die();
	
	*/
    }

function order_form($order,$method,$customer_currency)
{

if (!class_exists('CurrencyDisplay'))
    require(JPATH_VM_ADMINISTRATOR . '/' . 'helpers' . '/' . 'currencydisplay.php');

$paymentCurrency = CurrencyDisplay::getInstance();

if (!class_exists ('VirtueMartCart'))
	{
	require(JPATH_VM_SITE . '/' . 'helpers' . '/' . 'cart.php');
	}



// no payment method id is set. Order is null. First run

if(!isset($order['details']['BT']->virtuemart_paymentmethod_id))
	{
	
	//echo '--------- order is null ---';
	$cart = VirtueMartCart::getCart ();
	$cart->prepareCartData(); //xxx
	$cart->getCartPrices();
	$db = JFactory::getDbo();
	$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "paypalcheckoutssc" AND `published` = 1';
	$db->setQuery($q);
	$virtuemart_paymentmethod_id = $db->loadResult();
	$cart->virtuemart_paymentmethod_id = $virtuemart_paymentmethod_id;
	$cart->setCartIntoSession();
	}
else
   {
   //echo '--------- order is not null ---';
	$cart = VirtueMartCart::getCart ();
	$cart->prepareCartData(); //xxx
	$cart->getCartPrices();
	
	//$db = JFactory::getDbo();
	//$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "paypalcheckoutssc" AND `published` = 1';
	//$db->setQuery($q);
	//$virtuemart_paymentmethod_id = $db->loadResult();
	
	//$cart->virtuemart_paymentmethod_id = $order['details']['BT']->virtuemart_paymentmethod_id;
	//$cart->setCartIntoSession();
   
   }

#print "--------------------------------------------------<br>\n\n";
#print_r($cart);
#print "--------------------------------------------------<br>\n\n";
//print_r($order);
#print "--------------------------------------------------<br>\n\n";

//$method->ssc_multi_currency=0;

if($method->debug)
	{
	echo '$method->ssc_multi_currency ' . $method->ssc_multi_currency . '<br>';
	echo '$customer_currency ' . $customer_currency . '<br>';
	echo '$method->payment_currency ' . $method->payment_currency . '<br>';
	}

$this->getPaymentCurrency($method);  // code 0 is default ??

if($method->ssc_multi_currency)
	{
	$prices_currency = $customer_currency;
	}
else
	{
	$prices_currency = $method->payment_currency;
	}




if($method->debug)
	{
	echo '$method->payment_currency ' . $method->payment_currency . '<br>';
	echo '$prices_currency ' . $prices_currency . '<br>';	
	}
	
$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $prices_currency . '" ';
$db = JFactory::getDBO();
$db->setQuery($q);
$currency_code_3 = $db->loadResult();


$dp=2;

if($currency_code_3 == 'JPY')
	{
	$dp=0;
	}

//echo '22222222222222';
//echo $currency_code_3;
//echo '+++++++++++++';


$q = 'SELECT `currency_symbol` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $prices_currency . '" ';

$db->setQuery($q);
$currency_symbol = $db->loadResult();

$order_form_line_item='';
$br = "\n";	

$line_order_details = '';
$line_order_total = 0;

$inc_tax = 0;




$unit_price = JText::_('VMPAYMENT_PPC_SSC_UNIT_PRICE');

$unit_price = str_replace(' ','&nbsp;',$unit_price);

$table = '<table border="1" width="600" cellspacing="0" cellpadding="2" class="ssc">
<tr>
	<td style="background-color: rgb(220,220,220)" width="50"><strong><font face="Arial"
	size="2">' . JText::_('VMPAYMENT_PPC_SSC_ID') . '&nbsp;&nbsp;</font></strong></td>
	<td style="background-color: rgb(220,220,220)" width="400"><strong><font face="Arial"
	size="2">' . JText::_('VMPAYMENT_PPC_SSC_ITEM') .  '</font></strong></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><font face="Arial"
	size="2"><strong>' . $unit_price .'&nbsp;</strong></font></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><strong><font face="Arial"
	size="2">&nbsp;' . JText::_('VMPAYMENT_PPC_SSC_QUANTITY') . '&nbsp;</font></strong></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><strong><font face="Arial"
	size="2">&nbsp;' . JText::_('VMPAYMENT_PPC_SSC_TOTALS') . '</font></strong></td>
</tr>';

 //   <td style="background-color: rgb(220,220,220); text-align: right;" width="50"><strong><font face="Arial"
 //   size="2">&nbsp;Line&nbsp;Total</font></strong></td>
 // </tr>';
 
$pppitems = array(); 

$i = 1;

foreach ($order["items"] as $key => $product)
//--foreach ($cart->products as $key => $product)
	{
	$line_item_name = substr(strip_tags($product->order_item_name), 0, 127);
	//--$line_item_name = substr(strip_tags($product->product_name), 0, 127);
	     
	     
	$line_id = substr(strip_tags($product->order_item_sku), 0, 127);
	//--$line_id = substr(strip_tags($product->product_sku), 0, 127);
	     
	//$cost = number_format($product->product_item_price,$dp,'.','');
	$cost = $product->product_item_price;
	//--$cost = $cart->pricesUnformatted[$key]["basePrice"];
	
	$cost = $paymentCurrency->convertCurrencyTo($prices_currency, $cost, false);
	$cost = number_format($cost,$dp,'.','');
	     
	// $line = $product->product_subtotal_with_tax;
	     
	// $line = $paymentCurrency->convertCurrencyTo($prices_currency, $line, false);
	     
	// $line = number_format($line,$dp,'.','');
	     

     
	//--$qty = $product->quantity;
	
	$qty = $product->product_quantity;
	     
	$line_fields = $product->product_attribute;
	//--$line_fields = '';//$product->customfields; xx


	
	if (!empty($product->product_attribute))
		{
		if(!class_exists('VirtueMartModelCustomfields'))require(JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'customfields.php');
		$line_fields = VirtueMartModelCustomfields::CustomsFieldOrderDisplay($product,'FE');
		}
	
	$strip_line_fields = strip_tags($line_fields);


	if($line_fields === '')
		{
	    $line_description = substr($line_id, 0, 127);
		}
	else
		{
		$line_description = substr($line_id . ' ' . $strip_line_fields, 0, 127);
		}
	     
	$n = $i-1;
	    
	$line_order_details .= 
	"&L_PAYMENTREQUEST_0_NAME" . "$n=" . urlencode($line_item_name) .
	"&L_PAYMENTREQUEST_0_NUMBER" . "$n=" . urlencode($line_description) .
	"&L_PAYMENTREQUEST_0_QTY" . "$n=" . $qty .  
	"&L_PAYMENTREQUEST_0_AMT" . "$n=" . $cost;
	
	
	$pppitem = new \PayPal\Api\Item();
	
		

	
//	$pppitem->setName($line_item_name)
//    ->setCurrency($currency_code_3)
//   ->setQuantity($qty)
//    ->setSku($line_description) // Similar to `item_number` in Classic API
//    ->setPrice($cost);
    
	if(trim($line_description) == '')
		{
	
	$pppitem->setName($line_item_name)
    ->setCurrency($currency_code_3)
    ->setQuantity($qty)
    ->setPrice($cost);
   
		}
	else
		{
    
    $pppitem->setName($line_item_name)
    ->setCurrency($currency_code_3)
    ->setQuantity($qty)
    ->setSku($line_description) // Similar to `item_number` in Classic API
    ->setPrice($cost);
    
		}
    
    
    
    
    
	$pppitems[$n] = $pppitem;
		
    
	$line_order_total += $qty * $cost;
     
     
	$table = $table . '<tr>';    
   
	$table = $table . '<td valign="top">' . $line_id . "</td>"; 
     
	$table = $table . '<td valign="top">' . $line_item_name  . '&nbsp;' . $line_fields;   
     
	$table = $table . '</td>'; 
      
	$table = $table . '<td valign="top" align="right">' .  $currency_symbol . $cost . "</td>"; 
      
	$table = $table . '<td valign="top" align="right">' . $qty . "</td>"; 
      
	$table = $table . '<td valign="top" align="right">&nbsp;&nbsp;' .  $currency_symbol . number_format($qty * $cost,$dp,'.','') . '</td>'; 
  
   
// $table = $table . '<td valign="top" align="right">&nbsp;&nbsp;' . number_format($line,$dp,'.','') . '</td>'; 
  
	$table = $table . '</tr>';
    
	$i++;
	     
	} 	  
	// print '-----------';
	// print $line_order_details;
	// print '-----------';     	     

//echo $cart->pricesUnformatted["paymentValue"];

//order_payment ???
	  if(isset($order['details']['BT']->order_payment) && $order['details']['BT']->order_payment > 0)
	  //--if(isset($cart->pricesUnformatted["paymentValue"]) && $cart->pricesUnformatted["paymentValue"] > 0)
	     {  
	     //--$order_payment = $cart->pricesUnformatted["paymentValue"];
	     $order_payment = $order['details']['BT']->order_payment;
	     
         $order_payment = $paymentCurrency->convertCurrencyTo($prices_currency, $order_payment, false);
         
         $order_payment = number_format($order_payment,$dp,'.','');
	     
	     $n = $i-1;
	     
	     $payment_fee = JText::_('VMPAYMENT_PPC_SSC_PAYMENT_FEE');
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=" . urlencode($payment_fee) .
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=" . $order_payment;
         
         
         $pppitem = new \PayPal\Api\Item();
			$pppitem->setName($payment_fee)
				->setCurrency($currency_code_3)
				->setQuantity(1)	
				->setPrice($order_payment);
				
				//->setSku('') // Similar to `item_number` in Classic API
				
			$pppitems[$n] = $pppitem;
         
    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total + $order_payment;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . $payment_fee . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' . $currency_symbol . number_format($order_payment,$dp,'.','') . '</td></tr>';

	     }



$table = $table . '<tr>';
$table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPC_SSC_ITEM_TOTAL') . ':&nbsp;</td>';
$table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($line_order_total,$dp,'.','') . '</td></tr>';     
	     
	    
$line_order_total = round($line_order_total,$dp);

$shipping = 0;

//--	if(isset($cart->pricesUnformatted["shipmentValue"]) && $cart->pricesUnformatted["shipmentValue"] > 0)
//--		{  
//--    $shipping = $cart->pricesUnformatted["shipmentValue"];
	    
	if(isset($order['details']['BT']->order_shipment) && $order['details']['BT']->order_shipment > 0)
		{  
	   $shipping = $order['details']['BT']->order_shipment;
	    
	    $shipping = $paymentCurrency->convertCurrencyTo($prices_currency, $shipping, false);    
	    
	    $shipping = number_format($shipping,$dp,'.','');
	     	     
		$table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPC_SSC_SHIPPING') .':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($shipping,$dp,'.','') . '</td></tr>';
	    }


//number_format($amount,$dp,'.','');
$total_tax = 0;
/*
	  if(isset($order['details']['BT']->order_tax) && $order['details']['BT']->order_tax > 0)
	     {  
	     $total_tax = $order['details']['BT']->order_tax;
	     
	     $total_tax = $paymentCurrency->convertCurrencyTo($prices_currency, $total_tax, false);
         }	     

	  if(isset($order['details']['BT']->order_shipment_tax) && $order['details']['BT']->order_shipment_tax > 0)
	     {
         $order_shippment_tax = $order['details']['BT']->order_shipment_tax;
         
         $order_shippment_tax = $paymentCurrency->convertCurrencyTo($prices_currency, $order_shippment_tax, false);
         
	     $total_tax += $order_shippment_tax;
	     }

	  if(isset($order['details']['BT']->order_payment_tax) && $order['details']['BT']->order_payment_tax > 0)
	     {
         $order_payment_tax = $order['details']['BT']->order_payment_tax;
         
         $order_payment_tax = $paymentCurrency->convertCurrencyTo($prices_currency, $order_payment_tax, false);
         
	     $total_tax += $order_payment_tax;
	     }
*/

//paymentTax

	if(isset($order['details']['BT']->order_billTaxAmount) && $order['details']['BT']->order_billTaxAmount > 0)
	//--if(isset($cart->pricesUnformatted["billTaxAmount"]) && $cart->pricesUnformatted["billTaxAmount"] > 0)
	     {
         $order_bill_tax = $order['details']['BT']->order_billTaxAmount;
         //--$order_bill_tax = $cart->pricesUnformatted["billTaxAmount"];
        
         $order_bill_tax = $paymentCurrency->convertCurrencyTo($prices_currency, $order_bill_tax, false);
         
         if($order_bill_tax > $total_tax)
         	{
	     	$total_tax = $order_bill_tax;
	     	//	echo 'Order bill tax set ' . $order_bill_tax;
	     	}
	     }


      if($total_tax > 0 || $shipping > 0)
       {
	    $total_tax = number_format($total_tax,$dp,'.','');
	    
// add surcharge to tax total	    

	    $line_order_total2 = number_format($line_order_total,$dp,'.','');
		$shipping2 = number_format($shipping,$dp,'.','');
		$total_tax2 = number_format($total_tax,$dp,'.','');

		$order_total2 = $line_order_total2 + $shipping2 + $total_tax2;
		$order_total2 = number_format($order_total2,$dp,'.','');

		$cart_order_total2 = $order['details']['BT']->order_total;
		//--$cart_order_total2 = $cart->pricesUnformatted["billTotal"];
		
		
		$cart_order_total2 = $paymentCurrency->convertCurrencyTo($prices_currency,$cart_order_total2,false); //convert1

		$cart_order_total2 = number_format($cart_order_total2,$dp,'.','');

		if($order_total2 < $cart_order_total2)
			{  
			$total_discount2 = $cart_order_total2 - $order_total2;
	     
			//$order_total2 = $cart_order_total2;
			$total_discount2 = number_format($total_discount2,$dp,'.','');
			    
	    	//if($total_tax-$total_discount2>0)
	    	//	{
	    	//	$total_tax += $total_discount2;
	    	//	}
	    	
	    	//if($total_tax > 0)
	    	//	{
	    	//	$total_tax += $total_discount2;
	    	//	}
	    	//elseif($shipping > 0)
	    	//	{
	    	//	$shipping +=  $total_discount2;
	    //	//	$line_order_total -= $total_discount2;
	    	//	}
				
			
			
	    	if($shipping > 0)
	    		{
	    		$shipping +=  $total_discount2;
	    //		$line_order_total -= $total_discount2;
	    		}
			elseif($total_tax > 0)
	    		{
	    		$total_tax += $total_discount2;
	    		}				

	    
	    	}

//end of surchange adjustment



 
		$table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPC_SSC_TAX') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($total_tax,$dp,'.','') . '</td></tr>';


	     }
	     
	     
$total_discount = 0;
//billDiscountAmount

/*
	  if(isset($order['details']['BT']->coupon_discount) && $order['details']['BT']->coupon_discount > 0)
	     {  
	     $total_discount = $order['details']['BT']->coupon_discount;
	     
         $total_discount = $paymentCurrency->convertCurrencyTo($prices_currency, $total_discount, false);
         
         $total_discount = number_format($total_discount,$dp,'.','');
	     
	     $n = $i-1;
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=Coupon+Discount" . 
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=$order->couponCode" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=-" . $total_discount;
    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total - $total_discount;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4"><p align="right">Coupon:&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' . number_format($total_discount,$dp,'.','') . '</td></tr>';

	     }
	     
	     
$total_discount = 0;
//billDiscountAmount
	  if(isset($order['details']['BT']->order_billDiscountAmount) && $order['details']['BT']->order_billDiscountAmount >0)
	     {  
	     $total_discount = $order['details']['BT']->order_billDiscountAmount;
	     
         $total_discount = $paymentCurrency->convertCurrencyTo($prices_currency, $total_discount, false);
         
         $total_discount = number_format($total_discount,$dp,'.','');
	     
	     // $total_discount = round($paymentCurrency->convertCurrencyTo($prices_currency, $total_discount, false),$dp);
	     
	     $n = $i-1;
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=Discount" . 
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=Discount" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=-" . $total_discount;
    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total - $total_discount;
    
	     $i++;
	     
	    $table = $table . '<tr>';
	    $table = $table . '<td colspan="4"><p align="right">Discount:&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' . number_format($total_discount,$dp,'.','') . '</td></tr>';

	     }
*/


$line_order_total = number_format($line_order_total,$dp,'.','');
$shipping = number_format($shipping,$dp,'.','');
$total_tax = number_format($total_tax,$dp,'.','');

$order_total = $line_order_total + $shipping + $total_tax;
$order_total = number_format($order_total,$dp,'.','');


$cart_order_total = $order['details']['BT']->order_total;
//**$cart_order_total = $cart->pricesUnformatted["billTotal"];

$cart_order_total = $paymentCurrency->convertCurrencyTo($prices_currency,$cart_order_total,false); //convert 2

$cart_order_total = number_format($cart_order_total,$dp,'.','');

if($order_total > $cart_order_total)
	     {  
	     $total_discount = $cart_order_total - $order_total;
	     
	     $order_total = $cart_order_total;
	     
         $total_discount = number_format($total_discount,$dp,'.','');
	     
	     $n = $i-1;
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=Discount" . 
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=Discount" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=" . $total_discount;
         
         
         $pppitem = new \PayPal\Api\Item();
			$pppitem->setName('Discount')
				->setCurrency($currency_code_3)
				->setQuantity(1)
				->setSku('Discount') // Similar to `item_number` in Classic API
				->setPrice($total_discount);
				
			$pppitems[$n] = $pppitem;

    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total + $total_discount;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPC_SSC_DISCOUNT') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($total_discount,$dp,'.','') . '</td></tr>';

	     }


if($order_total < $cart_order_total)
	     {  
	     $total_discount = $cart_order_total - $order_total;
	     
	     $order_total = $cart_order_total;
	     
         $total_discount = number_format($total_discount,$dp,'.','');
	     
	     $n = $i-1;
	     
	     $surcharge = urlencode(JText::_('VMPAYMENT_PPC_SSC_SURCHARGE'));
	     $surcharge = 'sur';
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=$surcharge" . 
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=$surcharge" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=" . $total_discount;
         
         $pppitem = new \PayPal\Api\Item();
         
			$pppitem->setName($surcharge)
				->setCurrency($currency_code_3)
				->setQuantity(1)
				->setPrice($total_discount);
				
			//->setSku($surcharge) // Similar to `item_number` in Classic API
				
			$pppitems[$n] = $pppitem;

    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total + $total_discount;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPC_SSC_SURCHARGE') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($total_discount,$dp,'.','') . '</td></tr>';

	     }





	    $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPC_SSC_ORDER_TOTAL') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($order_total,$dp,'.','') . '</td></tr>';

 $table .= '</table>';

  $table .= '<p style="font-size: small">';
	
	$table .= '<table cellspacing="0" cellpadding="2">';
	//$table .= '<tr><td style="border-style:hidden">';
	//$table .= JText::_('VMPAYMENT_PPC_SSC_ORDER_NUMBER') . ':</td>';
	//$table .= '<td style="border-style:hidden">&nbsp;&nbsp;';
	//$table .= $order["details"]["BT"]->order_number;
	//$table .= '</td></tr>';
	
	$table .= '<tr><td style="border-style:hidden; text-align: right;">';
	$table .= JText::_('VMPAYMENT_PPC_SSC_CURRENCY') . ':</td><td style="border-style:hidden">&nbsp;&nbsp;';
	$table .= $currency_code_3;
	$table .= '</td></tr>';
	
	$table .= '</table>';
	
	$table .= '</style>';

//$method->debug = 0;
if($method->debug)
	{
	echo '<span style="color: ' . '#' . 'FF0000">';
	echo "<br/>You have enabled debugging in setup. Turn it off to remove the debug information below<br/>3<br/>";
	echo '</span>';

//print_r($order);
//print_r($cart);

echo '<br><br>';
echo $_SERVER["SERVER_PORT"] .'<br>';
echo $_SERVER["SERVER_NAME"] .'<br>';
echo $_SERVER["REQUEST_URI"] .'<br>';

if(isset($_SERVER["HTTPS"]))
	{
	echo $_SERVER["HTTPS"]  . '<br>';
	}
else
	{
	echo'No<br>';
	}

echo 'JURI root: ' . JURI::root()  . '<br>';
//echo 'JURI root: ' . JURI::root(false,'')  . '<br>';
}
//echo "<br>Order Total: $order_total<br>
//Line Order Total: $line_order_total<br>
//Total Discount: $total_discount<br>
//Total Tax: $total_tax<br>
//Shipping: $shipping<br>";

return array($table,$order_total,$line_order_total,$total_discount,$total_tax,$shipping,$line_order_details,$pppitems);

}


################ begin success ##################



function process_success($paymentId,$PayerID,$pectransid)
	{

	if (!class_exists('VirtueMartModelOrders'))
	    require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );


$order_data = $this->post_strings();
$order_get = $this->get_strings();	
		

//print_r($order_data);


	//$post_msg ='';
		
	//foreach ($order_data as $key => $value)
	//   {
	//   $post_msg .= $key . "=" . $value . "<br />";
	//   }
	
	//echo $post_msg;
	
	
	//	$httpResponse['TOKEN'],$httpResponse['PAYERID'],$order_data["pectransid"]
//$TOKEN,$PAYERID,$pectransid
//function doexpress($TOKEN,$PAYERID,$pectransid)	
	
		$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($pectransid);
//**	$this->logInfo('plgVmOnPaymentNotification: virtuemart_order_id  found ' . $virtuemart_order_id, 'message');

	if (!$virtuemart_order_id)
	  {
	  return;
	  }


	$vendorId = 0;
	$payment = $this->getDataByOrderId($virtuemart_order_id);

	$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
	if (!$this->selectedThisElement($method->payment_element)) {
	
	print 'no order id for ppp';
	    return false;
	}
	

	

if (!class_exists('VirtueMartModelOrders'))
		require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );
	    $modelOrder = new VirtueMartModelOrders();
	    
	    $order = $modelOrder->getOrder($virtuemart_order_id);


//echo '#############################################';

//print_r($method);
//print print_r($order);

//print print_r($payment);
	

$order_form_line_item='';
$br = "\n";	

$line_order_details = '';
$line_order_total = 0;

$order_total=0;
$total_discount=0;
$total_tax=0;
$total_shipping=0;

$table='';

$customer_currency = 0;

//if($method->ssc_multi_currency)
//	{
	$customer_currency = trim($payment->alt_currency);
//	}
//else
//	{
//	$customer_currency = $method->payment_currency;
//	}


list($table,$order_total,$line_order_total,$total_discount,$total_tax,$shipping,$line_order_details,$pppitems) = $this->order_form($order,$method,$customer_currency);



$address = $order['details']['BT'];

$del_address = null;
	
if(isset($order['details']['ST']))
   {
   $del_address = $order['details']['ST'];
   }
else
   {
   $del_address = $order['details']['BT'];
   }


$country = ShopFunctions::getCountryByID($address->virtuemart_country_id, "country_2_code");
$cc_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($address->virtuemart_state_id) : "";


$del_country = ShopFunctions::getCountryByID($del_address->virtuemart_country_id, "country_2_code");
$del_state = isset($address->virtuemart_state_id) ? ShopFunctions::getStateByID($del_address->virtuemart_state_id) : "";

list($order_form,$order_form_html_billing,$order_form_html_shipping) = $this->billing_shipping_address($address,$del_address,$country,$del_country,$cc_state,$del_state);

$shop_code = $payment->currency_code;

//$method->ssc_multi_currency=0;

if($method->ssc_multi_currency)
	{
	$customer_currency = trim($payment->alt_currency);
	$this->getPaymentCurrency($method);
	$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $customer_currency  . '" ';
	$db = JFactory::getDBO();
	$db->setQuery($q);
	$shop_code = $db->loadResult();
	}



####### Begin Update ##############
$httpResponse = null;
   
//ssc_show_thank_you
//ssc_show_receipt_address
//ssc_api_receipt_header
//ssc_api_receipt_header

///////////// Update Order Log/////////////////



$transactions = $payment->getTransactions();

$transaction = $transactions[0];

$payer = $payment->getPayer();

//print_r($payer);

$httpResponse =  new StdClass;



/*

[payment_instruction] => Array
	(
	[reference_number] => 7FC35911MD7697828
	[instruction_type] => PAY_UPON_INVOICE
	[recipient_banking_instruction] => Array
		(	
		[bank_name] => Deutsche Bank
		[account_holder_name] => PayPal Europe
		[international_bank_account_number] => DE07120700888000XXXXXX
		[bank_identifier_code] => DEUTDEDBPAL
		)
[amount] => Array
	(
	[value] => 4.99
	[currency] => EUR
	)

[payment_due_date] => 2015-09-24
[links] => Array
	(
	[0] => Array
		(
		[href] =>
		https://api.paypal.com/v1/payments/payment/PAY-
		1VG08356YH269600PKXOBRAY/payment-instruction
		[rel] => self
		[method] => GET
 * 
 * 


*/


$comment = '';

if(isset($payment->payment_instruction->recipient_banking_instruction->bank_name))
{
$httpResponse->bank_name  = $payment->payment_instruction->recipient_banking_instruction->bank_name;
$httpResponse->account_holder_name = $payment->payment_instruction->recipient_banking_instruction->account_holder_name;
$httpResponse->international_bank_account_number = $payment->payment_instruction->recipient_banking_instruction->international_bank_account_number;
$httpResponse->bank_identifier_code = $payment->payment_instruction->recipient_banking_instruction->bank_identifier_code;

$httpResponse->value = $payment->payment_instruction->amount->value;
$httpResponse->currency = $payment->payment_instruction->amount->currency;
$httpResponse->payment_due_date = $payment->payment_instruction->payment_due_date;
$httpResponse->href = $payment->payment_instruction->links[0]->href;


$httpResponse->reference_number = $payment->payment_instruction->reference_number;

$httpResponse->instruction_type = $payment->payment_instruction->instruction_type;

$comment = 'Kauf auf Rechnung<br />' .	
$httpResponse->bank_name . '<br />' .		  
$httpResponse->account_holder_name . '<br />' .
$httpResponse->international_bank_account_number . '<br />' .
$httpResponse->bank_identifier_code . '<br />' .
		  
$httpResponse->value  . '<br />' .
$httpResponse->currency  . '<br />' .
'Faelligkeit: ' . $httpResponse->payment_due_date . '<br />' .
'Referenznummer:' . $httpResponse->reference_number;

}

//Amount
$httpResponse->total = $transaction->amount->total;
$httpResponse->currency = $transaction->amount->currency;

$httpResponse->subtotal = $transaction->amount->details->subtotal;
$httpResponse->tax = $transaction->amount->details->tax;
$httpResponse->shipping = $transaction->amount->details->shipping;


$httpResponse->merchant_id = $transaction->payee->merchant_id;

$httpResponse->description = $transaction->description;
$httpResponse->invoice_number = $transaction->invoice_number;

$httpResponse->shipping_recipient_name   = $transaction->item_list->shipping_address->recipient_name;
$httpResponse->shipping_line1   = $transaction->item_list->shipping_address->line1;
$httpResponse->shipping_city   = $transaction->item_list->shipping_address->city;
$httpResponse->shipping_state   = $transaction->item_list->shipping_address->state;
$httpResponse->shipping_postal_code = $transaction->item_list->shipping_address->postal_code;
$httpResponse->shipping_country_code   = $transaction->item_list->shipping_address->country_code;

$httpResponse->id = $transaction->related_resources[0]->sale->id;
$httpResponse->state = $transaction->related_resources[0]->sale->state;


$httpResponse->payment_mode = $transaction->related_resources[0]->sale->payment_mode;

$httpResponse->protection_eligibility  = $transaction->related_resources[0]->sale->protection_eligibility;
$httpResponse->protection_eligibility_type = $transaction->related_resources[0]->sale->protection_eligibility_type;


$httpResponse->parent_payment = $transaction->related_resources[0]->sale->parent_payment;

//property of non object???
//$httpResponse->transaction_fee_value = $transaction->related_resources[0]->sale->transaction_fee->value;
//$httpResponse->transaction_fee_currency = $transaction->related_resources[0]->sale->transaction_fee->currency;

$httpResponse->create_time = $transaction->related_resources[0]->sale->create_time;
$httpResponse->update_time = $transaction->related_resources[0]->sale->update_time;

$httpResponse->payment_method = $payer->payment_method;
$httpResponse->payer_status = $payer->status;


$httpResponse->email = $payer->payer_info->email;
$httpResponse->first_name = $payer->payer_info->first_name;
$httpResponse->last_name = $payer->payer_info->last_name;
$httpResponse->payer_id = $payer->payer_info->payer_id;
$httpResponse->phone = $payer->payer_info->phone;
$httpResponse->country_code = $payer->payer_info->country_code;



$paypal_fullresponse = json_encode($httpResponse);

$db = JFactory::getDBO();

try
	{
	$q =  "UPDATE `#__virtuemart_payment_plg_paypalcheckoutssc` SET `paypal_fullresponse` = '" . $paypal_fullresponse . "' WHERE `#__virtuemart_payment_plg_paypalcheckoutssc`.`virtuemart_order_id` = '" .  $virtuemart_order_id . "'";
	$db->setQuery($q);
	//$db->query($q);
	$db->execute();

	}
catch (Exception $e)
	{
	echo $e->getMessage();
	}

	
	
//////////// End Update Order Log ////////////////	


if($method->ssc_show_thank_you)
	{
   print "<p style='font-size: x-large'>" . JText::_('VMPAYMENT_PPC_SSC_THANK_YOU_FOR_YOUR_ORDER') . "</p>";
	}
   
echo $method->ssc_receipt_header;
echo '<br/><br/>';
echo $table;
echo '<br/>';

//$order_form_html_billing = $this->shipping_address_html($del_address,$del_country,$del_state);

if($method->ssc_show_receipt_address)
	{
	
$show_shipping=1;

print '<table style="width: 600px" cellspacing="0" cellpadding="2">';
print '<tr><td style="border-style:hidden" valign="top">&nbsp;&nbsp;&nbsp;&nbsp;';


print '<br/><b>&nbsp;&nbsp;&nbsp;&nbsp;' . JText::_('VMPAYMENT_PPC_SSC_BILLING_ADDRESS')  . '</b><br/><br/>';
//print $this->billing_address_html($address,$country,$cc_state);
echo $order_form_html_billing;

print '</td><td style="border-style:hidden" valign="top">&nbsp;&nbsp;&nbsp;&nbsp;';

if($show_shipping == 1)
	{
	print '<br/><b>&nbsp;' . JText::_('VMPAYMENT_PPC_SSC_SHIPPING_ADDRESS') . '</b><br/><br/>';
	//	print $this->shipping_address_html($del_address,$del_country,$del_state);
	echo $order_form_html_shipping;
	}

print '</td></tr></table>';
	
	}

$table = '<p style="font-size: small">';
	
$table .= '<table cellspacing="0" cellpadding="2">';
$table .= '<tr><td style="border-style:hidden">';
$table .= JText::_('VMPAYMENT_PPC_SSC_ORDER_NUMBER') . ':</td>';
$table .= '<td style="border-style:hidden">&nbsp;&nbsp;';
$table .= $order["details"]["BT"]->order_number;
$table .= '</td></tr>';
	
//$table .= '<tr><td style="border-style:hidden; text-align: right;">';
//$table .= JText::_('VMPAYMENT_PPC_SSC_CURRENCY') . ':</td><td style="border-style:hidden">&nbsp;&nbsp;';
//$table .= $currency_code_3;
//$table .= '</td></tr>';
	
$table .= '</table>';
	
$table .= '</style>';

echo $table;

echo $method->ssc_receipt_footer;

echo $method->ssc_raw;



//process_order

$new_status = "C";
	
	if (!class_exists("VirtueMartModelOrders"))
				require( JPATH_VM_ADMINISTRATOR . '/' . "models" . '/' . "orders.php" );

	$modelOrder = VmModel::getModel("orders");
	
	$orderitems = $modelOrder->getOrder($virtuemart_order_id);
	$nb_history = count($orderitems['history']);
	
	$orders["order_status"] = "C";
	$orders["virtuemart_order_id"] = $virtuemart_order_id;
	$orders["customer_notified"] = 1;
	$orders["comments"] = $comment;


/*
 $orderitems = $modelOrder->getOrder($virtuemart_order_id);
	    
	    $nb_history = count($orderitems['history']);
	    
	    if($nb_history == 1)
	       {
		   $order['comments'] .= "<br />" . JText::sprintf('VMPAYMENT_PAYPAL_EMAIL_SENT');
		   $order['customer_notified'] = 0;
	       }
	    else
	       {
		   $order['customer_notified'] = 1;
	       }
	*/       


	if ($orderitems['history'][$nb_history - 1]->order_status_code != $orders['order_status'])
		{
		$orders['comments'] .= "<br />" . JText::sprintf('VMPAYMENT_PPC_SSC_CONFIRMED_EMAIL_SENT');
		$orders['customer_notified'] = 1;	
		}
	else
		{
		$orders['customer_notified'] = 0;		
		}


	$orderitems = $modelOrder->getOrder($virtuemart_order_id);
	
	$already_confirmed = 0;
	
	foreach($orderitems['history'] as $status)
		{
		//echo $status->order_status_code;
		if($status->order_status_code == 'C')
			{
			$already_confirmed = 1;
			}
		}
	
	
	if($already_confirmed == 0)
		{
		//echo '--------- Confirm Order ----------------' . $orderitems['details']['BT']->order_status;
		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $orders, true);	
		}
	

echo $this->hidessc();


$this->emptyCart(null);


 
return;
   
#####  end update ##########
}

################ end success ###################




function order_form_cart($order,$method,$customer_currency)
{

if (!class_exists('CurrencyDisplay'))
    require(JPATH_VM_ADMINISTRATOR . '/' . 'helpers' . '/' . 'currencydisplay.php');

$paymentCurrency = CurrencyDisplay::getInstance();

if (!class_exists ('VirtueMartCart'))
	{
	require(JPATH_VM_SITE . '/' . 'helpers' . '/' . 'cart.php');
	}



############# Begin Express Code #####################

/*
// no payment method id is set. Order is null. First run

if(!isset($order['details']['BT']->virtuemart_paymentmethod_id))
	{
	//echo '--------- order is null ---';
	$cart = VirtueMartCart::getCart ();
	$cart->prepareCartData(); //xxx
	$cart->getCartPrices();
	$db = JFactory::getDbo();
	$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "paypalcheckoutssc" AND `published` = 1';
	$db->setQuery($q);
	$virtuemart_paymentmethod_id = $db->loadResult();
	$cart->virtuemart_paymentmethod_id = $virtuemart_paymentmethod_id;
	$cart->setCartIntoSession();
	}
else
   {
   //echo '--------- order is not null ---';
	$cart = VirtueMartCart::getCart ();
	$cart->prepareCartData(); //xxx
	$cart->getCartPrices();
	
	//$db = JFactory::getDbo();
	//$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "paypalcheckoutssc" AND `published` = 1';
	//$db->setQuery($q);
	//$virtuemart_paymentmethod_id = $db->loadResult();
	
	//$cart->virtuemart_paymentmethod_id = $order['details']['BT']->virtuemart_paymentmethod_id;
	//$cart->setCartIntoSession();
   
   }
   
*/   
############ End Express Code ############################# 


############# PayPal Plus Code #################

# virtuemart_paymentmethod_id not required

$cart = VirtueMartCart::getCart ();
$cart->prepareCartData(); //xxx
$cart->getCartPrices();

############ End PayPal Plus Code #############




  

#print "--------------------------------------------------<br>\n\n";
#print_r($cart);
#print "--------------------------------------------------<br>\n\n";
//print_r($order);
#print "--------------------------------------------------<br>\n\n";

//$method->ssc_multi_currency=0;

if($method->debug)
	{
	echo '$method->ssc_multi_currency ' . $method->ssc_multi_currency . '<br>';
	echo '$customer_currency ' . $customer_currency . '<br>';
	echo '$method->payment_currency ' . $method->payment_currency . '<br>';
	}

$this->getPaymentCurrency($method);  // code 0 is default ??

if($method->ssc_multi_currency)
	{
	$prices_currency = $customer_currency;
	}
else
	{
	$prices_currency = $method->payment_currency;
	}




if($method->debug)
	{
	echo '$method->payment_currency ' . $method->payment_currency . '<br>';
	echo '$prices_currency ' . $prices_currency . '<br>';	
	}
	
$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $prices_currency . '" ';
$db = JFactory::getDBO();
$db->setQuery($q);
$currency_code_3 = $db->loadResult();


$dp=2;

if($currency_code_3 == 'JPY')
	{
	$dp=0;
	}

//echo '22222222222222';
//echo $currency_code_3;
//echo '+++++++++++++';


$q = 'SELECT `currency_symbol` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $prices_currency . '" ';

$db->setQuery($q);
$currency_symbol = $db->loadResult();

$order_form_line_item='';
$br = "\n";	

$line_order_details = '';

$trusted_line_items=''; 
$line_order_total = 0;
$trusted_line_items='';    ## Tracking
$inc_tax = 0;




$unit_price = JText::_('VMPAYMENT_PPC_SSC_UNIT_PRICE');

$unit_price = str_replace(' ','&nbsp;',$unit_price);

$table = '<table border="1" width="600" cellspacing="0" cellpadding="2" class="ssc">
<tr>
	<td style="background-color: rgb(220,220,220)" width="50"><strong><font face="Arial"
	size="2">' . JText::_('VMPAYMENT_PPC_SSC_ID') . '&nbsp;&nbsp;</font></strong></td>
	<td style="background-color: rgb(220,220,220)" width="400"><strong><font face="Arial"
	size="2">' . JText::_('VMPAYMENT_PPC_SSC_ITEM') .  '</font></strong></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><font face="Arial"
	size="2"><strong>' . $unit_price .'&nbsp;</strong></font></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><strong><font face="Arial"
	size="2">&nbsp;' . JText::_('VMPAYMENT_PPC_SSC_QUANTITY') . '&nbsp;</font></strong></td>
	<td style="background-color: rgb(220,220,220); text-align: right;" width="50"><strong><font face="Arial"
	size="2">&nbsp;' . JText::_('VMPAYMENT_PPC_SSC_TOTALS') . '</font></strong></td>
</tr>';

 //   <td style="background-color: rgb(220,220,220); text-align: right;" width="50"><strong><font face="Arial"
 //   size="2">&nbsp;Line&nbsp;Total</font></strong></td>
 // </tr>';
$pppitems = array();
$i = 1;

//--foreach ($order["items"] as $key => $product)
foreach ($cart->products as $key => $product)
	{
	//--$line_item_name = substr(strip_tags($product->order_item_name), 0, 127);
	$line_item_name = substr(strip_tags($product->product_name), 0, 127);
	     
	     
	//--$line_id = substr(strip_tags($product->order_item_sku), 0, 127);
	$line_id = substr(strip_tags($product->product_sku), 0, 127);
	     
	//$cost = number_format($product->product_item_price,$dp,'.','');
	//--$cost = $product->product_item_price;
	$cost = $cart->pricesUnformatted[$key]["basePrice"];
	
	$cost = $paymentCurrency->convertCurrencyTo($prices_currency, $cost, false);
	$cost = number_format($cost,$dp,'.','');
	     
	// $line = $product->product_subtotal_with_tax;
	     
	// $line = $paymentCurrency->convertCurrencyTo($prices_currency, $line, false);
	     
	// $line = number_format($line,$dp,'.','');
	     

     
	$qty = $product->quantity;
	
	//--$qty = $product->product_quantity;
	     
	//--$line_fields = $product->product_attribute;
	$line_fields = '';//$product->customfields; xx


	
	if (!empty($product->product_attribute))
		{
		if(!class_exists('VirtueMartModelCustomfields'))require(JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'customfields.php');
		$line_fields = VirtueMartModelCustomfields::CustomsFieldOrderDisplay($product,'FE');
		}
	
	$strip_line_fields = strip_tags($line_fields);


	if($line_fields === '')
		{
	    $line_description = substr($line_id, 0, 127);
		}
	else
		{
		$line_description = substr($line_id . ' ' . $strip_line_fields, 0, 127);
		}
	     
	$n = $i-1;
	    
	$line_order_details .= 
	"&L_PAYMENTREQUEST_0_NAME" . "$n=" . urlencode($line_item_name) .
	"&L_PAYMENTREQUEST_0_NUMBER" . "$n=" . urlencode($line_description) .
	"&L_PAYMENTREQUEST_0_QTY" . "$n=" . $qty .  
	"&L_PAYMENTREQUEST_0_AMT" . "$n=" . $cost;
	
	
         
   $pppitem = new \PayPal\Api\Item();
   
   
   
   
	//$pppitem->setName($line_item_name)
   // ->setCurrency($currency_code_3)
   // ->setQuantity($qty)
   // ->setSku($line_description) // Similar to `item_number` in Classic API
   // ->setPrice($cost);
   
	if(trim($line_description) == '')
		{
	
	$pppitem->setName($line_item_name)
    ->setCurrency($currency_code_3)
    ->setQuantity($qty)
    ->setPrice($cost);
   
		}
	else
		{
    
    $pppitem->setName($line_item_name)
    ->setCurrency($currency_code_3)
    ->setQuantity($qty)
    ->setSku($line_description) // Similar to `item_number` in Classic API
    ->setPrice($cost);
    
		}

    
    
    
    
    
    
    
    
	$pppitems[$n] = $pppitem;
	
	
	if($i>1){$trusted_line_items = $trusted_line_items .  ',';}
	
	$trusted_line_items .=
	'{' .
	'"name": ' . json_encode($line_item_name) . ',' .
	# urlencode($line_description) .
		'"unit_amount":  {
					"value": ' . json_encode($cost) . ',
               "currency_code": ' . json_encode($currency_code_3) . '
               
            },' .
		'"quantity": ' . json_encode($qty) .
	'}'; 
	
	

	
    
	$line_order_total += $qty * $cost;
     
     
	$table = $table . '<tr>';    
   
	$table = $table . '<td valign="top">' . $line_id . "</td>"; 
     
	$table = $table . '<td valign="top">' . $line_item_name  . '&nbsp;' . $line_fields;   
     
	$table = $table . '</td>'; 
      
	$table = $table . '<td valign="top" align="right">' .  $currency_symbol . $cost . "</td>"; 
      
	$table = $table . '<td valign="top" align="right">' . $qty . "</td>"; 
      
	$table = $table . '<td valign="top" align="right">&nbsp;&nbsp;' .  $currency_symbol . number_format($qty * $cost,$dp,'.','') . '</td>'; 
  
   
// $table = $table . '<td valign="top" align="right">&nbsp;&nbsp;' . number_format($line,$dp,'.','') . '</td>'; 
  
	$table = $table . '</tr>';
    
	$i++;
	     
	} 	  
	// print '-----------';
	// print $line_order_details;
	// print '-----------';     	     

//echo $cart->pricesUnformatted["paymentValue"];

//order_payment ???
	  //--if(isset($order['details']['BT']->order_payment) && $order['details']['BT']->order_payment > 0)
	  if(isset($cart->pricesUnformatted["paymentValue"]) && $cart->pricesUnformatted["paymentValue"] > 0)
	     {  
	     $order_payment = $cart->pricesUnformatted["paymentValue"];
	     //--$order_payment = $order['details']['BT']->order_payment;
	     
         $order_payment = $paymentCurrency->convertCurrencyTo($prices_currency, $order_payment, false);
         
         $order_payment = number_format($order_payment,$dp,'.','');
	     
	     $n = $i-1;
	     
	     $payment_fee = JText::_('VMPAYMENT_PPC_SSC_PAYMENT_FEE');
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=" . urlencode($payment_fee) .
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=" . $order_payment;
         
         

			$pppitem = new \PayPal\Api\Item();
			$pppitem->setName($payment_fee)
				->setCurrency($currency_code_3)
				->setQuantity(1)
				->setPrice($order_payment);
				
			//->setSku('') // Similar to `item_number` in Classic API				
				
			$pppitems[$n] = $pppitem;

			
	$trusted_line_items .=
	',{' .
	'"name": ' . json_encode($payment_fee) . ',' .
	'"unit_amount":  {
						"value": ' . json_encode($order_payment) . ',
						"currency_code": ' . json_encode($currency_code_3) . '
							},' .
	'"quantity": "1"' .
	'}';
		     
    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total + $order_payment;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . $payment_fee . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' . $currency_symbol . number_format($order_payment,$dp,'.','') . '</td></tr>';

	     }



$table = $table . '<tr>';
$table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPC_SSC_ITEM_TOTAL') . ':&nbsp;</td>';
$table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($line_order_total,$dp,'.','') . '</td></tr>';     
	     
	    
$line_order_total = round($line_order_total,$dp);

$line_items_total =  $line_order_total;

$shipping = 0;

	if(isset($cart->pricesUnformatted["shipmentValue"]) && $cart->pricesUnformatted["shipmentValue"] > 0)
		{  
    $shipping = $cart->pricesUnformatted["shipmentValue"];
	    
//--	if(isset($order['details']['BT']->order_shipment) && $order['details']['BT']->order_shipment > 0)
//--		{  
//--	   $shipping = $order['details']['BT']->order_shipment;
	    
	    $shipping = $paymentCurrency->convertCurrencyTo($prices_currency, $shipping, false);    
	    
	    $shipping = number_format($shipping,$dp,'.','');
	     	     
		$table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPC_SSC_SHIPPING') .':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($shipping,$dp,'.','') . '</td></tr>';
	    }


//number_format($amount,$dp,'.','');
$total_tax = 0;
/*
	  if(isset($order['details']['BT']->order_tax) && $order['details']['BT']->order_tax > 0)
	     {  
	     $total_tax = $order['details']['BT']->order_tax;
	     
	     $total_tax = $paymentCurrency->convertCurrencyTo($prices_currency, $total_tax, false);
         }	     

	  if(isset($order['details']['BT']->order_shipment_tax) && $order['details']['BT']->order_shipment_tax > 0)
	     {
         $order_shippment_tax = $order['details']['BT']->order_shipment_tax;
         
         $order_shippment_tax = $paymentCurrency->convertCurrencyTo($prices_currency, $order_shippment_tax, false);
         
	     $total_tax += $order_shippment_tax;
	     }

	  if(isset($order['details']['BT']->order_payment_tax) && $order['details']['BT']->order_payment_tax > 0)
	     {
         $order_payment_tax = $order['details']['BT']->order_payment_tax;
         
         $order_payment_tax = $paymentCurrency->convertCurrencyTo($prices_currency, $order_payment_tax, false);
         
	     $total_tax += $order_payment_tax;
	     }
*/

//paymentTax

	//--if(isset($order['details']['BT']->order_billTaxAmount) && $order['details']['BT']->order_billTaxAmount > 0)
	if(isset($cart->pricesUnformatted["billTaxAmount"]) && $cart->pricesUnformatted["billTaxAmount"] > 0)
	     {
         //--$order_bill_tax = $order['details']['BT']->order_billTaxAmount;
         $order_bill_tax = $cart->pricesUnformatted["billTaxAmount"];
        
         $order_bill_tax = $paymentCurrency->convertCurrencyTo($prices_currency, $order_bill_tax, false);
         
         if($order_bill_tax > $total_tax)
         	{
	     	$total_tax = $order_bill_tax;
	     	//	echo 'Order bill tax set ' . $order_bill_tax;
	     	}
	     }


      if($total_tax > 0 || $shipping > 0)
       {
	    $total_tax = number_format($total_tax,$dp,'.','');
	    
// add surcharge to tax total	    

	    $line_order_total2 = number_format($line_order_total,$dp,'.','');
		$shipping2 = number_format($shipping,$dp,'.','');
		$total_tax2 = number_format($total_tax,$dp,'.','');

		$order_total2 = $line_order_total2 + $shipping2 + $total_tax2;
		$order_total2 = number_format($order_total2,$dp,'.','');

		//--$cart_order_total2 = $order['details']['BT']->order_total;
		$cart_order_total2 = $cart->pricesUnformatted["billTotal"];
		
		
		$cart_order_total2 = $paymentCurrency->convertCurrencyTo($prices_currency,$cart_order_total2,false); //convert1

		$cart_order_total2 = number_format($cart_order_total2,$dp,'.','');

		if($order_total2 < $cart_order_total2)
			{  
			$total_discount2 = $cart_order_total2 - $order_total2;
	     
			//$order_total2 = $cart_order_total2;
			$total_discount2 = number_format($total_discount2,$dp,'.','');
			    
	    	//if($total_tax-$total_discount2>0)
	    	//	{
	    	//	$total_tax += $total_discount2;
	    	//	}
	    	
	    	//if(total_tax > 0)
	    	//	{
	    	//	$total_tax += $total_discount2;
	    	//	}
	    	//elseif($shipping > 0)
	    	//	{
	    	//	$shipping +=  $total_discount2;
	    //	//	$line_order_total -= $total_discount2;
	    	//	}
			
			
			if($shipping > 0)
	    		{
	    		$shipping +=  $total_discount2;
	    //		$line_order_total -= $total_discount2;
	    		}
			elseif($total_tax > 0)
	    		{
	    		$total_tax += $total_discount2;
	    		}

	    
	    	}

//end of surchange adjustment



 
		$table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPC_SSC_TAX') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($total_tax,$dp,'.','') . '</td></tr>';


	     }
	     
	     
$total_discount = 0;
//billDiscountAmount

/*
	  if(isset($order['details']['BT']->coupon_discount) && $order['details']['BT']->coupon_discount > 0)
	     {  
	     $total_discount = $order['details']['BT']->coupon_discount;
	     
         $total_discount = $paymentCurrency->convertCurrencyTo($prices_currency, $total_discount, false);
         
         $total_discount = number_format($total_discount,$dp,'.','');
	     
	     $n = $i-1;
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=Coupon+Discount" . 
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=$order->couponCode" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=-" . $total_discount;
    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total - $total_discount;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4"><p align="right">Coupon:&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' . number_format($total_discount,$dp,'.','') . '</td></tr>';

	     }
	     
	     
$total_discount = 0;
//billDiscountAmount
	  if(isset($order['details']['BT']->order_billDiscountAmount) && $order['details']['BT']->order_billDiscountAmount >0)
	     {  
	     $total_discount = $order['details']['BT']->order_billDiscountAmount;
	     
         $total_discount = $paymentCurrency->convertCurrencyTo($prices_currency, $total_discount, false);
         
         $total_discount = number_format($total_discount,$dp,'.','');
	     
	     // $total_discount = round($paymentCurrency->convertCurrencyTo($prices_currency, $total_discount, false),$dp);
	     
	     $n = $i-1;
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=Discount" . 
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=Discount" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=-" . $total_discount;
    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total - $total_discount;
    
	     $i++;
	     
	    $table = $table . '<tr>';
	    $table = $table . '<td colspan="4"><p align="right">Discount:&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' . number_format($total_discount,$dp,'.','') . '</td></tr>';

	     }
*/


$line_order_total = number_format($line_order_total,$dp,'.','');
$shipping = number_format($shipping,$dp,'.','');
$total_tax = number_format($total_tax,$dp,'.','');

$order_total = $line_order_total + $shipping + $total_tax;
$order_total = number_format($order_total,$dp,'.','');


//--$cart_order_total = $order['details']['BT']->order_total;
$cart_order_total = $cart->pricesUnformatted["billTotal"];

$cart_order_total = $paymentCurrency->convertCurrencyTo($prices_currency,$cart_order_total,false); //convert 2

$cart_order_total = number_format($cart_order_total,$dp,'.','');

if($order_total > $cart_order_total)
	     {  
	     $total_discount = $cart_order_total - $order_total;
	     
	     $order_total = $cart_order_total;
	     
         $total_discount = number_format($total_discount,$dp,'.','');
	     
	     $n = $i-1;
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=Discount" . 
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=Discount" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=" . $total_discount;
    
         
         $pppitem = new \PayPal\Api\Item();
			$pppitem->setName('Discount')
				->setCurrency($currency_code_3)
				->setQuantity(1)
				->setSku('Discount') // Similar to `item_number` in Classic API
				->setPrice($total_discount);
				
			$pppitems[$n] = $pppitem;
         
    
         #    urlencode($line_item_name) .
    
         $line_order_total = $line_order_total + $total_discount;
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPC_SSC_DISCOUNT') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($total_discount,$dp,'.','') . '</td></tr>';

	     }


if($order_total < $cart_order_total)
	     {  
	     $total_discount = $cart_order_total - $order_total;
	     $adjustment = $total_discount;
	     $order_total = $cart_order_total;
	     
         $total_discount = number_format($total_discount,$dp,'.','');
	     
	     $n = $i-1;
	     
	     $surcharge = urlencode(JText::_('VMPAYMENT_PPC_SSC_SURCHARGE'));
	     $surcharge = 'sur';
	     
	     $line_order_details .= 
         "&L_PAYMENTREQUEST_0_NAME" . "$n=$surcharge" . 
         "&L_PAYMENTREQUEST_0_NUMBER" . "$n=$surcharge" .
         "&L_PAYMENTREQUEST_0_QTY" . "$n=1" .  
         "&L_PAYMENTREQUEST_0_AMT" . "$n=" . $total_discount;
    
         #    urlencode($line_item_name) .
         
            
         $pppitem = new \PayPal\Api\Item();
			$pppitem->setName($surcharge)
				->setCurrency($currency_code_3)
				->setQuantity(1)
				->setPrice($total_discount)
				
			->setSku($surcharge); // Similar to `item_number` in Classic API
				
				
			$pppitems[$n] = $pppitem;
			
			
			
			
			
			
						  	$trusted_line_items .=
	',{' .
	'"name": ' . json_encode('Ajustment') . ',' .
	'"unit_amount":  {
							"value": ' . json_encode($adjustment) . ',
							"currency_code": ' . json_encode($currency_code_3) . '					
							},' .
	'"quantity": "1"' .
	'}';
		
			
			
         
         
 //   print_r($pppitems);
         $line_order_total = $line_order_total + $total_discount;
			
			$line_items_total =  number_format($line_order_total,2,'.','');
    
	     $i++;
	     
        $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPC_SSC_SURCHARGE') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($total_discount,$dp,'.','') . '</td></tr>';

	     }





	    $table = $table . '<tr>';
	    $table = $table . '<td colspan="4" align="right">' . JText::_('VMPAYMENT_PPC_SSC_ORDER_TOTAL') . ':&nbsp;</td>';
	    $table = $table . '<td align="right">&nbsp;' .  $currency_symbol . number_format($order_total,$dp,'.','') . '</td></tr>';

 $table .= '</table>';

  $table .= '<p style="font-size: small">';
	
	$table .= '<table cellspacing="0" cellpadding="2">';
	//$table .= '<tr><td style="border-style:hidden">';
	//$table .= JText::_('VMPAYMENT_PPC_SSC_ORDER_NUMBER') . ':</td>';
	//$table .= '<td style="border-style:hidden">&nbsp;&nbsp;';
	//$table .= $order["details"]["BT"]->order_number;
	//$table .= '</td></tr>';
	
	$table .= '<tr><td style="border-style:hidden; text-align: right;">';
	$table .= JText::_('VMPAYMENT_PPC_SSC_CURRENCY') . ':</td><td style="border-style:hidden">&nbsp;&nbsp;';
	$table .= $currency_code_3;
	$table .= '</td></tr>';
	
	$table .= '</table>';
	
	$table .= '</style>';

//$method->debug = 0;
if($method->debug)
	{
	echo '<span style="color: ' . '#' . 'FF0000">';
	echo "<br/>You have enabled debugging in setup. Turn it off to remove the debug information below<br/>4<br/>";
	echo '</span>';

//print_r($order);
//print_r($cart);

echo '<br><br>';
echo $_SERVER["SERVER_PORT"] .'<br>';
echo $_SERVER["SERVER_NAME"] .'<br>';
echo $_SERVER["REQUEST_URI"] .'<br>';

if(isset($_SERVER["HTTPS"]))
	{
	echo $_SERVER["HTTPS"]  . '<br>';
	}
else
	{
	echo'No<br>';
	}

echo 'JURI root: ' . JURI::root()  . '<br>';
//echo 'JURI root: ' . JURI::root(false,'')  . '<br>';
}
//echo "<br>Order Total: $order_total<br>
//Line Order Total: $line_order_total<br>
//Total Discount: $total_discount<br>
//Total Tax: $total_tax<br>
//Shipping: $shipping<br>";

return array($table,$order_total,$line_order_total,$total_discount,$total_tax,$shipping,$line_order_details,$pppitems,$trusted_line_items,$line_items_total);

}



function ssc_check()
	{
	$ssc = 0;

	$ssc = require_once __DIR__  . '/fields/paypal/autoload.php';
	
	
	$db = JFactory::getDbo();
	$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "paypalcheckoutssc" AND `published` = 1';
	$db->setQuery($q);
	$virtuemart_paymentmethod_id = $db->loadResult();

	if(!is_null($virtuemart_paymentmethod_id))
		{
		

	$payment_params = $this->get_payment_params();	
	
	$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $payment_params['currency_id'] . '" ';
	
	$db = JFactory::getDBO();
	$db->setQuery($q);

	$currency_code_3 = $db->loadResult();


	$paypal_url = "api.paypal.com";
	
	if($payment_params['ssc_environment'] === "sandbox")
		{
		$paypal_url = "api.sandbox.paypal.com";
		}


	$clientId = $payment_params['ssc_ssc1'];



	if($payment_params['ssc_environment'] === "sandbox")
		{
		$clientId = $payment_params['ssc_ssc1_sb'];
		}
	

	$document = JFactory::getDocument();

	$enable_funding = '';


	if($payment_params['ssc_enable_funding'] != '')
		{	
		$enable_funding = '&enable-funding=' . $payment_params['ssc_enable_funding'];
		}
	
	
	$buyer_country = '';

	/*
	if($payment_params['ssc_environment'] == "sandbox")
		{
		if(trim($payment_params['ssc_buyer_country']) != '')
			{
			$buyer_country= $payment_params['ssc_buyer_country'];
			$buyer_country = '&buyer-country=' . $buyer_country;
			}
		}
	*/

	$jinput = JFactory::getApplication()->input;
	//$option = $jinput->get('option','');
	//$view = $jinput->get('view','');
	$task = $jinput->get('task','');
	
	$payment_params = $this->get_payment_params();

	$attributes =  array( 'async' => 'async');
	//$attributes = array('defer' => 'defer');

	//if($option == 'com_virtuemart' && ($view == 'cart' || $view == 'pluginresponse'))
	
	if($task === 'updatecart' || $task === 'orderdone')
		{
		$attributes = array();
		}

	$document->addScript('https://www.paypal.com/sdk/js?components=buttons,payment-fields,marks,messages,funding-eligibility&client-id=' . $clientId . '&currency=' . $currency_code_3  . $enable_funding . $buyer_country .'&commit=true',array(),$attributes); 	

	
	}


	
	

if (version_compare(JVERSION, '4.0.0', '>='))
	{
	$db = JFactory::getDbo();
	$db->setQuery("SELECT `params` FROM `#__extensions` WHERE `name` = 'plg_system_httpheaders'");
	$config = $db->loadResult();

	$data = json_decode($config, true);
	
	if(!(isset($data['coop']) && $data['coop'] === "same-origin-allow-popups"))
		{
		$data['coop'] = "same-origin-allow-popups";

		$config = json_encode($data);

		$db = JFactory::getDBO();

		try
			{
			$q =  "UPDATE `#__extensions` SET `params` = '" . $db->escape($config) . "' WHERE `name` = 'plg_system_httpheaders'";
			$db->setQuery($q);
			$db->execute($q);
			}
		catch (Exception $e)
			{
			echo $e->getMessage();
			}


		}
	}
	

	return $ssc;
	}



function https_check($url)
	{
	//echo '<br><br>';
	//echo $_SERVER["SERVER_PORT"] .'<br>';
	//echo $_SERVER["SERVER_NAME"] .'<br>';
	//echo $_SERVER["REQUEST_URI"] .'<br>';

	if(isset($_SERVER["HTTPS"]) && $_SERVER["HTTPS"] === 'on')
		{
		//$url = str_replace("http://", "https://", $url, 1);
		$url = preg_replace("/^http:/", "https:", $url);
		}
		
	return $url;

	}




function _getTablepkeyValue($virtuemart_order_id) {
	$db = JFactory::getDBO();
	$q = 'SELECT ' . $this->_tablepkey . ' FROM `' . $this->_tablename . '` '
		. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
	$db->setQuery($q);

	if (!($pkey = $db->loadResult())) {
	    //J Error::raiseWarning(500, $db->getErrorMsg());
	    JFactory::getApplication()->enqueueMessage($db->getErrorMsg());
	    return '';
	}
	return $pkey;
    }

    /**
     * Display stored payment data for an order
     * @see components/com_virtuemart/helpers/vmPSPlugin::plgVmOnShowOrderBEPayment()
     */
	function plgVmOnShowOrderBEPayment($virtuemart_order_id, $payment_method_id) {

	if (!$this->selectedThisByMethodId($payment_method_id)) {
	    return null; // Another method was selected, do nothing
	}
	
	if (!($method = $this->getVmPluginMethod ($payment_method_id))) { //$this->_currentMethod
			return NULL; // Another method was selected, do nothing   // xxx
		}


	$db = JFactory::getDBO();
	$q = 'SELECT * FROM `' . $this->_tablename . '` '
		. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
	$db->setQuery($q);
	if (!($paymentTable = $db->loadObject())) {
	    // J Error::raiseWarning(500, $db->getErrorMsg());
	    return '';
	}
	$this->getPaymentCurrency($paymentTable);
	$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $paymentTable->payment_currency . '" ';
	$db = JFactory::getDBO();
	$db->setQuery($q);
	$currency_code_3 = $db->loadResult();
	$html = '<table class="adminlist">' . "\n";
	$html .=$this->getHtmlHeaderBE();
	$html .= $this->getHtmlRowBE('Payment Method', $paymentTable->payment_name);
	//$html .= $this->getHtmlRowBE('PAYPAL_PAYMENT_TOTAL_CURRENCY', $paymentTable->payment_order_total.' '.$currency_code_3);
	//$code = "paypal_response_";
	//foreach ($paymentTable as $key => $value) {
	//   if (substr($key, 0, strlen($code)) == $code) {
	//	$html .= $this->getHtmlRowBE($key, $value);
	//    }
	//}
//	$html .= '</table>';
	
	$json = null;
	
	if(isset($paymentTable->paymentId) && trim($paymentTable->paymentId) !== '')
		{	
	
	$paypal_url = "api.paypal.com";
	
	
if($method->ssc_environment == "sandbox")
	{
	$paypal_url = "api.sandbox.paypal.com";
	}
		
		
	$clientId = $method->ssc_ssc1;
	$secret = $method->ssc_ssc2;
	
	if($method->ssc_environment == "sandbox")
		{
		$clientId = $method->ssc_ssc1_sb;
		$secret = $method->ssc_ssc2_sb;
		}
		
	$clientId = trim($clientId);
	$secret = trim($secret);
		
	$access_token =	 $this->create_access_token($clientId,$secret,$paypal_url);		
	
	

	
$headers = array(
'Content-type: application/json',
'Authorization: Bearer ' . $access_token,
'Accept-Language: en_US'
);




$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://" . $paypal_url . "/v2/checkout/orders/" . $paymentTable->paymentId);
//curl_setopt($ch, CURLOPT_HEADER, false);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
//curl_setopt($ch, CURLOPT_SSLVERSION , 6); //NEW ADDITION
//curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); 
//curl_setopt($ch, CURLOPT_USERPWD, $clientId.":".$secret);
//curl_setopt($ch, CURLOPT_POSTFIELDS, $postfields);
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);

if(empty($result))
	{
	$html .= 'Curl error: ' . curl_error($ch);
	}
else
	{
	$json_array = json_decode($result);
		
	$json =  '<pre>' . json_encode($json_array, JSON_PRETTY_PRINT) . '</pre>';
	}
	
		$html .= $this->getHtmlRowBE('Order ID:',$paymentTable->paymentId);
		
		
		if(isset($json_array->status))
			{
			$html .= $this->getHtmlRowBE('Order Status:',$json_array->status);
			}
		
	
		if(isset($json_array->purchase_units[0]->payments->captures[0]->id))
			{
			$html .= $this->getHtmlRowBE('Transaction ID:',$json_array->purchase_units[0]->payments->captures[0]->id);
			}
			
			
		if(isset($json_array->purchase_units[0]->payments->captures[0]->status))
			{
			$html .= $this->getHtmlRowBE('Transaction Status:',$json_array->purchase_units[0]->payments->captures[0]->status);
			}
		
		$html .= '</table><br/>';
		
		$html .= '<b>PayPal Order Details:</b><br>';
		
			$html .= $json;
		
		
	/*
		$html .= "<script type=\"text/javascript\">
			function open_text() {
			document.getElementById('link').innerHTML = \"<b><a href='javascript:close_text()'>Hide PayPal Data</a><br/></b><br/>";
  

        
		$html .="\";
			}
		function close_text()
			{
			document.getElementById('link').innerHTML = \"<b><a href='javascript:open_text()'>Show PayPal Data</a></b>\";
			}
		</script>
		
		<div id='link'><b><a href='javascript:open_text()'>Show PayPal Data</a></b></div>";
	
		
		*/
		}
	else
		{
		$html .= '</table>';
		}
	
	 
	
	
	
	return $html;
    }

 /*
    function getCosts(VirtueMartCart $cart, $method, $cart_prices) {
	if (preg_match('/%$/', $method->cost_percent_total)) {
	    $cost_percent_total = substr($method->cost_percent_total, 0, -1);
	} else {
	    $cost_percent_total = $method->cost_percent_total;
	}
//	return (10.01);
	return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
    }
*/    

    /**
     * Check if the payment conditions are fulfilled for this payment method
     * @author: Valerie Isaksen
     *
     * @param $cart_prices: cart prices
     * @param $payment
     * @return true: if the conditions are fulfilled, false otherwise
     *
     */
   


		protected function checkConditions ($cart, $method, $cart_prices) {

		$this->convert ($method);
		
		$cat_cond = true;
		
		
		if( !empty($method->categories) or !empty($method->blocking_categories) ){
			if(!empty($method->categories)) $cat_cond = false;
			//vmdebug('hmm, my $cat_cond',$method);
			//if at least one product is  in a certain category, display this shipment
			if(!is_array($method->categories)) $method->categories = array($method->categories);
			if(!is_array($method->blocking_categories)) $method->blocking_categories = array($method->blocking_categories);

			$msg = 'None of the products is in a category of the method '. $method->{$this->_psType.'_name'} . '<br>';
			
			//Gather used cats
			foreach($cart->products as $product)
				{
				if(array_intersect($product->categories,$method->categories)){
					//echo "allowed category found<br>";
					$cat_cond = true;
					//break;
				}
				
				if(array_intersect($product->categories,$method->blocking_categories)){
					$cat_cond = false;
					//echo "blocked category found<br>";
					$msg = 'At least one of the products is in a category which blockes the method '.$method->{$this->_psType.'_name'};
					break;
				}
			}
			//if all products in a certain category, display the shipment
			//if a product has a certain category, DO NOT display the shipment
			
			//echo $msg;
			
			if(!$cat_cond) {
				//vmdebug($msg);
				return false;
			}
		}

		// Fix for VM 3.6
		
		//$address = (($cart->ST == 0) ? $cart->BT : $cart->ST);
		
		$address = $cart->getST();
		

		$amount = $cart_prices['salesPrice'];
		$amount_cond = ($amount >= $method->min_amount AND $amount <= $method->max_amount
			OR
			($method->min_amount <= $amount AND ($method->max_amount == 0)));

		$countries = array();
		if (!empty($method->countries)) {
			if (!is_array ($method->countries)) {
				$countries[0] = $method->countries;
			} else {
				$countries = $method->countries;
			}
		}
		// probably did not gave his BT:ST address
		if (!is_array ($address)) {
			$address = array();
			$address['virtuemart_country_id'] = 0;
		}

		if (!isset($address['virtuemart_country_id'])) {
			$address['virtuemart_country_id'] = 0;
		}
		if (in_array ($address['virtuemart_country_id'], $countries) || count ($countries) == 0) {
			if ($amount_cond) {
				return TRUE;
			}
		}

		return FALSE;
	}

	/**
	 * @param $method
	 */
	function convert ($method) {

		$method->min_amount = (float)$method->min_amount;
		$method->max_amount = (float)$method->max_amount;
		
		//$method->min_amount = (float)str_replace(',','.',$method->min_amount);
		//$method->max_amount = (float)str_replace(',','.',$method->max_amount);
	}


	/**
	 * @param $virtuemart_paymentmethod_id
	 * @param $paymentCurrencyId
	 * @return bool|null
	 */
	 
function plgVmgetEmailCurrency ($virtuemart_paymentmethod_id, $virtuemart_order_id, &$emailCurrencyId)
	{
	
	if (!($method = $this->getVmPluginMethod ($virtuemart_paymentmethod_id)))
		{
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement ($method->payment_element)) {
			return FALSE;
		}
		
		/*
		if (!($payments = $this->_getPaypalInternalData ($virtuemart_order_id))) {
			// J Error::raiseWarning(500, $db->getErrorMsg());
			return '';
		}
		*/
		
	/*
	$order_number = $order_data["pectransid"];
	$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_data["pectransid"]);
	$this->logInfo('plgVmOnPaymentNotification: virtuemart_order_id  found ' . $virtuemart_order_id, 'message');
	*/
	
	if(!$virtuemart_order_id)
	  {
	  return;
	  }

	$vendorId = 0;
	$payment = $this->getDataByOrderId($virtuemart_order_id);

	// **********
	//$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
	
	//if (!$this->selectedThisElement($method->payment_element))
	//	{
	//	print 'no order id';
	//   return false;
	//	}

	//if(!class_exists('VirtueMartModelOrders'))
	//	require( JPATH_VM_ADMINISTRATOR . '/' . 'models' . '/' . 'orders.php' );
	//    $modelOrder = new VirtueMartModelOrders();
	    
	//    $order = $modelOrder->getOrder($virtuemart_order_id);		
	// ***********************
			
	//	if (empty($payments[0]->email_currency)) {
	//		$vendorId = 1; //VirtueMartModelVendor::getLoggedVendor();
	//		$db = JFactory::getDBO ();
	//		$q = 'SELECT   `vendor_currency` FROM `#__virtuemart_vendors` WHERE `virtuemart_vendor_id`=' . $vendorId;
	//		$db->setQuery ($q);
	//		$emailCurrencyId = $db->loadResult ();
	//	} else {
	//		$emailCurrencyId = $payments[0]->email_currency;
	//	}
	
$emailCurrencyId = $payment->payment_currency;	


/*
if($method->ssc_multi_currency)
	{
	$emailCurrencyId = trim($payment->paypal_custom);
	}
else
	{
	$this->getPaymentCurrency($method);
	$emailCurrencyId = $method->payment_currency;
	}
*/

//$emailCurrencyId=52;
//$emailCurrencyId=47;
//$emailCurrencyId=144;

}

  function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {

	return $this->onStoreInstallPluginTable($jplugin_id);
    }



function plgVmOnCheckoutAdvertise($cart, &$payment_advertise)
	{

	$ver = VmConfig::getInstalledVersion();

	if (version_compare ($ver, '3.2.0', '>='))
		{
		return null;
		}
	
	
	$template = JFactory::getApplication()->getTemplate();	
		
		if(!$template == 'yootheme')
			{
			return null;	
			}
	
	
	if ($this->getPluginMethods($cart->vendorId) === 0)
		{
		//echo 'Vendor id  is 0';
		return FALSE;
		}
	
	if ($cart->pricesUnformatted['salesPrice'] <= 0.0)
		{
		//echo 'Sales Price is 0';
		return NULL;
		}
		
	if (!($this->_currentMethod = $this->getVmPluginMethod($cart->virtuemart_paymentmethod_id)))
		{
		//echo 'Payment Method id is 0';
		return NULL;
		}


	$html='';	
	$debug=0;

	$db = JFactory::getDbo();
	$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "paypalcheckoutssc" AND `published` = 1';
	$db->setQuery($q);
	$virtuemart_paymentmethod_id = $db->loadResult();
	
	if(empty($virtuemart_paymentmethod_id))
		{
		if($debug == 1)
			{
			$text = 'PayPal Express is not published';
			return $text;
			}
		return null;	
		}
		
	if($cart->virtuemart_paymentmethod_id > 0 && $cart->virtuemart_paymentmethod_id != $virtuemart_paymentmethod_id)// && $this->get_cookie('ssc_checkout') != '1')
		{ 
		if($debug) echo 'another payment processor is selected<br>';
		return null;
		}	
	
	$method = $this->getVmPluginMethod($virtuemart_paymentmethod_id);
	
	//method is user for shortcut. Use database to show exact payment_element ??

/*
//if (version_compare (JVERSION, '3.0.0', 'le'))
//	{
	jimport('joomla.environment.browser');
	$doc =& JFactory::getDocument();
	$browser = &JBrowser::getInstance();
	$browserType = $browser->getBrowser();
	//$browserVersion = $browser->getMajor();
	if($browserType == 'chrome')// && ($browserVersion < 7))
		{
		echo $browserType;
		}
//	}
*/

if($debug)
{

if($cart->_dataValidated)
	{
	echo 'dataValidated = 1<br>';
	}
else
	{
	echo 'dataValidated = 0<br>';
	}

if($cart->_confirmDone)
	{
	echo 'confirmDone = 1<br>';
	}
else
	{
	echo 'confirmDone = 0<br>';
	}

if($cart->_inConfirm)
	{
	echo 'inConfirm = 1<br>';
	}
else
	{
	echo 'inConfirm = 0<br>';
	}

if($cart->_fromCart)
	{
	echo 'fromCart = 1<br>';
	}
else
	{
	echo 'fromCart = 0<br>';
	}

if($cart->getInCheckOut())
	{
	echo 'inCheckout =1 <br>';
	}
else
	{
	echo 'inCheckout = 0<br>';
	}



//print 'ssc_ecob=' . $this->get_cookie('ssc_ecob');

print '<br>';

//if(isset($this->get_cookie('ssc_checkout')))
//print 'ssc_checkout=' . $this->get_cookie('ssc_checkout');

print '<br>';

echo "Current Method: " . $cart->virtuemart_paymentmethod_id . '<br/>';

//echo 'JVM_VERSION=' . JVM_VERSION;

}

$url = $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&ecocheckout=1&adv=yes');
	
$ReturnURL = '<a href="' . $url . '">' .
'<img style="border:0;margin-right:7px;" src="https://fpdbs.paypal.com/dynamicimageweb?cmd=_dynamic-image" alt="PayPal" align="left"></a>';

$payment_advertise[] = '';

$session = JFactory::getSession();

$new_price = 0;


if($debug)
	{
	print '<br>';
	print 'New Price: ' . $new_price . '<br>';
	print 'SSC Total: ' . $session->get('session_ssc_total') . '<br>';
	print 'Bill Total: ' . $cart->pricesUnformatted["billTotal"] . '<br>';
	print 'ssc_checkout=' . $this->get_cookie('ssc_checkout');
	}


//if($session->get('session_ssc_total') != $cart->pricesUnformatted["billTotal"])
//	{
//	$new_price = 1;
//	$session->set('session_ssc_total', $cart->pricesUnformatted["billTotal"]);
//	}


if($session->get('session_ssc_total') != $cart->pricesUnformatted["billTotal"])
	{
	
	if($session->get('session_ssc_total') != null)
		{
		$new_price = 1;
		$application = JFactory::getApplication();

		// Add a message to the message queue
		$new_total = $cart->pricesUnformatted["billTotal"];
	
		$new_total = number_format($new_total,2,'.','');
		
		$this->getPaymentCurrency($method);
		
		$q = 'SELECT `currency_symbol` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
		$db = JFactory::getDBO();
		$db->setQuery($q);
		$currency_symbol = $db->loadResult();
			
		$new_message = JText::_('VMPAYMENT_PPC_SSC_ORDER_TOTAL') . ' : ' . $currency_symbol . $new_total;
		
		if($cart->_dataValidated)
			{
			$application->enqueueMessage(' ');
		
		//	$application->enqueueMessage(JText::_('VMPAYMENT_PPC_SSC_YOUR_ORDER_IS_NOT_YET_COMPLETE'));
		
			$application->enqueueMessage(JText::_('VMPAYMENT_PPC_SSC_REVIEW_YOUR_ORDER_DETAILS'));
		
			$application->enqueueMessage($new_message);
			}
		
 		}

 	$session->set('session_ssc_total', $cart->pricesUnformatted["billTotal"]);
	}


if($debug)
	{
	print '<br>';
	print 'New Price: ' . $new_price . '<br>';
	}

//if($new_price) echo 'New Price: ' . $cart->pricesUnformatted["billTotal"] . '<br/>';

//$ssc_ecob = $this->get_cookie('ssc_ecob');
//$ssc_checkout = $this->get_cookie('ssc_checkout');

if($this->get_cookie('ssc_ecob') == '1')
	{
	//setcookie("ssc_ecob",'');

	$j = "<script language=\"javascript\">
	document.cookie = \"ssc_checkout=0;path=/\";
	document.cookie = \"ssc_ecob=0;path=/\";
	window.location=\"$url\";
	</script>
	<noscript>
	<meta http-equiv=\"refresh\" content=\"0;url=$url\">
	</noscript>
	";

	$doc =& JFactory::getDocument();
	$doc->addCustomTag($j);

	}
elseif($cart->_dataValidated && $this->get_cookie('ssc_checkout') == '1' && $new_price == 0)
	{
	//	setcookie("ssc_ecob",'');
	$url = $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=cart&task=updatecart&confirm=1&tos=1');

	$ver = VmConfig::getInstalledVersion();

	if($ver < '2.9')
		{
		$url = $this->https_check(JURI::root() . 'index.php?option=com_virtuemart&view=cart&task=confirm&tos=1');
		}	
	
$i = "
	<script language=\"javascript\">
		<!--
		document.cookie = \"ssc_checkout=0;path=/\";
		document.cookie = \"ssc_ecob=0;path=/\";
		window.location.href=\"$url\";
		//-->
	</script>
";

//setTimeout(function(){ window.location.href = \"$url\"; }, 5000);

	$j = "
	<meta http-equiv=\"set-cookie\" content=\"ssc_checkout=0;path=/\">
	<meta http-equiv=\"set-cookie\" content=\"ssc_ecob=0;path=/\">
	<meta http-equiv=\"refresh\" content=\"0;url=$url\">
	";


//if (version_compare (JVERSION, '3.0.0', 'le'))
//	{
	
	jimport('joomla.environment.browser');
	$doc =& JFactory::getDocument();
	$browser = &JBrowser::getInstance();
	$browserType = $browser->getBrowser();
	//$browserVersion = $browser->getMajor();
	if($browserType == 'chrome')// && ($browserVersion < 7))
		{
		$i=$j;
		}
//	}

	$doc =& JFactory::getDocument();
	$doc->addCustomTag($i);
	
//	$name="refresh";
//	$content="0;url=$url";
	
//	$doc->setMetaData($name,$content,true);

//$app = JFactory::getApplication();

//$app->redirect($url);
	
	}
	
	
	$checkout_button_1='';
	$checkout_button_2='';
	
$button_text = '';

$cookie_no = '0';

if(!$cart->_dataValidated)
	{
	$cookie_no='1';
	$button_text = 'Click to Continue';
	}
else
	{
	$cookie_no = '0';
	$button_text = 'Enter Payment Details';
	}
	
	
	$checkout_button =
	"<script language=\"javascript\">
	document.cookie = \"ssc_checkout=0;path=/\";

	if(window.addEventListener)
		{
		if(document.getElementById('checkoutFormSubmit') != null)
			{
			//document.getElementById('checkoutFormSubmit').innerHTML = '" . $button_text . "';
			document.getElementById('checkoutFormSubmit').addEventListener('click', function()
				{
				document.cookie = \"ssc_checkout=" . $cookie_no . ";path=/\";
				document.getElementById('checkoutFormSubmit').disabled = false;
				}, false);
			}
		window.addEventListener('load', function()
			{
			if(document.getElementById('checkoutFormSubmit') != null)
				{
				//document.getElementById('checkoutFormSubmit').innerHTML = '" . $button_text . "';
				document.getElementById('checkoutFormSubmit').addEventListener('click', function()
					{
					document.cookie = \"ssc_checkout=" . $cookie_no . ";path=/\";
					document.getElementById('checkoutFormSubmit').disabled = false;
					}, false);
				}	
			else 
				{				
				var position=-1;
				for (var i=0; i<document.anchors.length; i++)
					{
					try{
						if(document.anchors[i].href == \"javascript:document.checkoutForm.submit();\")
							{
							//alert(\"Found\" + i);
							position=i;
							i=document.anchors.length;	
							}
						}	
					catch(err){}//alert(\"error found\");
					}
				if(document.anchors[position] != null)
					{
					//document.anchors[position].innerHTML = '" . $button_text . "';
					document.anchors[position].addEventListener('click', function()
						{
						document.cookie = \"ssc_checkout=" . $cookie_no . ";path=/\";
						}, false);
					}		
				}
				
			}, false);
		}
	else if(window.attachEvent)
		{
		window.attachEvent('onload', function()
			{
			if(document.getElementById('checkoutFormSubmit') != null)
				{
				//document.getElementById('checkoutFormSubmit').innerHTML = '" . $button_text . "';
				document.getElementById('checkoutFormSubmit').attachEvent('onclick', function()
					{
					document.cookie = \"ssc_checkout=" . $cookie_no . ";path=/\";
					document.getElementById('checkoutFormSubmit').disabled = false;
					});
				}
			else
				{
				var position=-1;
				for (var i=0; i<document.anchors.length; i++)
					{
					try{
						if(document.anchors[i].href == \"javascript:document.checkoutForm.submit();\")
							{
							//alert(\"Found\" + i);
							position=i;
							i=document.anchors.length;	
							}
						}
					catch(err){}//alert(\"error found\");
					}
				
				if(document.anchors[position] != null)
					{
					//document.anchors[position].innerHTML = '" . $button_text . "';		
					document.anchors[position].attachEvent('onclick', function()
						{
						document.cookie = \"ssc_checkout=" . $cookie_no . ";path=/\";
						});
					}						
				}
			});
		}

	</script>";


//$session = JFactory::getSession();
//$session->set('session_token', $token);

$session_token = $session->get('session_token');
$session_PayerID = $session->get('session_PayerID');

##rest
$method->ssc_short_cut_cart = 0;

if($method->ssc_short_cut_cart == 1)
	{
	if($cart->virtuemart_paymentmethod_id > 0 && $cart->virtuemart_paymentmethod_id == $virtuemart_paymentmethod_id)
		{
		$html .= $checkout_button;
		}

//	elseif(is_null($session->get('session_token')))
	if(is_null($session->get('session_token')))
		{
		//if(!isset($cart->BT['last_name']))
		//	{
		$html .= $ReturnURL;
		//	}
		}	
	}




$user = JFactory::getUser();

if($user->id > 0)
	{
	$xff = $this->html_code();
	
	echo $xff; 
	}



//echo $html;
	$payment_advertise[] = $html;	
	
}






function plgVmOnProductDisplayPayment($product, &$productDisplay)
	{

	$vendorId = 1;
	if ($this->getPluginMethods($vendorId) === 0)
		{
		return FALSE;
		}

$button_code =
'
<form name="pos_ssc">
<input type="hidden" name="place" value="1">
</form>

<script type="text/javascript">
function func1()
{

var position=0;

for (var i=0; i<document.forms.length; i++)
	{
	try{
		if(document.forms[i].name == "pos_ssc")
			{
			//alert("Found" + i);
			position=i;
			i=document.forms.length;	
			}
		}
	catch(err)
		{
		//alert("error found");
		}
	}


try{
	if(typeof document.forms[position+1].addtocart != "object" && position>0)
		{
		position=position-1;
		//alert("non standard layout");
		}
	else
		{
		//alert("standard layout");
		}	
	}
	catch(err)
		{
		//alert("error found");
		}



	
//alert(vmSiteurl + Virtuemart.addtocart_popup);
if(typeof Virtuemart !== "undefined")
	{
	Virtuemart.addtocart_popup=0;
	}
for (var i=position; i<document.forms.length; i++)
	{
	try{
		if(typeof document.forms[i].addtocart == "object")
			{
			//setCookie("ssc_ecob","1","path=/");
			document.cookie = "ssc_ecob=1;path=/";
			document.forms[i].addtocart.click();
			//alert("error");
			i=document.forms.length;	
			}
		}
	catch(err)
		{
		//alert("error found");
		}
	}
}


function setCookie(cname,cvalue,exdays)
{
var d = new Date();
//d.setTime(d.getTime()+(exdays*24*60*60*1000));
//var expires = "expires="+d.toGMTString();
var expires="";
document.cookie = cname + "=" + cvalue + "; " + expires;
}

function getCookie(cname)
{
var name = cname + "=";
var ca = document.cookie.split(";");
for(var i=0; i<ca.length; i++)
  {
  var c = ca[i].trim();
  if (c.indexOf(name)==0) return c.substring(name.length,c.length);
}
return "";
}
//document.cookie = "ssc_ecob=0;path=/";
</script>' .

'<br/><img style="border:0;margin-right:7px;cursor: pointer" src="https://fpdbs.paypal.com/dynamicimageweb?cmd=_dynamic-image" onclick="func1();" alt="PayPal" align="left"><br/><br/>';


$db = JFactory::getDbo();
$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "paypalcheckoutssc" AND `published` = 1';
$db->setQuery($q);
$virtuemart_paymentmethod_id = $db->loadResult();

if(!is_null($virtuemart_paymentmethod_id))
	{
	$method = $this->getVmPluginMethod($virtuemart_paymentmethod_id);
	
	##rest
	$method->ssc_short_cut_cart=0;
	if($method->ssc_short_cut_cart == '1')
		{
		$productDisplay[] = $button_code;
		//echo 'Selected';
		}
	else
		{
		//echo 'Not Selected';	
		}
	
	}
else
	{
	echo 'Null';
	}

		
	$session = JFactory::getSession();

	if(is_null($session->get('session_token')))
		{
		//echo 'Session Token is null<br/>';
		}
	else
		{
		//echo 'Session Token is reset: ' . $session_token . '<br/>';
	
		$session->set('session_token', null);
		$session->set('session_PayerID', null);
		}

		return TRUE;
	}


	function plgVmDisplayLogin2($user, &$html, $from_cart = FALSE)
		{
		$ver = VmConfig::getInstalledVersion();

		if (version_compare ($ver, '3.2.0', '>='))
			{
			return null;
			}
			
		$template = JFactory::getApplication()->getTemplate();	
		
		if($template == 'yootheme')
			{
			return null;	
			}
		
		//$html .= '***Display the Login***1';
		// only to display it in the cart, not in list orders view
		if (!$from_cart)
			{
			return NULL;
			}
					
		$vendorId = 1;
		if (!class_exists('VirtueMartCart'))
			{
			require(JPATH_VM_SITE . '/' . 'helpers' . '/' . 'cart.php'); // xx JPATH_VM_SITE
			}

		$cart = VirtueMartCart::getCart();
		if ($this->getPluginMethods($cart->vendorId) === 0)
			{
			return FALSE;
			}
		
		//if ($cart->pricesUnformatted['salesPrice'] <= 0.0)
		if (isset($cart->pricesUnformatted['salesPrice']) && $cart->pricesUnformatted['salesPrice'] <= 0.0)
			{
			return FALSE;
			}
			
		if (!isset($cart->pricesUnformatted['salesPrice']))
			{
			return FALSE;
			}			
			
		
		if (!($this->_currentMethod = $this->getVmPluginMethod($cart->virtuemart_paymentmethod_id)))
			{
			return NULL;
			}

		//$html .= '***Display the Login***2';
		
		$html = $this->html_code();

	}


function html_code()
{

$html='';

$css= "<style>
	//span.vmpayment_name + * + h3
	//{
	//width:100%;
	//opacity:0.0;
	//filter:alpha(opacity=0);
	//display:none
	//}

	//span.vmpayment_name + * + h3 + *
	//{
	//width:100%;
	//opacity:0.0;
	//filter:alpha(opacity=0);
	//display:none
	//}

	//input[name=virtuemart_paymentmethod_id]
	//{
	//width:100%;
	//opacity:0.0;
	//filter:alpha(opacity=0);
	//display:none
	//}

form#com-form-login
{
width:100%;
opacity:0.0;
filter:alpha(opacity=0);
display:none
}

</style>
";

/*
$session = JFactory::getSession();

$new_price = 0;

if($session->get('session_ssc_total') != $cart->pricesUnformatted["billTotal"])
	{
	$new_price = 1;
	$session->set('session_ssc_total', $cart->pricesUnformatted["billTotal"]);
	}

if($new_price) echo 'New Price: ' . $cart->pricesUnformatted["billTotal"] . '<br/>';
*/		

/*
		<fieldset class='vm-fieldset-tos'>
		<div  class='cart tos' >
		<span class='cart tos' >Terms of Service</span>

						<input type='hidden' name='tos' value='0' /><input class='terms-of-service'  type='checkbox' name='tos' value='1'  /><div class='terms-of-service'>
	<label for='tos'>
		<a href='/store/joomla33/index.php/vendor/virtuemart-3-sample-store/tos' class='terms-of-service' id='terms-of-service' rel='facebox'
		   target='_blank'>
			<span class='vmicon vm2-termsofservice-icon'></span>
			Click here to read terms of service and check the box to accept them.		</a>
	</label>

	<div id='full-tos'>
		<h2>Terms of service</h2>
		<h5>This is a demo store. Your orders will not proceed. You have not configured any terms of service yet. Click <a href='/store/joomla33/administrator/index.php?option=com_virtuemart&amp;view=user&amp;task=editshop'>here</a> to change this text.</h5>		</div>
</div>
			</div>
	
	</fieldset>
*/	
	
/*	
echo "<form>
<fieldset class='vm-fieldset-tos'>
<div  class='cart tos' >
<span class='cart tos' >Terms of Service</span>

<input type='hidden' name='tos' value='0' /><input class='terms-of-service'  type='checkbox' name='tos' value='1'  /><div class='terms-of-service'>
<label for='tos'>
<a href='/store/joomla33/index.php/vendor/virtuemart-3-sample-store/tos' class='terms-of-service' id='terms-of-service' rel='facebox'
target='_blank'>
<span class='vmicon vm2-termsofservice-icon'></span>
Click here to read terms of service and check the box to accept them.</a>
</label>

<div id='full-tos'>
<h2>Terms of service</h2>
<h5>This is a demo store. Your orders will not proceed. You have not configured any terms of service yet. Click <a href='/store/joomla33/administrator/index.php?option=com_virtuemart&amp;view=user&amp;task=editshop'>here</a> to change this text.</h5>		</div>
</div>
</div>
	
</fieldset>

<div class='checkout-button-top'> <button type='submit'  id='checkoutFormSubmit' name='checkout' value='1' class='vm-button-correct' ><span>Check Out Now</span> </button></div>

<input type='hidden' name='order_language' value='en-GB'/>
<input type='hidden' name='task' value='updatecart'/>
<input type='hidden' name='option' value='com_virtuemart'/>
<input type='hidden' name='view' value='cart'/>
</form>";
*/
		
		
if($this->get_cookie('c') == '1')
	{
	$html .= '<br/><p><font face="Arial" size="5" color="#FF0000"><b style="background-color: #FFFFFF">' . JText::_('VMPAYMENT_PPC_SSC_YOUR_ORDER_IS_NOT_YET_COMPLETE') . '</b></font></p>';
	$html .= '<br/><p><font face="Arial" size="4" color="#008080"><b style="background-color: #FFFFFF">' . JText::_('VMPAYMENT_PPC_SSC_REVIEW_YOUR_ORDER_DETAILS') . '</b></font></p><br/>';
	
	$html .= "<script language=\"javascript\">";
	$html .= "document.cookie = \"c=0;path=/\";";
	$html .= "document.cookie = \"ceco=1;path=/\";";
	$html .= "</script>" . $css;
	}	
elseif($this->get_cookie('ceco') == '1' && $this->get_cookie('ssc_checkout') == '1')
	{
	$html .= '<br/><p><font face="Arial" size="5" color="#FF0000"><b style="background-color: #FFFFFF">' . JText::_('VMPAYMENT_PPC_SSC_YOUR_ORDER_IS_NOT_YET_COMPLETE') . '</b></font></p>';
	$html .= '<br/><p><font face="Arial" size="4" color="#008080"><b style="background-color: #FFFFFF">' . JText::_('VMPAYMENT_PPC_SSC_REVIEW_YOUR_ORDER_DETAILS') . '</b></font></p><br/>';
	
	$html .= "<script language=\"javascript\">";
	$html .= "document.cookie = \"c=0;path=/\";";
	$html .= "document.cookie = \"ceco=1;path=/\";";
	$html .= "</script>" . $css;
	}	
else
	{
	$html .= "<script language=\"javascript\">";
	$html .= "document.cookie = \"ceco=0;path=/\";";
	$html .= "</script>";
	}

return $html;


}





function onAfterRender()
	{


	$db = JFactory::getDbo();

	$q = 'SELECT `virtuemart_paymentmethod_id` FROM `#__virtuemart_paymentmethods` WHERE `payment_element` = "paypalcheckoutssc" AND `published` = 1';
	$db->setQuery($q);
	$virtuemart_paymentmethod_id = $db->loadResult();
	$method = $this->getVmPluginMethod($virtuemart_paymentmethod_id);
	
	
	if (!$this->selectedThisElement($method->payment_element))
		{
		return false;
		}


	$input = new JInput;
	$name = $input->get('view', '', '');

	if($name != 'cart')
		{
		return NULL;
		}
	

	//$name = $input->get('task', '', '');
	
	//if($name != 'updatecart' && $name != '')
	//	{
//		return NULL;
	//	}
		
	//$body = JResponse::getBody();
	$body = JFactory::getApplication()->getBody();
	$new_body = $body;

	$str = '/<span class="vmpayment_name">/';
	
	$replace = '<span class="vmpayment_name notranslate">';
	
	$new_body = preg_replace($str, $replace, $new_body);
	
	
	$str = '/\$\(\'input\[name="task"\]\'\)\.val\("updateCartNoMethods"\);/';
	
	$replace = '$(\'input[name="task"]\').val("updatecart");';
	
	$new_body = preg_replace($str, $replace, $new_body);
	
	
	//$str = '/<input class="terms-of-service required"/';
	
	//$replace = '<input class="terms-of-service"';
	
	//$new_body = preg_replace($str, $replace, $new_body);
	
	
	//$str = '/id="checkoutForm"/';
	
	//$replace = ' onsubmit = \'alert(1); const form = event.target; fetch(form.action, { method: form.method, body: new FormData(form), }); event.preventDefault()\' id="checkoutForm"';
	
//	$new_body = preg_replace($str, $replace, $new_body);
	
	
		//$str = '/<div class="checkout-button-top">/';
		
	//$str = '/<div class="proopc-row proopc-checkout-box">/';
	
	//$replace = '<div class="checkout-button-top"><button type="button" onclick = "document.getElementById(\'checkoutFormSubmit\').click();alert(3);">Click Me</button> ';
	
//	$replace = '<button type="button" onclick = "document.getElementById(\'proopc-order-submit\').click();alert(3);">Click Me</button> <div class="proopc-row proopc-checkout-box">';
	
//	$new_body = preg_replace($str, $replace, $new_body);
	
	
	
	if($body != $new_body)
		{
		//JResponse::setBody($new_body);
		JFactory::getApplication()->setBody($new_body);
		}
	

	}


    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {
		 
		if (!$this->selectedThisByMethodId($cart->virtuemart_paymentmethod_id)) {
			return NULL; // Another method was selected, do nothing
		}

		if (!($this->_currentMethod = $this->getVmPluginMethod($cart->virtuemart_paymentmethod_id))) {
			return FALSE;
		}	 
		 
		
		$this->_ssc_payment_option  = vRequest::getVar('ssc_payment_option_' . $cart->virtuemart_paymentmethod_id, '');
		 
	 	$session = JFactory::getSession();

		//$session_token = $session->get('ssc_payment_option');

		$session->set('ssc_payment_option', $this->_ssc_payment_option);
		
		 
		return $this->OnSelectCheck($cart);
    }

    /**
     * plgVmDisplayListFEPayment
     * This event is fired to display the pluginmethods in the cart (edit shipment/payment) for exampel
     *
     * @param object $cart Cart object
     * @param integer $selected ID of the method selected
     * @return boolean True on succes, false on failures, null when this plugin was not selected.
     * On errors, J Error::raiseWarning (or J Error::raiseError) must be used to set a message.
     *
     * @author Valerie Isaksen
     * @author Max Milbers
     */
//    public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
//	return $this->displayListFE($cart, $selected, $htmlIn);
//    }


	 
	 function funding_radio_html($funding,$funding_name,$id,$selected,$alt_name='')
	 
	 {

		 
		 $checked='';
		 if($funding == $selected)
			{
			$checked = ' checked';
			}
			
			
			
		 $html = "
<div id='funding-$funding' style='display:none'>
	<label>
<table cellpadding='0' cellspacing='0' style='border-style: none; border-width: 0px'>
<tr>
<td style='border-width: 0px'>
<input type='radio' name='ssc_payment_option_$id' id='funding-$funding-radio' value='$funding' $checked onclick=\"document.getElementById('payment_id_$id').checked = true;\">
</td>
<td style='border-width: 0px'>
<span class='vmCartPaymentLogo' id='ssc-logo-$funding'></span>
</td>
<td style='border-width: 0px'>
<span class='vmpayment_name'>$funding_name</span>
</td>
</tr>
</table>
</label>
</div>
";			
			
			
			
	
		 $html = "
<div id='funding-$funding' style='display:none'>
	<label>

<input type='radio' name='ssc_payment_option_$id' id='funding-$funding-radio' value='$funding' $checked onclick=\"document.getElementById('payment_id_$id').checked = true;\">

<span class='vmCartPaymentLogo' id='ssc-logo-$funding'></span>
	
<span class='vmpayment_name'>$funding_name</span>

</label>
</div>
";
	
	 
	 
return $html;
	 }
	 
	 
	function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected, &$htmlIn) {

		return $this->displayListFE($cart, $selected, $htmlIn);



	}







    /*
     * plgVmOnSelectedCalculatePricePayment
     * Calculate the price (value, tax_id) of the selected method
     * It is called by the calculator
     * This function does NOT to be reimplemented. If not reimplemented, then the default values from this function are taken.
     * @author Valerie Isaksen
     * @cart: VirtueMartCart the current cart
     * @cart_prices: array the new cart prices
     * @return null if the method was not selected, false if the shiiping rate is not valid any more, true otherwise
     *
     *
     */

    public function plgVmOnSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name)
		{
		 
		$ver = VmConfig::getInstalledVersion();
		$arr = explode(' ',trim($ver));
		$ver = $arr[0];
		//echo $ver;

		if (version_compare ($ver, '3.7.0', '>'))
			{
		 	$cart->automaticSelectedPayment=false;
			$cart->setCartIntoSession();
			}
		 
		return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
		}

    /**
     * plgVmOnCheckAutomaticSelectedPayment
     * Checks how many plugins are available. If only one, the user will not have the choice. Enter edit_xxx page
     * The plugin must check first if it is the correct type
     * @author Valerie Isaksen
     * @param VirtueMartCart cart: the cart object
     * @return null if no plugin was found, 0 if more then one plugin was found,  virtuemart_xxx_id if only one plugin is found
     *
     */


  function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices, &$paymentCounter)
	{
			  
			  
	$ver = VmConfig::getInstalledVersion();
	$arr = explode(' ',trim($ver));
	$ver = $arr[0];
	//echo $ver;

	if (version_compare ($ver, '3.5.99', '>') && version_compare ($ver, '3.6.4', '<'))
		{
		//echo 'New';		  
	   return $this->onCheckAutomaticSelected($cart, $cart_prices, $paymentCounter);
		}

	//echo 'Old';
			  
	
	$return = $this->onCheckAutomaticSelected($cart, $cart_prices);
		if (isset($return)) {
			return 0;
		} else {
			return NULL;
		}
	}



    /**
     * This method is fired when showing the order details in the frontend.
     * It displays the method-specific data.
     *
     * @param integer $order_id The order ID
     * @return mixed Null for methods that aren't active, text (HTML) otherwise
     * @author Max Milbers
     * @author Valerie Isaksen
     */
    public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
	$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
    }

    /**
     * This event is fired during the checkout process. It can be used to validate the
     * method data as entered by the user.
     *
     * @return boolean True when the data was valid, false otherwise. If the plugin is not activated, it should return null.
     * @author Max Milbers

      public function plgVmOnCheckoutCheckDataPayment($psType, VirtueMartCart $cart) {
      return null;
      }
     */

    /**
     * This method is fired when showing when priting an Order
     * It displays the the payment method-specific data.
     *
     * @param integer $_virtuemart_order_id The order ID
     * @param integer $method_id  method used for this order
     * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
     * @author Valerie Isaksen
     */
    function plgVmonShowOrderPrintPayment($order_number, $method_id) {
	return $this->onShowOrderPrint($order_number, $method_id);
    }

    /**
     * Save updated order data to the method specific table
     *
     * @param array $_formData Form data
     * @return mixed, True on success, false on failures (the rest of the save-process will be
     * skipped!), or null when this method is not actived.
     * @author Oscar van Eijk

      public function plgVmOnUpdateOrderPayment(  $_formData) {
      return null;
      }
     */
    /**
     * Save updated orderline data to the method specific table
     *
     * @param array $_formData Form data
     * @return mixed, True on success, false on failures (the rest of the save-process will be
     * skipped!), or null when this method is not actived.
     * @author Oscar van Eijk

      public function plgVmOnUpdateOrderLine(  $_formData) {
      return null;
      }
     */
    /**
     * plgVmOnEditOrderLineBE
     * This method is fired when editing the order line details in the backend.
     * It can be used to add line specific package codes
     *
     * @param integer $_orderId The order ID
     * @param integer $_lineId
     * @return mixed Null for method that aren't active, text (HTML) otherwise
     * @author Oscar van Eijk

      public function plgVmOnEditOrderLineBE(  $_orderId, $_lineId) {
      return null;
      }
     */

    /**
     * This method is fired when showing the order details in the frontend, for every orderline.
     * It can be used to display line specific package codes, e.g. with a link to external tracking and
     * tracing systems
     *
     * @param integer $_orderId The order ID
     * @param integer $_lineId
     * @return mixed Null for method that aren't active, text (HTML) otherwise
     * @author Oscar van Eijk

      public function plgVmOnShowOrderLineFE(  $_orderId, $_lineId) {
      return null;
      }
     */
    function plgVmDeclarePluginParamsPayment($name, $id, &$data) {
	return $this->declarePluginParams('payment', $name, $id, $data);
    }

	function plgVmDeclarePluginParamsPaymentVM3( &$data) {
		return $this->declarePluginParams('payment', $data);
	}

    function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {
	return $this->setOnTablePluginParams($name, $id, $table);
    }
    
 private function table_exist($table,$debug)
	{

	if (!class_exists('JConfig'))
		require(JPATH_CONFIGURATION . '/configuration.php');
	
	$cfg = new JConfig();
	$dbname = $cfg->db;
	$dbprefix = $cfg->dbprefix;		
		
	$table = $dbprefix . $table;

	if($debug)echo $table . '<br>Table name is ' . $table . '<br><br>';
		
	$tables = JFactory::getDbo()->getTableList();
	
	//$table = 'test';
	
	if(in_array($table,$tables))
		{
		if($debug)echo '<br>Table found<br><br>';
		return true;
		}
	else
		{
		if($debug)echo '<br>Table not found<br><br>';
		return false;
		}
	}  


public function post_strings()
	{
	$postvars = array();

	foreach ($_POST as $key => $value)
		{
		$value = preg_replace('/[^a-zA-Z0-9.\-_: \/]/', '', $value);
		$postvars[$key] = $value;
		}

	return $postvars;
	}


public function get_strings()
	{
	$getvars= array();

	foreach ($_GET as $key => $value)
		{
		$value = preg_replace('/[^a-zA-Z0-9.\-_: \/]/', '', $value);
		$getvars[$key] = $value;
		}

	return $getvars;
	}


	    
 function get_cookie($name)
	{
	$value = '';
    
	if(isset($_COOKIE[$name]))
		{
    	$value = $_COOKIE[$name];
    	//$value = preg_replace('/[^a-zA-Z0-9.-]/', '', $value);
		$value = preg_replace('/[^a-zA-Z0-9.\-_: \/]/', '', $value);
    	}
    	
	return $value;
	}


}

// No closing tag
